

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2WebExtension.Interfaces.DOMNodeFilter
    ( 

-- * Exported types
    DOMNodeFilter(..)                       ,
    noDOMNodeFilter                         ,
    IsDOMNodeFilter                         ,
    toDOMNodeFilter                         ,


 -- * Methods
-- ** acceptNode #method:acceptNode#

#if ENABLE_OVERLOADING
    DOMNodeFilterAcceptNodeMethodInfo       ,
#endif
    dOMNodeFilterAcceptNode                 ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMNode as WebKit2WebExtension.DOMNode

-- interface DOMNodeFilter 
-- | Memory-managed wrapper type.
newtype DOMNodeFilter = DOMNodeFilter (ManagedPtr DOMNodeFilter)
-- | A convenience alias for `Nothing` :: `Maybe` `DOMNodeFilter`.
noDOMNodeFilter :: Maybe DOMNodeFilter
noDOMNodeFilter = Nothing

#if ENABLE_OVERLOADING
type instance O.SignalList DOMNodeFilter = DOMNodeFilterSignalList
type DOMNodeFilterSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

foreign import ccall "webkit_dom_node_filter_get_type"
    c_webkit_dom_node_filter_get_type :: IO GType

instance GObject DOMNodeFilter where
    gobjectType = c_webkit_dom_node_filter_get_type
    

-- | Type class for types which can be safely cast to `DOMNodeFilter`, for instance with `toDOMNodeFilter`.
class (GObject o, O.IsDescendantOf DOMNodeFilter o) => IsDOMNodeFilter o
instance (GObject o, O.IsDescendantOf DOMNodeFilter o) => IsDOMNodeFilter o

instance O.HasParentTypes DOMNodeFilter
type instance O.ParentTypes DOMNodeFilter = '[GObject.Object.Object]

-- | Cast to `DOMNodeFilter`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toDOMNodeFilter :: (MonadIO m, IsDOMNodeFilter o) => o -> m DOMNodeFilter
toDOMNodeFilter = liftIO . unsafeCastTo DOMNodeFilter

#if ENABLE_OVERLOADING
instance O.HasAttributeList DOMNodeFilter
type instance O.AttributeList DOMNodeFilter = DOMNodeFilterAttributeList
type DOMNodeFilterAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type family ResolveDOMNodeFilterMethod (t :: Symbol) (o :: *) :: * where
    ResolveDOMNodeFilterMethod "acceptNode" o = DOMNodeFilterAcceptNodeMethodInfo
    ResolveDOMNodeFilterMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveDOMNodeFilterMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveDOMNodeFilterMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveDOMNodeFilterMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveDOMNodeFilterMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveDOMNodeFilterMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveDOMNodeFilterMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveDOMNodeFilterMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveDOMNodeFilterMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveDOMNodeFilterMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveDOMNodeFilterMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveDOMNodeFilterMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveDOMNodeFilterMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveDOMNodeFilterMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveDOMNodeFilterMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveDOMNodeFilterMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveDOMNodeFilterMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveDOMNodeFilterMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveDOMNodeFilterMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveDOMNodeFilterMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveDOMNodeFilterMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveDOMNodeFilterMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveDOMNodeFilterMethod t DOMNodeFilter, O.MethodInfo info DOMNodeFilter p) => OL.IsLabel t (DOMNodeFilter -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- method DOMNodeFilter::accept_node
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "filter", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeFilter"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeFilter", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "node", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNode", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TInt16)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_node_filter_accept_node" webkit_dom_node_filter_accept_node :: 
    Ptr DOMNodeFilter ->                    -- filter : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeFilter"})
    Ptr WebKit2WebExtension.DOMNode.DOMNode -> -- node : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"})
    IO Int16

{-# DEPRECATED dOMNodeFilterAcceptNode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMNodeFilterAcceptNode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMNodeFilter a, WebKit2WebExtension.DOMNode.IsDOMNode b) =>
    a
    {- ^ /@filter@/: A 'GI.WebKit2WebExtension.Interfaces.DOMNodeFilter.DOMNodeFilter' -}
    -> b
    {- ^ /@node@/: A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' -}
    -> m Int16
    {- ^ __Returns:__ a @/gshort/@ -}
dOMNodeFilterAcceptNode filter node = liftIO $ do
    filter' <- unsafeManagedPtrCastPtr filter
    node' <- unsafeManagedPtrCastPtr node
    result <- webkit_dom_node_filter_accept_node filter' node'
    touchManagedPtr filter
    touchManagedPtr node
    return result

#if ENABLE_OVERLOADING
data DOMNodeFilterAcceptNodeMethodInfo
instance (signature ~ (b -> m Int16), MonadIO m, IsDOMNodeFilter a, WebKit2WebExtension.DOMNode.IsDOMNode b) => O.MethodInfo DOMNodeFilterAcceptNodeMethodInfo a signature where
    overloadedMethod _ = dOMNodeFilterAcceptNode

#endif


