

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2WebExtension.Interfaces.DOMXPathNSResolver
    ( 

-- * Exported types
    DOMXPathNSResolver(..)                  ,
    noDOMXPathNSResolver                    ,
    IsDOMXPathNSResolver                    ,
    toDOMXPathNSResolver                    ,


 -- * Methods
-- ** lookupNamespaceUri #method:lookupNamespaceUri#

#if ENABLE_OVERLOADING
    DOMXPathNSResolverLookupNamespaceUriMethodInfo,
#endif
    dOMXPathNSResolverLookupNamespaceUri    ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object

-- interface DOMXPathNSResolver 
-- | Memory-managed wrapper type.
newtype DOMXPathNSResolver = DOMXPathNSResolver (ManagedPtr DOMXPathNSResolver)
-- | A convenience alias for `Nothing` :: `Maybe` `DOMXPathNSResolver`.
noDOMXPathNSResolver :: Maybe DOMXPathNSResolver
noDOMXPathNSResolver = Nothing

#if ENABLE_OVERLOADING
type instance O.SignalList DOMXPathNSResolver = DOMXPathNSResolverSignalList
type DOMXPathNSResolverSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

foreign import ccall "webkit_dom_xpath_ns_resolver_get_type"
    c_webkit_dom_xpath_ns_resolver_get_type :: IO GType

instance GObject DOMXPathNSResolver where
    gobjectType = c_webkit_dom_xpath_ns_resolver_get_type
    

-- | Type class for types which can be safely cast to `DOMXPathNSResolver`, for instance with `toDOMXPathNSResolver`.
class (GObject o, O.IsDescendantOf DOMXPathNSResolver o) => IsDOMXPathNSResolver o
instance (GObject o, O.IsDescendantOf DOMXPathNSResolver o) => IsDOMXPathNSResolver o

instance O.HasParentTypes DOMXPathNSResolver
type instance O.ParentTypes DOMXPathNSResolver = '[GObject.Object.Object]

-- | Cast to `DOMXPathNSResolver`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toDOMXPathNSResolver :: (MonadIO m, IsDOMXPathNSResolver o) => o -> m DOMXPathNSResolver
toDOMXPathNSResolver = liftIO . unsafeCastTo DOMXPathNSResolver

#if ENABLE_OVERLOADING
instance O.HasAttributeList DOMXPathNSResolver
type instance O.AttributeList DOMXPathNSResolver = DOMXPathNSResolverAttributeList
type DOMXPathNSResolverAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type family ResolveDOMXPathNSResolverMethod (t :: Symbol) (o :: *) :: * where
    ResolveDOMXPathNSResolverMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveDOMXPathNSResolverMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveDOMXPathNSResolverMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveDOMXPathNSResolverMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveDOMXPathNSResolverMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveDOMXPathNSResolverMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveDOMXPathNSResolverMethod "lookupNamespaceUri" o = DOMXPathNSResolverLookupNamespaceUriMethodInfo
    ResolveDOMXPathNSResolverMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveDOMXPathNSResolverMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveDOMXPathNSResolverMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveDOMXPathNSResolverMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveDOMXPathNSResolverMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveDOMXPathNSResolverMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveDOMXPathNSResolverMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveDOMXPathNSResolverMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveDOMXPathNSResolverMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveDOMXPathNSResolverMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveDOMXPathNSResolverMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveDOMXPathNSResolverMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveDOMXPathNSResolverMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveDOMXPathNSResolverMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveDOMXPathNSResolverMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveDOMXPathNSResolverMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveDOMXPathNSResolverMethod t DOMXPathNSResolver, O.MethodInfo info DOMXPathNSResolver p) => OL.IsLabel t (DOMXPathNSResolver -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- method DOMXPathNSResolver::lookup_namespace_uri
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "resolver", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathNSResolver"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMXPathNSResolver", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "prefix", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "The prefix to lookup", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_xpath_ns_resolver_lookup_namespace_uri" webkit_dom_xpath_ns_resolver_lookup_namespace_uri :: 
    Ptr DOMXPathNSResolver ->               -- resolver : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathNSResolver"})
    CString ->                              -- prefix : TBasicType TUTF8
    IO CString

{-# DEPRECATED dOMXPathNSResolverLookupNamespaceUri ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMXPathNSResolverLookupNamespaceUri ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMXPathNSResolver a) =>
    a
    {- ^ /@resolver@/: A 'GI.WebKit2WebExtension.Interfaces.DOMXPathNSResolver.DOMXPathNSResolver' -}
    -> T.Text
    {- ^ /@prefix@/: The prefix to lookup -}
    -> m T.Text
    {- ^ __Returns:__ a @/gchar/@ -}
dOMXPathNSResolverLookupNamespaceUri resolver prefix = liftIO $ do
    resolver' <- unsafeManagedPtrCastPtr resolver
    prefix' <- textToCString prefix
    result <- webkit_dom_xpath_ns_resolver_lookup_namespace_uri resolver' prefix'
    checkUnexpectedReturnNULL "dOMXPathNSResolverLookupNamespaceUri" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr resolver
    freeMem prefix'
    return result'

#if ENABLE_OVERLOADING
data DOMXPathNSResolverLookupNamespaceUriMethodInfo
instance (signature ~ (T.Text -> m T.Text), MonadIO m, IsDOMXPathNSResolver a) => O.MethodInfo DOMXPathNSResolverLookupNamespaceUriMethodInfo a signature where
    overloadedMethod _ = dOMXPathNSResolverLookupNamespaceUri

#endif


