

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2WebExtension.Objects.DOMDocumentType
    ( 

-- * Exported types
    DOMDocumentType(..)                     ,
    IsDOMDocumentType                       ,
    toDOMDocumentType                       ,
    noDOMDocumentType                       ,


 -- * Methods
-- ** getEntities #method:getEntities#

#if ENABLE_OVERLOADING
    DOMDocumentTypeGetEntitiesMethodInfo    ,
#endif
    dOMDocumentTypeGetEntities              ,


-- ** getInternalSubset #method:getInternalSubset#

#if ENABLE_OVERLOADING
    DOMDocumentTypeGetInternalSubsetMethodInfo,
#endif
    dOMDocumentTypeGetInternalSubset        ,


-- ** getName #method:getName#

#if ENABLE_OVERLOADING
    DOMDocumentTypeGetNameMethodInfo        ,
#endif
    dOMDocumentTypeGetName                  ,


-- ** getNotations #method:getNotations#

#if ENABLE_OVERLOADING
    DOMDocumentTypeGetNotationsMethodInfo   ,
#endif
    dOMDocumentTypeGetNotations             ,


-- ** getPublicId #method:getPublicId#

#if ENABLE_OVERLOADING
    DOMDocumentTypeGetPublicIdMethodInfo    ,
#endif
    dOMDocumentTypeGetPublicId              ,


-- ** getSystemId #method:getSystemId#

#if ENABLE_OVERLOADING
    DOMDocumentTypeGetSystemIdMethodInfo    ,
#endif
    dOMDocumentTypeGetSystemId              ,




 -- * Properties
-- ** entities #attr:entities#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentTypeEntitiesPropertyInfo     ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentTypeEntities                 ,
#endif
    getDOMDocumentTypeEntities              ,


-- ** internalSubset #attr:internalSubset#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentTypeInternalSubsetPropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentTypeInternalSubset           ,
#endif
    getDOMDocumentTypeInternalSubset        ,


-- ** name #attr:name#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentTypeNamePropertyInfo         ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentTypeName                     ,
#endif
    getDOMDocumentTypeName                  ,


-- ** notations #attr:notations#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentTypeNotationsPropertyInfo    ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentTypeNotations                ,
#endif
    getDOMDocumentTypeNotations             ,


-- ** publicId #attr:publicId#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentTypePublicIdPropertyInfo     ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentTypePublicId                 ,
#endif
    getDOMDocumentTypePublicId              ,


-- ** systemId #attr:systemId#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentTypeSystemIdPropertyInfo     ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentTypeSystemId                 ,
#endif
    getDOMDocumentTypeSystemId              ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Interfaces.DOMEventTarget as WebKit2WebExtension.DOMEventTarget
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMNamedNodeMap as WebKit2WebExtension.DOMNamedNodeMap
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMNode as WebKit2WebExtension.DOMNode
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMObject as WebKit2WebExtension.DOMObject

-- | Memory-managed wrapper type.
newtype DOMDocumentType = DOMDocumentType (ManagedPtr DOMDocumentType)
foreign import ccall "webkit_dom_document_type_get_type"
    c_webkit_dom_document_type_get_type :: IO GType

instance GObject DOMDocumentType where
    gobjectType = c_webkit_dom_document_type_get_type
    

-- | Type class for types which can be safely cast to `DOMDocumentType`, for instance with `toDOMDocumentType`.
class (GObject o, O.IsDescendantOf DOMDocumentType o) => IsDOMDocumentType o
instance (GObject o, O.IsDescendantOf DOMDocumentType o) => IsDOMDocumentType o

instance O.HasParentTypes DOMDocumentType
type instance O.ParentTypes DOMDocumentType = '[WebKit2WebExtension.DOMNode.DOMNode, WebKit2WebExtension.DOMObject.DOMObject, GObject.Object.Object, WebKit2WebExtension.DOMEventTarget.DOMEventTarget]

-- | Cast to `DOMDocumentType`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toDOMDocumentType :: (MonadIO m, IsDOMDocumentType o) => o -> m DOMDocumentType
toDOMDocumentType = liftIO . unsafeCastTo DOMDocumentType

-- | A convenience alias for `Nothing` :: `Maybe` `DOMDocumentType`.
noDOMDocumentType :: Maybe DOMDocumentType
noDOMDocumentType = Nothing

#if ENABLE_OVERLOADING
type family ResolveDOMDocumentTypeMethod (t :: Symbol) (o :: *) :: * where
    ResolveDOMDocumentTypeMethod "addEventListener" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetAddEventListenerMethodInfo
    ResolveDOMDocumentTypeMethod "appendChild" o = WebKit2WebExtension.DOMNode.DOMNodeAppendChildMethodInfo
    ResolveDOMDocumentTypeMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveDOMDocumentTypeMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveDOMDocumentTypeMethod "cloneNodeWithError" o = WebKit2WebExtension.DOMNode.DOMNodeCloneNodeWithErrorMethodInfo
    ResolveDOMDocumentTypeMethod "compareDocumentPosition" o = WebKit2WebExtension.DOMNode.DOMNodeCompareDocumentPositionMethodInfo
    ResolveDOMDocumentTypeMethod "contains" o = WebKit2WebExtension.DOMNode.DOMNodeContainsMethodInfo
    ResolveDOMDocumentTypeMethod "dispatchEvent" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetDispatchEventMethodInfo
    ResolveDOMDocumentTypeMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveDOMDocumentTypeMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveDOMDocumentTypeMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveDOMDocumentTypeMethod "hasChildNodes" o = WebKit2WebExtension.DOMNode.DOMNodeHasChildNodesMethodInfo
    ResolveDOMDocumentTypeMethod "insertBefore" o = WebKit2WebExtension.DOMNode.DOMNodeInsertBeforeMethodInfo
    ResolveDOMDocumentTypeMethod "isDefaultNamespace" o = WebKit2WebExtension.DOMNode.DOMNodeIsDefaultNamespaceMethodInfo
    ResolveDOMDocumentTypeMethod "isEqualNode" o = WebKit2WebExtension.DOMNode.DOMNodeIsEqualNodeMethodInfo
    ResolveDOMDocumentTypeMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveDOMDocumentTypeMethod "isSameNode" o = WebKit2WebExtension.DOMNode.DOMNodeIsSameNodeMethodInfo
    ResolveDOMDocumentTypeMethod "isSupported" o = WebKit2WebExtension.DOMNode.DOMNodeIsSupportedMethodInfo
    ResolveDOMDocumentTypeMethod "lookupNamespaceUri" o = WebKit2WebExtension.DOMNode.DOMNodeLookupNamespaceUriMethodInfo
    ResolveDOMDocumentTypeMethod "lookupPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeLookupPrefixMethodInfo
    ResolveDOMDocumentTypeMethod "normalize" o = WebKit2WebExtension.DOMNode.DOMNodeNormalizeMethodInfo
    ResolveDOMDocumentTypeMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveDOMDocumentTypeMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveDOMDocumentTypeMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveDOMDocumentTypeMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveDOMDocumentTypeMethod "removeChild" o = WebKit2WebExtension.DOMNode.DOMNodeRemoveChildMethodInfo
    ResolveDOMDocumentTypeMethod "removeEventListener" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetRemoveEventListenerMethodInfo
    ResolveDOMDocumentTypeMethod "replaceChild" o = WebKit2WebExtension.DOMNode.DOMNodeReplaceChildMethodInfo
    ResolveDOMDocumentTypeMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveDOMDocumentTypeMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveDOMDocumentTypeMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveDOMDocumentTypeMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveDOMDocumentTypeMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveDOMDocumentTypeMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveDOMDocumentTypeMethod "getBaseUri" o = WebKit2WebExtension.DOMNode.DOMNodeGetBaseUriMethodInfo
    ResolveDOMDocumentTypeMethod "getChildNodes" o = WebKit2WebExtension.DOMNode.DOMNodeGetChildNodesMethodInfo
    ResolveDOMDocumentTypeMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveDOMDocumentTypeMethod "getEntities" o = DOMDocumentTypeGetEntitiesMethodInfo
    ResolveDOMDocumentTypeMethod "getFirstChild" o = WebKit2WebExtension.DOMNode.DOMNodeGetFirstChildMethodInfo
    ResolveDOMDocumentTypeMethod "getInternalSubset" o = DOMDocumentTypeGetInternalSubsetMethodInfo
    ResolveDOMDocumentTypeMethod "getLastChild" o = WebKit2WebExtension.DOMNode.DOMNodeGetLastChildMethodInfo
    ResolveDOMDocumentTypeMethod "getLocalName" o = WebKit2WebExtension.DOMNode.DOMNodeGetLocalNameMethodInfo
    ResolveDOMDocumentTypeMethod "getName" o = DOMDocumentTypeGetNameMethodInfo
    ResolveDOMDocumentTypeMethod "getNamespaceUri" o = WebKit2WebExtension.DOMNode.DOMNodeGetNamespaceUriMethodInfo
    ResolveDOMDocumentTypeMethod "getNextSibling" o = WebKit2WebExtension.DOMNode.DOMNodeGetNextSiblingMethodInfo
    ResolveDOMDocumentTypeMethod "getNodeName" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeNameMethodInfo
    ResolveDOMDocumentTypeMethod "getNodeType" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeTypeMethodInfo
    ResolveDOMDocumentTypeMethod "getNodeValue" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeValueMethodInfo
    ResolveDOMDocumentTypeMethod "getNotations" o = DOMDocumentTypeGetNotationsMethodInfo
    ResolveDOMDocumentTypeMethod "getOwnerDocument" o = WebKit2WebExtension.DOMNode.DOMNodeGetOwnerDocumentMethodInfo
    ResolveDOMDocumentTypeMethod "getParentElement" o = WebKit2WebExtension.DOMNode.DOMNodeGetParentElementMethodInfo
    ResolveDOMDocumentTypeMethod "getParentNode" o = WebKit2WebExtension.DOMNode.DOMNodeGetParentNodeMethodInfo
    ResolveDOMDocumentTypeMethod "getPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeGetPrefixMethodInfo
    ResolveDOMDocumentTypeMethod "getPreviousSibling" o = WebKit2WebExtension.DOMNode.DOMNodeGetPreviousSiblingMethodInfo
    ResolveDOMDocumentTypeMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveDOMDocumentTypeMethod "getPublicId" o = DOMDocumentTypeGetPublicIdMethodInfo
    ResolveDOMDocumentTypeMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveDOMDocumentTypeMethod "getSystemId" o = DOMDocumentTypeGetSystemIdMethodInfo
    ResolveDOMDocumentTypeMethod "getTextContent" o = WebKit2WebExtension.DOMNode.DOMNodeGetTextContentMethodInfo
    ResolveDOMDocumentTypeMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveDOMDocumentTypeMethod "setNodeValue" o = WebKit2WebExtension.DOMNode.DOMNodeSetNodeValueMethodInfo
    ResolveDOMDocumentTypeMethod "setPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeSetPrefixMethodInfo
    ResolveDOMDocumentTypeMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveDOMDocumentTypeMethod "setTextContent" o = WebKit2WebExtension.DOMNode.DOMNodeSetTextContentMethodInfo
    ResolveDOMDocumentTypeMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveDOMDocumentTypeMethod t DOMDocumentType, O.MethodInfo info DOMDocumentType p) => OL.IsLabel t (DOMDocumentType -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "entities"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNamedNodeMap"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@entities@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocumentType #entities
@
-}
getDOMDocumentTypeEntities :: (MonadIO m, IsDOMDocumentType o) => o -> m (Maybe WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap)
getDOMDocumentTypeEntities obj = liftIO $ B.Properties.getObjectPropertyObject obj "entities" WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap

#if ENABLE_OVERLOADING
data DOMDocumentTypeEntitiesPropertyInfo
instance AttrInfo DOMDocumentTypeEntitiesPropertyInfo where
    type AttrAllowedOps DOMDocumentTypeEntitiesPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentTypeEntitiesPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentTypeEntitiesPropertyInfo = IsDOMDocumentType
    type AttrGetType DOMDocumentTypeEntitiesPropertyInfo = (Maybe WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap)
    type AttrLabel DOMDocumentTypeEntitiesPropertyInfo = "entities"
    type AttrOrigin DOMDocumentTypeEntitiesPropertyInfo = DOMDocumentType
    attrGet _ = getDOMDocumentTypeEntities
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "internal-subset"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@internal-subset@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocumentType #internalSubset
@
-}
getDOMDocumentTypeInternalSubset :: (MonadIO m, IsDOMDocumentType o) => o -> m (Maybe T.Text)
getDOMDocumentTypeInternalSubset obj = liftIO $ B.Properties.getObjectPropertyString obj "internal-subset"

#if ENABLE_OVERLOADING
data DOMDocumentTypeInternalSubsetPropertyInfo
instance AttrInfo DOMDocumentTypeInternalSubsetPropertyInfo where
    type AttrAllowedOps DOMDocumentTypeInternalSubsetPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentTypeInternalSubsetPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentTypeInternalSubsetPropertyInfo = IsDOMDocumentType
    type AttrGetType DOMDocumentTypeInternalSubsetPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentTypeInternalSubsetPropertyInfo = "internal-subset"
    type AttrOrigin DOMDocumentTypeInternalSubsetPropertyInfo = DOMDocumentType
    attrGet _ = getDOMDocumentTypeInternalSubset
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@name@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocumentType #name
@
-}
getDOMDocumentTypeName :: (MonadIO m, IsDOMDocumentType o) => o -> m (Maybe T.Text)
getDOMDocumentTypeName obj = liftIO $ B.Properties.getObjectPropertyString obj "name"

#if ENABLE_OVERLOADING
data DOMDocumentTypeNamePropertyInfo
instance AttrInfo DOMDocumentTypeNamePropertyInfo where
    type AttrAllowedOps DOMDocumentTypeNamePropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentTypeNamePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentTypeNamePropertyInfo = IsDOMDocumentType
    type AttrGetType DOMDocumentTypeNamePropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentTypeNamePropertyInfo = "name"
    type AttrOrigin DOMDocumentTypeNamePropertyInfo = DOMDocumentType
    attrGet _ = getDOMDocumentTypeName
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "notations"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNamedNodeMap"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@notations@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocumentType #notations
@
-}
getDOMDocumentTypeNotations :: (MonadIO m, IsDOMDocumentType o) => o -> m (Maybe WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap)
getDOMDocumentTypeNotations obj = liftIO $ B.Properties.getObjectPropertyObject obj "notations" WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap

#if ENABLE_OVERLOADING
data DOMDocumentTypeNotationsPropertyInfo
instance AttrInfo DOMDocumentTypeNotationsPropertyInfo where
    type AttrAllowedOps DOMDocumentTypeNotationsPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentTypeNotationsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentTypeNotationsPropertyInfo = IsDOMDocumentType
    type AttrGetType DOMDocumentTypeNotationsPropertyInfo = (Maybe WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap)
    type AttrLabel DOMDocumentTypeNotationsPropertyInfo = "notations"
    type AttrOrigin DOMDocumentTypeNotationsPropertyInfo = DOMDocumentType
    attrGet _ = getDOMDocumentTypeNotations
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "public-id"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@public-id@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocumentType #publicId
@
-}
getDOMDocumentTypePublicId :: (MonadIO m, IsDOMDocumentType o) => o -> m (Maybe T.Text)
getDOMDocumentTypePublicId obj = liftIO $ B.Properties.getObjectPropertyString obj "public-id"

#if ENABLE_OVERLOADING
data DOMDocumentTypePublicIdPropertyInfo
instance AttrInfo DOMDocumentTypePublicIdPropertyInfo where
    type AttrAllowedOps DOMDocumentTypePublicIdPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentTypePublicIdPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentTypePublicIdPropertyInfo = IsDOMDocumentType
    type AttrGetType DOMDocumentTypePublicIdPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentTypePublicIdPropertyInfo = "public-id"
    type AttrOrigin DOMDocumentTypePublicIdPropertyInfo = DOMDocumentType
    attrGet _ = getDOMDocumentTypePublicId
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "system-id"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@system-id@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocumentType #systemId
@
-}
getDOMDocumentTypeSystemId :: (MonadIO m, IsDOMDocumentType o) => o -> m (Maybe T.Text)
getDOMDocumentTypeSystemId obj = liftIO $ B.Properties.getObjectPropertyString obj "system-id"

#if ENABLE_OVERLOADING
data DOMDocumentTypeSystemIdPropertyInfo
instance AttrInfo DOMDocumentTypeSystemIdPropertyInfo where
    type AttrAllowedOps DOMDocumentTypeSystemIdPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentTypeSystemIdPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentTypeSystemIdPropertyInfo = IsDOMDocumentType
    type AttrGetType DOMDocumentTypeSystemIdPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentTypeSystemIdPropertyInfo = "system-id"
    type AttrOrigin DOMDocumentTypeSystemIdPropertyInfo = DOMDocumentType
    attrGet _ = getDOMDocumentTypeSystemId
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList DOMDocumentType
type instance O.AttributeList DOMDocumentType = DOMDocumentTypeAttributeList
type DOMDocumentTypeAttributeList = ('[ '("baseUri", WebKit2WebExtension.DOMNode.DOMNodeBaseUriPropertyInfo), '("childNodes", WebKit2WebExtension.DOMNode.DOMNodeChildNodesPropertyInfo), '("coreObject", WebKit2WebExtension.DOMObject.DOMObjectCoreObjectPropertyInfo), '("entities", DOMDocumentTypeEntitiesPropertyInfo), '("firstChild", WebKit2WebExtension.DOMNode.DOMNodeFirstChildPropertyInfo), '("internalSubset", DOMDocumentTypeInternalSubsetPropertyInfo), '("lastChild", WebKit2WebExtension.DOMNode.DOMNodeLastChildPropertyInfo), '("name", DOMDocumentTypeNamePropertyInfo), '("nextSibling", WebKit2WebExtension.DOMNode.DOMNodeNextSiblingPropertyInfo), '("nodeName", WebKit2WebExtension.DOMNode.DOMNodeNodeNamePropertyInfo), '("nodeType", WebKit2WebExtension.DOMNode.DOMNodeNodeTypePropertyInfo), '("nodeValue", WebKit2WebExtension.DOMNode.DOMNodeNodeValuePropertyInfo), '("notations", DOMDocumentTypeNotationsPropertyInfo), '("ownerDocument", WebKit2WebExtension.DOMNode.DOMNodeOwnerDocumentPropertyInfo), '("parentElement", WebKit2WebExtension.DOMNode.DOMNodeParentElementPropertyInfo), '("parentNode", WebKit2WebExtension.DOMNode.DOMNodeParentNodePropertyInfo), '("previousSibling", WebKit2WebExtension.DOMNode.DOMNodePreviousSiblingPropertyInfo), '("publicId", DOMDocumentTypePublicIdPropertyInfo), '("systemId", DOMDocumentTypeSystemIdPropertyInfo), '("textContent", WebKit2WebExtension.DOMNode.DOMNodeTextContentPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
dOMDocumentTypeEntities :: AttrLabelProxy "entities"
dOMDocumentTypeEntities = AttrLabelProxy

dOMDocumentTypeInternalSubset :: AttrLabelProxy "internalSubset"
dOMDocumentTypeInternalSubset = AttrLabelProxy

dOMDocumentTypeName :: AttrLabelProxy "name"
dOMDocumentTypeName = AttrLabelProxy

dOMDocumentTypeNotations :: AttrLabelProxy "notations"
dOMDocumentTypeNotations = AttrLabelProxy

dOMDocumentTypePublicId :: AttrLabelProxy "publicId"
dOMDocumentTypePublicId = AttrLabelProxy

dOMDocumentTypeSystemId :: AttrLabelProxy "systemId"
dOMDocumentTypeSystemId = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList DOMDocumentType = DOMDocumentTypeSignalList
type DOMDocumentTypeSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

-- method DOMDocumentType::get_entities
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocumentType", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNamedNodeMap"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_type_get_entities" webkit_dom_document_type_get_entities :: 
    Ptr DOMDocumentType ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"})
    IO (Ptr WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap)

{-# DEPRECATED dOMDocumentTypeGetEntities ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentTypeGetEntities ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocumentType a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocumentType.DOMDocumentType' -}
    -> m WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNamedNodeMap.DOMNamedNodeMap' -}
dOMDocumentTypeGetEntities self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_type_get_entities self'
    checkUnexpectedReturnNULL "dOMDocumentTypeGetEntities" result
    result' <- (wrapObject WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentTypeGetEntitiesMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap), MonadIO m, IsDOMDocumentType a) => O.MethodInfo DOMDocumentTypeGetEntitiesMethodInfo a signature where
    overloadedMethod _ = dOMDocumentTypeGetEntities

#endif

-- method DOMDocumentType::get_internal_subset
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocumentType", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_type_get_internal_subset" webkit_dom_document_type_get_internal_subset :: 
    Ptr DOMDocumentType ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"})
    IO CString

{-# DEPRECATED dOMDocumentTypeGetInternalSubset ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentTypeGetInternalSubset ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocumentType a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocumentType.DOMDocumentType' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentTypeGetInternalSubset self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_type_get_internal_subset self'
    checkUnexpectedReturnNULL "dOMDocumentTypeGetInternalSubset" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentTypeGetInternalSubsetMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocumentType a) => O.MethodInfo DOMDocumentTypeGetInternalSubsetMethodInfo a signature where
    overloadedMethod _ = dOMDocumentTypeGetInternalSubset

#endif

-- method DOMDocumentType::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocumentType", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_type_get_name" webkit_dom_document_type_get_name :: 
    Ptr DOMDocumentType ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"})
    IO CString

{-# DEPRECATED dOMDocumentTypeGetName ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentTypeGetName ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocumentType a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocumentType.DOMDocumentType' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentTypeGetName self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_type_get_name self'
    checkUnexpectedReturnNULL "dOMDocumentTypeGetName" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentTypeGetNameMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocumentType a) => O.MethodInfo DOMDocumentTypeGetNameMethodInfo a signature where
    overloadedMethod _ = dOMDocumentTypeGetName

#endif

-- method DOMDocumentType::get_notations
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocumentType", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNamedNodeMap"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_type_get_notations" webkit_dom_document_type_get_notations :: 
    Ptr DOMDocumentType ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"})
    IO (Ptr WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap)

{-# DEPRECATED dOMDocumentTypeGetNotations ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentTypeGetNotations ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocumentType a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocumentType.DOMDocumentType' -}
    -> m WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNamedNodeMap.DOMNamedNodeMap' -}
dOMDocumentTypeGetNotations self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_type_get_notations self'
    checkUnexpectedReturnNULL "dOMDocumentTypeGetNotations" result
    result' <- (wrapObject WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentTypeGetNotationsMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMNamedNodeMap.DOMNamedNodeMap), MonadIO m, IsDOMDocumentType a) => O.MethodInfo DOMDocumentTypeGetNotationsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentTypeGetNotations

#endif

-- method DOMDocumentType::get_public_id
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocumentType", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_type_get_public_id" webkit_dom_document_type_get_public_id :: 
    Ptr DOMDocumentType ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"})
    IO CString

{-# DEPRECATED dOMDocumentTypeGetPublicId ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentTypeGetPublicId ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocumentType a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocumentType.DOMDocumentType' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentTypeGetPublicId self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_type_get_public_id self'
    checkUnexpectedReturnNULL "dOMDocumentTypeGetPublicId" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentTypeGetPublicIdMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocumentType a) => O.MethodInfo DOMDocumentTypeGetPublicIdMethodInfo a signature where
    overloadedMethod _ = dOMDocumentTypeGetPublicId

#endif

-- method DOMDocumentType::get_system_id
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocumentType", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_type_get_system_id" webkit_dom_document_type_get_system_id :: 
    Ptr DOMDocumentType ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"})
    IO CString

{-# DEPRECATED dOMDocumentTypeGetSystemId ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentTypeGetSystemId ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocumentType a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocumentType.DOMDocumentType' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentTypeGetSystemId self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_type_get_system_id self'
    checkUnexpectedReturnNULL "dOMDocumentTypeGetSystemId" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentTypeGetSystemIdMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocumentType a) => O.MethodInfo DOMDocumentTypeGetSystemIdMethodInfo a signature where
    overloadedMethod _ = dOMDocumentTypeGetSystemId

#endif


