#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))
module GI.WebKit2WebExtension.Objects.DOMElement where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

newtype DOMElement = DOMElement (ManagedPtr DOMElement)
instance GObject DOMElement where
class (GObject o, O.IsDescendantOf DOMElement o) => IsDOMElement o
instance (GObject o, O.IsDescendantOf DOMElement o) => IsDOMElement o
instance O.HasParentTypes DOMElement
#if ENABLE_OVERLOADING
data DOMElementAttributesPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementChildElementCountPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementChildrenPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementClassListPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementClassNamePropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementClientHeightPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementClientLeftPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementClientTopPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementClientWidthPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementFirstElementChildPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementIdPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementInnerHtmlPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementLastElementChildPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementLocalNamePropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementNamespaceUriPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementNextElementSiblingPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementOffsetHeightPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementOffsetLeftPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementOffsetParentPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementOffsetTopPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementOffsetWidthPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementOuterHtmlPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementPrefixPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementPreviousElementSiblingPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementScrollHeightPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementScrollLeftPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementScrollTopPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementScrollWidthPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementStylePropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementTagNamePropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementWebkitRegionOversetPropertyInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementBlurMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementClosestMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementFocusMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetAttributeMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetAttributeNodeMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetAttributeNodeNsMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetAttributeNsMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetAttributesMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetBoundingClientRectMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetChildElementCountMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetChildrenMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetClassListMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetClassNameMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetClientHeightMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetClientLeftMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetClientRectsMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetClientTopMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetClientWidthMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetElementsByClassNameMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetElementsByClassNameAsHtmlCollectionMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetElementsByTagNameMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetElementsByTagNameAsHtmlCollectionMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetElementsByTagNameNsMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetElementsByTagNameNsAsHtmlCollectionMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetFirstElementChildMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetIdMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetInnerHtmlMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetLastElementChildMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetLocalNameMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetNamespaceUriMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetNextElementSiblingMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetOffsetHeightMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetOffsetLeftMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetOffsetParentMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetOffsetTopMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetOffsetWidthMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetOuterHtmlMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetPrefixMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetPreviousElementSiblingMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetScrollHeightMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetScrollLeftMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetScrollTopMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetScrollWidthMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetStyleMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetTagNameMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementGetWebkitRegionOversetMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementHasAttributeMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementHasAttributeNsMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementHasAttributesMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementHtmlInputElementGetAutoFilledMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementHtmlInputElementIsUserEditedMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementHtmlInputElementSetAutoFilledMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementHtmlInputElementSetEditingValueMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementInsertAdjacentElementMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementInsertAdjacentHtmlMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementInsertAdjacentTextMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementMatchesMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementQuerySelectorMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementQuerySelectorAllMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementRemoveMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementRemoveAttributeMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementRemoveAttributeNodeMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementRemoveAttributeNsMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementRequestPointerLockMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementScrollByLinesMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementScrollByPagesMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementScrollIntoViewMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementScrollIntoViewIfNeededMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementSetAttributeMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementSetAttributeNodeMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementSetAttributeNodeNsMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementSetAttributeNsMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementSetClassNameMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementSetIdMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementSetInnerHtmlMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementSetOuterHtmlMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementSetScrollLeftMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementSetScrollTopMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementWebkitMatchesSelectorMethodInfo
#endif
#if ENABLE_OVERLOADING
data DOMElementWebkitRequestFullscreenMethodInfo
#endif
