

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2WebExtension.Objects.DOMHTMLStyleElement
    ( 

-- * Exported types
    DOMHTMLStyleElement(..)                 ,
    IsDOMHTMLStyleElement                   ,
    toDOMHTMLStyleElement                   ,
    noDOMHTMLStyleElement                   ,


 -- * Methods
-- ** getDisabled #method:getDisabled#

#if ENABLE_OVERLOADING
    DOMHTMLStyleElementGetDisabledMethodInfo,
#endif
    dOMHTMLStyleElementGetDisabled          ,


-- ** getMedia #method:getMedia#

#if ENABLE_OVERLOADING
    DOMHTMLStyleElementGetMediaMethodInfo   ,
#endif
    dOMHTMLStyleElementGetMedia             ,


-- ** getSheet #method:getSheet#

#if ENABLE_OVERLOADING
    DOMHTMLStyleElementGetSheetMethodInfo   ,
#endif
    dOMHTMLStyleElementGetSheet             ,


-- ** getTypeAttr #method:getTypeAttr#

#if ENABLE_OVERLOADING
    DOMHTMLStyleElementGetTypeAttrMethodInfo,
#endif
    dOMHTMLStyleElementGetTypeAttr          ,


-- ** setDisabled #method:setDisabled#

#if ENABLE_OVERLOADING
    DOMHTMLStyleElementSetDisabledMethodInfo,
#endif
    dOMHTMLStyleElementSetDisabled          ,


-- ** setMedia #method:setMedia#

#if ENABLE_OVERLOADING
    DOMHTMLStyleElementSetMediaMethodInfo   ,
#endif
    dOMHTMLStyleElementSetMedia             ,


-- ** setTypeAttr #method:setTypeAttr#

#if ENABLE_OVERLOADING
    DOMHTMLStyleElementSetTypeAttrMethodInfo,
#endif
    dOMHTMLStyleElementSetTypeAttr          ,




 -- * Properties
-- ** disabled #attr:disabled#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMHTMLStyleElementDisabledPropertyInfo ,
#endif
    constructDOMHTMLStyleElementDisabled    ,
#if ENABLE_OVERLOADING
    dOMHTMLStyleElementDisabled             ,
#endif
    getDOMHTMLStyleElementDisabled          ,
    setDOMHTMLStyleElementDisabled          ,


-- ** media #attr:media#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMHTMLStyleElementMediaPropertyInfo    ,
#endif
    constructDOMHTMLStyleElementMedia       ,
#if ENABLE_OVERLOADING
    dOMHTMLStyleElementMedia                ,
#endif
    getDOMHTMLStyleElementMedia             ,
    setDOMHTMLStyleElementMedia             ,


-- ** sheet #attr:sheet#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMHTMLStyleElementSheetPropertyInfo    ,
#endif
#if ENABLE_OVERLOADING
    dOMHTMLStyleElementSheet                ,
#endif
    getDOMHTMLStyleElementSheet             ,


-- ** type #attr:type#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMHTMLStyleElementTypePropertyInfo     ,
#endif
    clearDOMHTMLStyleElementType            ,
    constructDOMHTMLStyleElementType        ,
#if ENABLE_OVERLOADING
    dOMHTMLStyleElementType                 ,
#endif
    getDOMHTMLStyleElementType              ,
    setDOMHTMLStyleElementType              ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Interfaces.DOMEventTarget as WebKit2WebExtension.DOMEventTarget
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMElement as WebKit2WebExtension.DOMElement
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMHTMLElement as WebKit2WebExtension.DOMHTMLElement
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMNode as WebKit2WebExtension.DOMNode
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMObject as WebKit2WebExtension.DOMObject
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMStyleSheet as WebKit2WebExtension.DOMStyleSheet

-- | Memory-managed wrapper type.
newtype DOMHTMLStyleElement = DOMHTMLStyleElement (ManagedPtr DOMHTMLStyleElement)
foreign import ccall "webkit_dom_html_style_element_get_type"
    c_webkit_dom_html_style_element_get_type :: IO GType

instance GObject DOMHTMLStyleElement where
    gobjectType = c_webkit_dom_html_style_element_get_type
    

-- | Type class for types which can be safely cast to `DOMHTMLStyleElement`, for instance with `toDOMHTMLStyleElement`.
class (GObject o, O.IsDescendantOf DOMHTMLStyleElement o) => IsDOMHTMLStyleElement o
instance (GObject o, O.IsDescendantOf DOMHTMLStyleElement o) => IsDOMHTMLStyleElement o

instance O.HasParentTypes DOMHTMLStyleElement
type instance O.ParentTypes DOMHTMLStyleElement = '[WebKit2WebExtension.DOMHTMLElement.DOMHTMLElement, WebKit2WebExtension.DOMElement.DOMElement, WebKit2WebExtension.DOMNode.DOMNode, WebKit2WebExtension.DOMObject.DOMObject, GObject.Object.Object, WebKit2WebExtension.DOMEventTarget.DOMEventTarget]

-- | Cast to `DOMHTMLStyleElement`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toDOMHTMLStyleElement :: (MonadIO m, IsDOMHTMLStyleElement o) => o -> m DOMHTMLStyleElement
toDOMHTMLStyleElement = liftIO . unsafeCastTo DOMHTMLStyleElement

-- | A convenience alias for `Nothing` :: `Maybe` `DOMHTMLStyleElement`.
noDOMHTMLStyleElement :: Maybe DOMHTMLStyleElement
noDOMHTMLStyleElement = Nothing

#if ENABLE_OVERLOADING
type family ResolveDOMHTMLStyleElementMethod (t :: Symbol) (o :: *) :: * where
    ResolveDOMHTMLStyleElementMethod "addEventListener" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetAddEventListenerMethodInfo
    ResolveDOMHTMLStyleElementMethod "appendChild" o = WebKit2WebExtension.DOMNode.DOMNodeAppendChildMethodInfo
    ResolveDOMHTMLStyleElementMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveDOMHTMLStyleElementMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveDOMHTMLStyleElementMethod "blur" o = WebKit2WebExtension.DOMElement.DOMElementBlurMethodInfo
    ResolveDOMHTMLStyleElementMethod "click" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementClickMethodInfo
    ResolveDOMHTMLStyleElementMethod "cloneNodeWithError" o = WebKit2WebExtension.DOMNode.DOMNodeCloneNodeWithErrorMethodInfo
    ResolveDOMHTMLStyleElementMethod "closest" o = WebKit2WebExtension.DOMElement.DOMElementClosestMethodInfo
    ResolveDOMHTMLStyleElementMethod "compareDocumentPosition" o = WebKit2WebExtension.DOMNode.DOMNodeCompareDocumentPositionMethodInfo
    ResolveDOMHTMLStyleElementMethod "contains" o = WebKit2WebExtension.DOMNode.DOMNodeContainsMethodInfo
    ResolveDOMHTMLStyleElementMethod "dispatchEvent" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetDispatchEventMethodInfo
    ResolveDOMHTMLStyleElementMethod "focus" o = WebKit2WebExtension.DOMElement.DOMElementFocusMethodInfo
    ResolveDOMHTMLStyleElementMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveDOMHTMLStyleElementMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveDOMHTMLStyleElementMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveDOMHTMLStyleElementMethod "hasAttribute" o = WebKit2WebExtension.DOMElement.DOMElementHasAttributeMethodInfo
    ResolveDOMHTMLStyleElementMethod "hasAttributeNs" o = WebKit2WebExtension.DOMElement.DOMElementHasAttributeNsMethodInfo
    ResolveDOMHTMLStyleElementMethod "hasAttributes" o = WebKit2WebExtension.DOMElement.DOMElementHasAttributesMethodInfo
    ResolveDOMHTMLStyleElementMethod "hasChildNodes" o = WebKit2WebExtension.DOMNode.DOMNodeHasChildNodesMethodInfo
    ResolveDOMHTMLStyleElementMethod "htmlInputElementGetAutoFilled" o = WebKit2WebExtension.DOMElement.DOMElementHtmlInputElementGetAutoFilledMethodInfo
    ResolveDOMHTMLStyleElementMethod "htmlInputElementIsUserEdited" o = WebKit2WebExtension.DOMElement.DOMElementHtmlInputElementIsUserEditedMethodInfo
    ResolveDOMHTMLStyleElementMethod "htmlInputElementSetAutoFilled" o = WebKit2WebExtension.DOMElement.DOMElementHtmlInputElementSetAutoFilledMethodInfo
    ResolveDOMHTMLStyleElementMethod "htmlInputElementSetEditingValue" o = WebKit2WebExtension.DOMElement.DOMElementHtmlInputElementSetEditingValueMethodInfo
    ResolveDOMHTMLStyleElementMethod "insertAdjacentElement" o = WebKit2WebExtension.DOMElement.DOMElementInsertAdjacentElementMethodInfo
    ResolveDOMHTMLStyleElementMethod "insertAdjacentHtml" o = WebKit2WebExtension.DOMElement.DOMElementInsertAdjacentHtmlMethodInfo
    ResolveDOMHTMLStyleElementMethod "insertAdjacentText" o = WebKit2WebExtension.DOMElement.DOMElementInsertAdjacentTextMethodInfo
    ResolveDOMHTMLStyleElementMethod "insertBefore" o = WebKit2WebExtension.DOMNode.DOMNodeInsertBeforeMethodInfo
    ResolveDOMHTMLStyleElementMethod "isDefaultNamespace" o = WebKit2WebExtension.DOMNode.DOMNodeIsDefaultNamespaceMethodInfo
    ResolveDOMHTMLStyleElementMethod "isEqualNode" o = WebKit2WebExtension.DOMNode.DOMNodeIsEqualNodeMethodInfo
    ResolveDOMHTMLStyleElementMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveDOMHTMLStyleElementMethod "isSameNode" o = WebKit2WebExtension.DOMNode.DOMNodeIsSameNodeMethodInfo
    ResolveDOMHTMLStyleElementMethod "isSupported" o = WebKit2WebExtension.DOMNode.DOMNodeIsSupportedMethodInfo
    ResolveDOMHTMLStyleElementMethod "lookupNamespaceUri" o = WebKit2WebExtension.DOMNode.DOMNodeLookupNamespaceUriMethodInfo
    ResolveDOMHTMLStyleElementMethod "lookupPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeLookupPrefixMethodInfo
    ResolveDOMHTMLStyleElementMethod "matches" o = WebKit2WebExtension.DOMElement.DOMElementMatchesMethodInfo
    ResolveDOMHTMLStyleElementMethod "normalize" o = WebKit2WebExtension.DOMNode.DOMNodeNormalizeMethodInfo
    ResolveDOMHTMLStyleElementMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveDOMHTMLStyleElementMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveDOMHTMLStyleElementMethod "querySelector" o = WebKit2WebExtension.DOMElement.DOMElementQuerySelectorMethodInfo
    ResolveDOMHTMLStyleElementMethod "querySelectorAll" o = WebKit2WebExtension.DOMElement.DOMElementQuerySelectorAllMethodInfo
    ResolveDOMHTMLStyleElementMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveDOMHTMLStyleElementMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveDOMHTMLStyleElementMethod "remove" o = WebKit2WebExtension.DOMElement.DOMElementRemoveMethodInfo
    ResolveDOMHTMLStyleElementMethod "removeAttribute" o = WebKit2WebExtension.DOMElement.DOMElementRemoveAttributeMethodInfo
    ResolveDOMHTMLStyleElementMethod "removeAttributeNode" o = WebKit2WebExtension.DOMElement.DOMElementRemoveAttributeNodeMethodInfo
    ResolveDOMHTMLStyleElementMethod "removeAttributeNs" o = WebKit2WebExtension.DOMElement.DOMElementRemoveAttributeNsMethodInfo
    ResolveDOMHTMLStyleElementMethod "removeChild" o = WebKit2WebExtension.DOMNode.DOMNodeRemoveChildMethodInfo
    ResolveDOMHTMLStyleElementMethod "removeEventListener" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetRemoveEventListenerMethodInfo
    ResolveDOMHTMLStyleElementMethod "replaceChild" o = WebKit2WebExtension.DOMNode.DOMNodeReplaceChildMethodInfo
    ResolveDOMHTMLStyleElementMethod "requestPointerLock" o = WebKit2WebExtension.DOMElement.DOMElementRequestPointerLockMethodInfo
    ResolveDOMHTMLStyleElementMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveDOMHTMLStyleElementMethod "scrollByLines" o = WebKit2WebExtension.DOMElement.DOMElementScrollByLinesMethodInfo
    ResolveDOMHTMLStyleElementMethod "scrollByPages" o = WebKit2WebExtension.DOMElement.DOMElementScrollByPagesMethodInfo
    ResolveDOMHTMLStyleElementMethod "scrollIntoView" o = WebKit2WebExtension.DOMElement.DOMElementScrollIntoViewMethodInfo
    ResolveDOMHTMLStyleElementMethod "scrollIntoViewIfNeeded" o = WebKit2WebExtension.DOMElement.DOMElementScrollIntoViewIfNeededMethodInfo
    ResolveDOMHTMLStyleElementMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveDOMHTMLStyleElementMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveDOMHTMLStyleElementMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveDOMHTMLStyleElementMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveDOMHTMLStyleElementMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveDOMHTMLStyleElementMethod "webkitMatchesSelector" o = WebKit2WebExtension.DOMElement.DOMElementWebkitMatchesSelectorMethodInfo
    ResolveDOMHTMLStyleElementMethod "webkitRequestFullscreen" o = WebKit2WebExtension.DOMElement.DOMElementWebkitRequestFullscreenMethodInfo
    ResolveDOMHTMLStyleElementMethod "getAccessKey" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetAccessKeyMethodInfo
    ResolveDOMHTMLStyleElementMethod "getAttribute" o = WebKit2WebExtension.DOMElement.DOMElementGetAttributeMethodInfo
    ResolveDOMHTMLStyleElementMethod "getAttributeNode" o = WebKit2WebExtension.DOMElement.DOMElementGetAttributeNodeMethodInfo
    ResolveDOMHTMLStyleElementMethod "getAttributeNodeNs" o = WebKit2WebExtension.DOMElement.DOMElementGetAttributeNodeNsMethodInfo
    ResolveDOMHTMLStyleElementMethod "getAttributeNs" o = WebKit2WebExtension.DOMElement.DOMElementGetAttributeNsMethodInfo
    ResolveDOMHTMLStyleElementMethod "getAttributes" o = WebKit2WebExtension.DOMElement.DOMElementGetAttributesMethodInfo
    ResolveDOMHTMLStyleElementMethod "getBaseUri" o = WebKit2WebExtension.DOMNode.DOMNodeGetBaseUriMethodInfo
    ResolveDOMHTMLStyleElementMethod "getBoundingClientRect" o = WebKit2WebExtension.DOMElement.DOMElementGetBoundingClientRectMethodInfo
    ResolveDOMHTMLStyleElementMethod "getChildElementCount" o = WebKit2WebExtension.DOMElement.DOMElementGetChildElementCountMethodInfo
    ResolveDOMHTMLStyleElementMethod "getChildNodes" o = WebKit2WebExtension.DOMNode.DOMNodeGetChildNodesMethodInfo
    ResolveDOMHTMLStyleElementMethod "getChildren" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetChildrenMethodInfo
    ResolveDOMHTMLStyleElementMethod "getClassList" o = WebKit2WebExtension.DOMElement.DOMElementGetClassListMethodInfo
    ResolveDOMHTMLStyleElementMethod "getClassName" o = WebKit2WebExtension.DOMElement.DOMElementGetClassNameMethodInfo
    ResolveDOMHTMLStyleElementMethod "getClientHeight" o = WebKit2WebExtension.DOMElement.DOMElementGetClientHeightMethodInfo
    ResolveDOMHTMLStyleElementMethod "getClientLeft" o = WebKit2WebExtension.DOMElement.DOMElementGetClientLeftMethodInfo
    ResolveDOMHTMLStyleElementMethod "getClientRects" o = WebKit2WebExtension.DOMElement.DOMElementGetClientRectsMethodInfo
    ResolveDOMHTMLStyleElementMethod "getClientTop" o = WebKit2WebExtension.DOMElement.DOMElementGetClientTopMethodInfo
    ResolveDOMHTMLStyleElementMethod "getClientWidth" o = WebKit2WebExtension.DOMElement.DOMElementGetClientWidthMethodInfo
    ResolveDOMHTMLStyleElementMethod "getContentEditable" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetContentEditableMethodInfo
    ResolveDOMHTMLStyleElementMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveDOMHTMLStyleElementMethod "getDir" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetDirMethodInfo
    ResolveDOMHTMLStyleElementMethod "getDisabled" o = DOMHTMLStyleElementGetDisabledMethodInfo
    ResolveDOMHTMLStyleElementMethod "getDraggable" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetDraggableMethodInfo
    ResolveDOMHTMLStyleElementMethod "getElementsByClassName" o = WebKit2WebExtension.DOMElement.DOMElementGetElementsByClassNameMethodInfo
    ResolveDOMHTMLStyleElementMethod "getElementsByClassNameAsHtmlCollection" o = WebKit2WebExtension.DOMElement.DOMElementGetElementsByClassNameAsHtmlCollectionMethodInfo
    ResolveDOMHTMLStyleElementMethod "getElementsByTagName" o = WebKit2WebExtension.DOMElement.DOMElementGetElementsByTagNameMethodInfo
    ResolveDOMHTMLStyleElementMethod "getElementsByTagNameAsHtmlCollection" o = WebKit2WebExtension.DOMElement.DOMElementGetElementsByTagNameAsHtmlCollectionMethodInfo
    ResolveDOMHTMLStyleElementMethod "getElementsByTagNameNs" o = WebKit2WebExtension.DOMElement.DOMElementGetElementsByTagNameNsMethodInfo
    ResolveDOMHTMLStyleElementMethod "getElementsByTagNameNsAsHtmlCollection" o = WebKit2WebExtension.DOMElement.DOMElementGetElementsByTagNameNsAsHtmlCollectionMethodInfo
    ResolveDOMHTMLStyleElementMethod "getFirstChild" o = WebKit2WebExtension.DOMNode.DOMNodeGetFirstChildMethodInfo
    ResolveDOMHTMLStyleElementMethod "getFirstElementChild" o = WebKit2WebExtension.DOMElement.DOMElementGetFirstElementChildMethodInfo
    ResolveDOMHTMLStyleElementMethod "getHidden" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetHiddenMethodInfo
    ResolveDOMHTMLStyleElementMethod "getId" o = WebKit2WebExtension.DOMElement.DOMElementGetIdMethodInfo
    ResolveDOMHTMLStyleElementMethod "getInnerHtml" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetInnerHtmlMethodInfo
    ResolveDOMHTMLStyleElementMethod "getInnerText" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetInnerTextMethodInfo
    ResolveDOMHTMLStyleElementMethod "getIsContentEditable" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetIsContentEditableMethodInfo
    ResolveDOMHTMLStyleElementMethod "getLang" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetLangMethodInfo
    ResolveDOMHTMLStyleElementMethod "getLastChild" o = WebKit2WebExtension.DOMNode.DOMNodeGetLastChildMethodInfo
    ResolveDOMHTMLStyleElementMethod "getLastElementChild" o = WebKit2WebExtension.DOMElement.DOMElementGetLastElementChildMethodInfo
    ResolveDOMHTMLStyleElementMethod "getLocalName" o = WebKit2WebExtension.DOMElement.DOMElementGetLocalNameMethodInfo
    ResolveDOMHTMLStyleElementMethod "getMedia" o = DOMHTMLStyleElementGetMediaMethodInfo
    ResolveDOMHTMLStyleElementMethod "getNamespaceUri" o = WebKit2WebExtension.DOMElement.DOMElementGetNamespaceUriMethodInfo
    ResolveDOMHTMLStyleElementMethod "getNextElementSibling" o = WebKit2WebExtension.DOMElement.DOMElementGetNextElementSiblingMethodInfo
    ResolveDOMHTMLStyleElementMethod "getNextSibling" o = WebKit2WebExtension.DOMNode.DOMNodeGetNextSiblingMethodInfo
    ResolveDOMHTMLStyleElementMethod "getNodeName" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeNameMethodInfo
    ResolveDOMHTMLStyleElementMethod "getNodeType" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeTypeMethodInfo
    ResolveDOMHTMLStyleElementMethod "getNodeValue" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeValueMethodInfo
    ResolveDOMHTMLStyleElementMethod "getOffsetHeight" o = WebKit2WebExtension.DOMElement.DOMElementGetOffsetHeightMethodInfo
    ResolveDOMHTMLStyleElementMethod "getOffsetLeft" o = WebKit2WebExtension.DOMElement.DOMElementGetOffsetLeftMethodInfo
    ResolveDOMHTMLStyleElementMethod "getOffsetParent" o = WebKit2WebExtension.DOMElement.DOMElementGetOffsetParentMethodInfo
    ResolveDOMHTMLStyleElementMethod "getOffsetTop" o = WebKit2WebExtension.DOMElement.DOMElementGetOffsetTopMethodInfo
    ResolveDOMHTMLStyleElementMethod "getOffsetWidth" o = WebKit2WebExtension.DOMElement.DOMElementGetOffsetWidthMethodInfo
    ResolveDOMHTMLStyleElementMethod "getOuterHtml" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetOuterHtmlMethodInfo
    ResolveDOMHTMLStyleElementMethod "getOuterText" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetOuterTextMethodInfo
    ResolveDOMHTMLStyleElementMethod "getOwnerDocument" o = WebKit2WebExtension.DOMNode.DOMNodeGetOwnerDocumentMethodInfo
    ResolveDOMHTMLStyleElementMethod "getParentElement" o = WebKit2WebExtension.DOMNode.DOMNodeGetParentElementMethodInfo
    ResolveDOMHTMLStyleElementMethod "getParentNode" o = WebKit2WebExtension.DOMNode.DOMNodeGetParentNodeMethodInfo
    ResolveDOMHTMLStyleElementMethod "getPrefix" o = WebKit2WebExtension.DOMElement.DOMElementGetPrefixMethodInfo
    ResolveDOMHTMLStyleElementMethod "getPreviousElementSibling" o = WebKit2WebExtension.DOMElement.DOMElementGetPreviousElementSiblingMethodInfo
    ResolveDOMHTMLStyleElementMethod "getPreviousSibling" o = WebKit2WebExtension.DOMNode.DOMNodeGetPreviousSiblingMethodInfo
    ResolveDOMHTMLStyleElementMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveDOMHTMLStyleElementMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveDOMHTMLStyleElementMethod "getScrollHeight" o = WebKit2WebExtension.DOMElement.DOMElementGetScrollHeightMethodInfo
    ResolveDOMHTMLStyleElementMethod "getScrollLeft" o = WebKit2WebExtension.DOMElement.DOMElementGetScrollLeftMethodInfo
    ResolveDOMHTMLStyleElementMethod "getScrollTop" o = WebKit2WebExtension.DOMElement.DOMElementGetScrollTopMethodInfo
    ResolveDOMHTMLStyleElementMethod "getScrollWidth" o = WebKit2WebExtension.DOMElement.DOMElementGetScrollWidthMethodInfo
    ResolveDOMHTMLStyleElementMethod "getSheet" o = DOMHTMLStyleElementGetSheetMethodInfo
    ResolveDOMHTMLStyleElementMethod "getSpellcheck" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetSpellcheckMethodInfo
    ResolveDOMHTMLStyleElementMethod "getStyle" o = WebKit2WebExtension.DOMElement.DOMElementGetStyleMethodInfo
    ResolveDOMHTMLStyleElementMethod "getTabIndex" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetTabIndexMethodInfo
    ResolveDOMHTMLStyleElementMethod "getTagName" o = WebKit2WebExtension.DOMElement.DOMElementGetTagNameMethodInfo
    ResolveDOMHTMLStyleElementMethod "getTextContent" o = WebKit2WebExtension.DOMNode.DOMNodeGetTextContentMethodInfo
    ResolveDOMHTMLStyleElementMethod "getTitle" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetTitleMethodInfo
    ResolveDOMHTMLStyleElementMethod "getTranslate" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetTranslateMethodInfo
    ResolveDOMHTMLStyleElementMethod "getTypeAttr" o = DOMHTMLStyleElementGetTypeAttrMethodInfo
    ResolveDOMHTMLStyleElementMethod "getWebkitRegionOverset" o = WebKit2WebExtension.DOMElement.DOMElementGetWebkitRegionOversetMethodInfo
    ResolveDOMHTMLStyleElementMethod "getWebkitdropzone" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementGetWebkitdropzoneMethodInfo
    ResolveDOMHTMLStyleElementMethod "setAccessKey" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetAccessKeyMethodInfo
    ResolveDOMHTMLStyleElementMethod "setAttribute" o = WebKit2WebExtension.DOMElement.DOMElementSetAttributeMethodInfo
    ResolveDOMHTMLStyleElementMethod "setAttributeNode" o = WebKit2WebExtension.DOMElement.DOMElementSetAttributeNodeMethodInfo
    ResolveDOMHTMLStyleElementMethod "setAttributeNodeNs" o = WebKit2WebExtension.DOMElement.DOMElementSetAttributeNodeNsMethodInfo
    ResolveDOMHTMLStyleElementMethod "setAttributeNs" o = WebKit2WebExtension.DOMElement.DOMElementSetAttributeNsMethodInfo
    ResolveDOMHTMLStyleElementMethod "setClassName" o = WebKit2WebExtension.DOMElement.DOMElementSetClassNameMethodInfo
    ResolveDOMHTMLStyleElementMethod "setContentEditable" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetContentEditableMethodInfo
    ResolveDOMHTMLStyleElementMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveDOMHTMLStyleElementMethod "setDir" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetDirMethodInfo
    ResolveDOMHTMLStyleElementMethod "setDisabled" o = DOMHTMLStyleElementSetDisabledMethodInfo
    ResolveDOMHTMLStyleElementMethod "setDraggable" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetDraggableMethodInfo
    ResolveDOMHTMLStyleElementMethod "setHidden" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetHiddenMethodInfo
    ResolveDOMHTMLStyleElementMethod "setId" o = WebKit2WebExtension.DOMElement.DOMElementSetIdMethodInfo
    ResolveDOMHTMLStyleElementMethod "setInnerHtml" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetInnerHtmlMethodInfo
    ResolveDOMHTMLStyleElementMethod "setInnerText" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetInnerTextMethodInfo
    ResolveDOMHTMLStyleElementMethod "setLang" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetLangMethodInfo
    ResolveDOMHTMLStyleElementMethod "setMedia" o = DOMHTMLStyleElementSetMediaMethodInfo
    ResolveDOMHTMLStyleElementMethod "setNodeValue" o = WebKit2WebExtension.DOMNode.DOMNodeSetNodeValueMethodInfo
    ResolveDOMHTMLStyleElementMethod "setOuterHtml" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetOuterHtmlMethodInfo
    ResolveDOMHTMLStyleElementMethod "setOuterText" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetOuterTextMethodInfo
    ResolveDOMHTMLStyleElementMethod "setPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeSetPrefixMethodInfo
    ResolveDOMHTMLStyleElementMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveDOMHTMLStyleElementMethod "setScrollLeft" o = WebKit2WebExtension.DOMElement.DOMElementSetScrollLeftMethodInfo
    ResolveDOMHTMLStyleElementMethod "setScrollTop" o = WebKit2WebExtension.DOMElement.DOMElementSetScrollTopMethodInfo
    ResolveDOMHTMLStyleElementMethod "setSpellcheck" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetSpellcheckMethodInfo
    ResolveDOMHTMLStyleElementMethod "setTabIndex" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetTabIndexMethodInfo
    ResolveDOMHTMLStyleElementMethod "setTextContent" o = WebKit2WebExtension.DOMNode.DOMNodeSetTextContentMethodInfo
    ResolveDOMHTMLStyleElementMethod "setTitle" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetTitleMethodInfo
    ResolveDOMHTMLStyleElementMethod "setTranslate" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetTranslateMethodInfo
    ResolveDOMHTMLStyleElementMethod "setTypeAttr" o = DOMHTMLStyleElementSetTypeAttrMethodInfo
    ResolveDOMHTMLStyleElementMethod "setWebkitdropzone" o = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSetWebkitdropzoneMethodInfo
    ResolveDOMHTMLStyleElementMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveDOMHTMLStyleElementMethod t DOMHTMLStyleElement, O.MethodInfo info DOMHTMLStyleElement p) => OL.IsLabel t (DOMHTMLStyleElement -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "disabled"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@disabled@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMHTMLStyleElement #disabled
@
-}
getDOMHTMLStyleElementDisabled :: (MonadIO m, IsDOMHTMLStyleElement o) => o -> m Bool
getDOMHTMLStyleElementDisabled obj = liftIO $ B.Properties.getObjectPropertyBool obj "disabled"

{- |
Set the value of the “@disabled@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMHTMLStyleElement [ #disabled 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMHTMLStyleElementDisabled :: (MonadIO m, IsDOMHTMLStyleElement o) => o -> Bool -> m ()
setDOMHTMLStyleElementDisabled obj val = liftIO $ B.Properties.setObjectPropertyBool obj "disabled" val

{- |
Construct a `GValueConstruct` with valid value for the “@disabled@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMHTMLStyleElementDisabled :: (IsDOMHTMLStyleElement o) => Bool -> IO (GValueConstruct o)
constructDOMHTMLStyleElementDisabled val = B.Properties.constructObjectPropertyBool "disabled" val

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementDisabledPropertyInfo
instance AttrInfo DOMHTMLStyleElementDisabledPropertyInfo where
    type AttrAllowedOps DOMHTMLStyleElementDisabledPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLStyleElementDisabledPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLStyleElementDisabledPropertyInfo = IsDOMHTMLStyleElement
    type AttrGetType DOMHTMLStyleElementDisabledPropertyInfo = Bool
    type AttrLabel DOMHTMLStyleElementDisabledPropertyInfo = "disabled"
    type AttrOrigin DOMHTMLStyleElementDisabledPropertyInfo = DOMHTMLStyleElement
    attrGet _ = getDOMHTMLStyleElementDisabled
    attrSet _ = setDOMHTMLStyleElementDisabled
    attrConstruct _ = constructDOMHTMLStyleElementDisabled
    attrClear _ = undefined
#endif

-- VVV Prop "media"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Just False)

{- |
Get the value of the “@media@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMHTMLStyleElement #media
@
-}
getDOMHTMLStyleElementMedia :: (MonadIO m, IsDOMHTMLStyleElement o) => o -> m (Maybe T.Text)
getDOMHTMLStyleElementMedia obj = liftIO $ B.Properties.getObjectPropertyString obj "media"

{- |
Set the value of the “@media@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMHTMLStyleElement [ #media 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMHTMLStyleElementMedia :: (MonadIO m, IsDOMHTMLStyleElement o) => o -> T.Text -> m ()
setDOMHTMLStyleElementMedia obj val = liftIO $ B.Properties.setObjectPropertyString obj "media" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@media@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMHTMLStyleElementMedia :: (IsDOMHTMLStyleElement o) => T.Text -> IO (GValueConstruct o)
constructDOMHTMLStyleElementMedia val = B.Properties.constructObjectPropertyString "media" (Just val)

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementMediaPropertyInfo
instance AttrInfo DOMHTMLStyleElementMediaPropertyInfo where
    type AttrAllowedOps DOMHTMLStyleElementMediaPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLStyleElementMediaPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLStyleElementMediaPropertyInfo = IsDOMHTMLStyleElement
    type AttrGetType DOMHTMLStyleElementMediaPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMHTMLStyleElementMediaPropertyInfo = "media"
    type AttrOrigin DOMHTMLStyleElementMediaPropertyInfo = DOMHTMLStyleElement
    attrGet _ = getDOMHTMLStyleElementMedia
    attrSet _ = setDOMHTMLStyleElementMedia
    attrConstruct _ = constructDOMHTMLStyleElementMedia
    attrClear _ = undefined
#endif

-- VVV Prop "sheet"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMStyleSheet"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@sheet@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMHTMLStyleElement #sheet
@
-}
getDOMHTMLStyleElementSheet :: (MonadIO m, IsDOMHTMLStyleElement o) => o -> m (Maybe WebKit2WebExtension.DOMStyleSheet.DOMStyleSheet)
getDOMHTMLStyleElementSheet obj = liftIO $ B.Properties.getObjectPropertyObject obj "sheet" WebKit2WebExtension.DOMStyleSheet.DOMStyleSheet

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementSheetPropertyInfo
instance AttrInfo DOMHTMLStyleElementSheetPropertyInfo where
    type AttrAllowedOps DOMHTMLStyleElementSheetPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMHTMLStyleElementSheetPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLStyleElementSheetPropertyInfo = IsDOMHTMLStyleElement
    type AttrGetType DOMHTMLStyleElementSheetPropertyInfo = (Maybe WebKit2WebExtension.DOMStyleSheet.DOMStyleSheet)
    type AttrLabel DOMHTMLStyleElementSheetPropertyInfo = "sheet"
    type AttrOrigin DOMHTMLStyleElementSheetPropertyInfo = DOMHTMLStyleElement
    attrGet _ = getDOMHTMLStyleElementSheet
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@type@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMHTMLStyleElement #type
@
-}
getDOMHTMLStyleElementType :: (MonadIO m, IsDOMHTMLStyleElement o) => o -> m (Maybe T.Text)
getDOMHTMLStyleElementType obj = liftIO $ B.Properties.getObjectPropertyString obj "type"

{- |
Set the value of the “@type@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMHTMLStyleElement [ #type 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMHTMLStyleElementType :: (MonadIO m, IsDOMHTMLStyleElement o) => o -> T.Text -> m ()
setDOMHTMLStyleElementType obj val = liftIO $ B.Properties.setObjectPropertyString obj "type" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@type@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMHTMLStyleElementType :: (IsDOMHTMLStyleElement o) => T.Text -> IO (GValueConstruct o)
constructDOMHTMLStyleElementType val = B.Properties.constructObjectPropertyString "type" (Just val)

{- |
Set the value of the “@type@” property to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #type
@
-}
clearDOMHTMLStyleElementType :: (MonadIO m, IsDOMHTMLStyleElement o) => o -> m ()
clearDOMHTMLStyleElementType obj = liftIO $ B.Properties.setObjectPropertyString obj "type" (Nothing :: Maybe T.Text)

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementTypePropertyInfo
instance AttrInfo DOMHTMLStyleElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLStyleElementTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMHTMLStyleElementTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLStyleElementTypePropertyInfo = IsDOMHTMLStyleElement
    type AttrGetType DOMHTMLStyleElementTypePropertyInfo = (Maybe T.Text)
    type AttrLabel DOMHTMLStyleElementTypePropertyInfo = "type"
    type AttrOrigin DOMHTMLStyleElementTypePropertyInfo = DOMHTMLStyleElement
    attrGet _ = getDOMHTMLStyleElementType
    attrSet _ = setDOMHTMLStyleElementType
    attrConstruct _ = constructDOMHTMLStyleElementType
    attrClear _ = clearDOMHTMLStyleElementType
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList DOMHTMLStyleElement
type instance O.AttributeList DOMHTMLStyleElement = DOMHTMLStyleElementAttributeList
type DOMHTMLStyleElementAttributeList = ('[ '("accessKey", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementAccessKeyPropertyInfo), '("attributes", WebKit2WebExtension.DOMElement.DOMElementAttributesPropertyInfo), '("baseUri", WebKit2WebExtension.DOMNode.DOMNodeBaseUriPropertyInfo), '("childElementCount", WebKit2WebExtension.DOMElement.DOMElementChildElementCountPropertyInfo), '("childNodes", WebKit2WebExtension.DOMNode.DOMNodeChildNodesPropertyInfo), '("children", WebKit2WebExtension.DOMElement.DOMElementChildrenPropertyInfo), '("classList", WebKit2WebExtension.DOMElement.DOMElementClassListPropertyInfo), '("className", WebKit2WebExtension.DOMElement.DOMElementClassNamePropertyInfo), '("clientHeight", WebKit2WebExtension.DOMElement.DOMElementClientHeightPropertyInfo), '("clientLeft", WebKit2WebExtension.DOMElement.DOMElementClientLeftPropertyInfo), '("clientTop", WebKit2WebExtension.DOMElement.DOMElementClientTopPropertyInfo), '("clientWidth", WebKit2WebExtension.DOMElement.DOMElementClientWidthPropertyInfo), '("contentEditable", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementContentEditablePropertyInfo), '("coreObject", WebKit2WebExtension.DOMObject.DOMObjectCoreObjectPropertyInfo), '("dir", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementDirPropertyInfo), '("disabled", DOMHTMLStyleElementDisabledPropertyInfo), '("draggable", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementDraggablePropertyInfo), '("firstChild", WebKit2WebExtension.DOMNode.DOMNodeFirstChildPropertyInfo), '("firstElementChild", WebKit2WebExtension.DOMElement.DOMElementFirstElementChildPropertyInfo), '("hidden", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementHiddenPropertyInfo), '("id", WebKit2WebExtension.DOMElement.DOMElementIdPropertyInfo), '("innerHtml", WebKit2WebExtension.DOMElement.DOMElementInnerHtmlPropertyInfo), '("innerText", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementInnerTextPropertyInfo), '("isContentEditable", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementIsContentEditablePropertyInfo), '("lang", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementLangPropertyInfo), '("lastChild", WebKit2WebExtension.DOMNode.DOMNodeLastChildPropertyInfo), '("lastElementChild", WebKit2WebExtension.DOMElement.DOMElementLastElementChildPropertyInfo), '("localName", WebKit2WebExtension.DOMElement.DOMElementLocalNamePropertyInfo), '("media", DOMHTMLStyleElementMediaPropertyInfo), '("namespaceUri", WebKit2WebExtension.DOMElement.DOMElementNamespaceUriPropertyInfo), '("nextElementSibling", WebKit2WebExtension.DOMElement.DOMElementNextElementSiblingPropertyInfo), '("nextSibling", WebKit2WebExtension.DOMNode.DOMNodeNextSiblingPropertyInfo), '("nodeName", WebKit2WebExtension.DOMNode.DOMNodeNodeNamePropertyInfo), '("nodeType", WebKit2WebExtension.DOMNode.DOMNodeNodeTypePropertyInfo), '("nodeValue", WebKit2WebExtension.DOMNode.DOMNodeNodeValuePropertyInfo), '("offsetHeight", WebKit2WebExtension.DOMElement.DOMElementOffsetHeightPropertyInfo), '("offsetLeft", WebKit2WebExtension.DOMElement.DOMElementOffsetLeftPropertyInfo), '("offsetParent", WebKit2WebExtension.DOMElement.DOMElementOffsetParentPropertyInfo), '("offsetTop", WebKit2WebExtension.DOMElement.DOMElementOffsetTopPropertyInfo), '("offsetWidth", WebKit2WebExtension.DOMElement.DOMElementOffsetWidthPropertyInfo), '("outerHtml", WebKit2WebExtension.DOMElement.DOMElementOuterHtmlPropertyInfo), '("outerText", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementOuterTextPropertyInfo), '("ownerDocument", WebKit2WebExtension.DOMNode.DOMNodeOwnerDocumentPropertyInfo), '("parentElement", WebKit2WebExtension.DOMNode.DOMNodeParentElementPropertyInfo), '("parentNode", WebKit2WebExtension.DOMNode.DOMNodeParentNodePropertyInfo), '("prefix", WebKit2WebExtension.DOMElement.DOMElementPrefixPropertyInfo), '("previousElementSibling", WebKit2WebExtension.DOMElement.DOMElementPreviousElementSiblingPropertyInfo), '("previousSibling", WebKit2WebExtension.DOMNode.DOMNodePreviousSiblingPropertyInfo), '("scrollHeight", WebKit2WebExtension.DOMElement.DOMElementScrollHeightPropertyInfo), '("scrollLeft", WebKit2WebExtension.DOMElement.DOMElementScrollLeftPropertyInfo), '("scrollTop", WebKit2WebExtension.DOMElement.DOMElementScrollTopPropertyInfo), '("scrollWidth", WebKit2WebExtension.DOMElement.DOMElementScrollWidthPropertyInfo), '("sheet", DOMHTMLStyleElementSheetPropertyInfo), '("spellcheck", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementSpellcheckPropertyInfo), '("style", WebKit2WebExtension.DOMElement.DOMElementStylePropertyInfo), '("tabIndex", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementTabIndexPropertyInfo), '("tagName", WebKit2WebExtension.DOMElement.DOMElementTagNamePropertyInfo), '("textContent", WebKit2WebExtension.DOMNode.DOMNodeTextContentPropertyInfo), '("title", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementTitlePropertyInfo), '("translate", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLStyleElementTypePropertyInfo), '("webkitRegionOverset", WebKit2WebExtension.DOMElement.DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", WebKit2WebExtension.DOMHTMLElement.DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
dOMHTMLStyleElementDisabled :: AttrLabelProxy "disabled"
dOMHTMLStyleElementDisabled = AttrLabelProxy

dOMHTMLStyleElementMedia :: AttrLabelProxy "media"
dOMHTMLStyleElementMedia = AttrLabelProxy

dOMHTMLStyleElementSheet :: AttrLabelProxy "sheet"
dOMHTMLStyleElementSheet = AttrLabelProxy

dOMHTMLStyleElementType :: AttrLabelProxy "type"
dOMHTMLStyleElementType = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList DOMHTMLStyleElement = DOMHTMLStyleElementSignalList
type DOMHTMLStyleElementSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

-- method DOMHTMLStyleElement::get_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMHTMLStyleElement", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_get_disabled" webkit_dom_html_style_element_get_disabled :: 
    Ptr DOMHTMLStyleElement ->              -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"})
    IO CInt

{-# DEPRECATED dOMHTMLStyleElementGetDisabled ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMHTMLStyleElementGetDisabled ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMHTMLStyleElement a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMHTMLStyleElement.DOMHTMLStyleElement' -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMHTMLStyleElementGetDisabled self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_html_style_element_get_disabled self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementGetDisabledMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDOMHTMLStyleElement a) => O.MethodInfo DOMHTMLStyleElementGetDisabledMethodInfo a signature where
    overloadedMethod _ = dOMHTMLStyleElementGetDisabled

#endif

-- method DOMHTMLStyleElement::get_media
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMHTMLStyleElement", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_get_media" webkit_dom_html_style_element_get_media :: 
    Ptr DOMHTMLStyleElement ->              -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"})
    IO CString

{-# DEPRECATED dOMHTMLStyleElementGetMedia ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMHTMLStyleElementGetMedia ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMHTMLStyleElement a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMHTMLStyleElement.DOMHTMLStyleElement' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMHTMLStyleElementGetMedia self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_html_style_element_get_media self'
    checkUnexpectedReturnNULL "dOMHTMLStyleElementGetMedia" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementGetMediaMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMHTMLStyleElement a) => O.MethodInfo DOMHTMLStyleElementGetMediaMethodInfo a signature where
    overloadedMethod _ = dOMHTMLStyleElementGetMedia

#endif

-- method DOMHTMLStyleElement::get_sheet
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMHTMLStyleElement", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMStyleSheet"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_get_sheet" webkit_dom_html_style_element_get_sheet :: 
    Ptr DOMHTMLStyleElement ->              -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"})
    IO (Ptr WebKit2WebExtension.DOMStyleSheet.DOMStyleSheet)

{-# DEPRECATED dOMHTMLStyleElementGetSheet ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMHTMLStyleElementGetSheet ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMHTMLStyleElement a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMHTMLStyleElement.DOMHTMLStyleElement' -}
    -> m WebKit2WebExtension.DOMStyleSheet.DOMStyleSheet
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMStyleSheet.DOMStyleSheet' -}
dOMHTMLStyleElementGetSheet self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_html_style_element_get_sheet self'
    checkUnexpectedReturnNULL "dOMHTMLStyleElementGetSheet" result
    result' <- (wrapObject WebKit2WebExtension.DOMStyleSheet.DOMStyleSheet) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementGetSheetMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMStyleSheet.DOMStyleSheet), MonadIO m, IsDOMHTMLStyleElement a) => O.MethodInfo DOMHTMLStyleElementGetSheetMethodInfo a signature where
    overloadedMethod _ = dOMHTMLStyleElementGetSheet

#endif

-- method DOMHTMLStyleElement::get_type_attr
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMHTMLStyleElement", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_get_type_attr" webkit_dom_html_style_element_get_type_attr :: 
    Ptr DOMHTMLStyleElement ->              -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"})
    IO CString

{-# DEPRECATED dOMHTMLStyleElementGetTypeAttr ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMHTMLStyleElementGetTypeAttr ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMHTMLStyleElement a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMHTMLStyleElement.DOMHTMLStyleElement' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMHTMLStyleElementGetTypeAttr self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_html_style_element_get_type_attr self'
    checkUnexpectedReturnNULL "dOMHTMLStyleElementGetTypeAttr" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementGetTypeAttrMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMHTMLStyleElement a) => O.MethodInfo DOMHTMLStyleElementGetTypeAttrMethodInfo a signature where
    overloadedMethod _ = dOMHTMLStyleElementGetTypeAttr

#endif

-- method DOMHTMLStyleElement::set_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMHTMLStyleElement", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gboolean", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_set_disabled" webkit_dom_html_style_element_set_disabled :: 
    Ptr DOMHTMLStyleElement ->              -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"})
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()

{-# DEPRECATED dOMHTMLStyleElementSetDisabled ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMHTMLStyleElementSetDisabled ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMHTMLStyleElement a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMHTMLStyleElement.DOMHTMLStyleElement' -}
    -> Bool
    {- ^ /@value@/: A 'Bool' -}
    -> m ()
dOMHTMLStyleElementSetDisabled self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_style_element_set_disabled self' value'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementSetDisabledMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsDOMHTMLStyleElement a) => O.MethodInfo DOMHTMLStyleElementSetDisabledMethodInfo a signature where
    overloadedMethod _ = dOMHTMLStyleElementSetDisabled

#endif

-- method DOMHTMLStyleElement::set_media
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMHTMLStyleElement", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_set_media" webkit_dom_html_style_element_set_media :: 
    Ptr DOMHTMLStyleElement ->              -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"})
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMHTMLStyleElementSetMedia ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMHTMLStyleElementSetMedia ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMHTMLStyleElement a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMHTMLStyleElement.DOMHTMLStyleElement' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m ()
dOMHTMLStyleElementSetMedia self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- textToCString value
    webkit_dom_html_style_element_set_media self' value'
    touchManagedPtr self
    freeMem value'
    return ()

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementSetMediaMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDOMHTMLStyleElement a) => O.MethodInfo DOMHTMLStyleElementSetMediaMethodInfo a signature where
    overloadedMethod _ = dOMHTMLStyleElementSetMedia

#endif

-- method DOMHTMLStyleElement::set_type_attr
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMHTMLStyleElement", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_set_type_attr" webkit_dom_html_style_element_set_type_attr :: 
    Ptr DOMHTMLStyleElement ->              -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLStyleElement"})
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMHTMLStyleElementSetTypeAttr ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMHTMLStyleElementSetTypeAttr ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMHTMLStyleElement a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMHTMLStyleElement.DOMHTMLStyleElement' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m ()
dOMHTMLStyleElementSetTypeAttr self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- textToCString value
    webkit_dom_html_style_element_set_type_attr self' value'
    touchManagedPtr self
    freeMem value'
    return ()

#if ENABLE_OVERLOADING
data DOMHTMLStyleElementSetTypeAttrMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDOMHTMLStyleElement a) => O.MethodInfo DOMHTMLStyleElementSetTypeAttrMethodInfo a signature where
    overloadedMethod _ = dOMHTMLStyleElementSetTypeAttr

#endif


