

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2WebExtension.Objects.DOMNodeIterator
    ( 

-- * Exported types
    DOMNodeIterator(..)                     ,
    IsDOMNodeIterator                       ,
    toDOMNodeIterator                       ,
    noDOMNodeIterator                       ,


 -- * Methods
-- ** detach #method:detach#

#if ENABLE_OVERLOADING
    DOMNodeIteratorDetachMethodInfo         ,
#endif
    dOMNodeIteratorDetach                   ,


-- ** getExpandEntityReferences #method:getExpandEntityReferences#

#if ENABLE_OVERLOADING
    DOMNodeIteratorGetExpandEntityReferencesMethodInfo,
#endif
    dOMNodeIteratorGetExpandEntityReferences,


-- ** getFilter #method:getFilter#

#if ENABLE_OVERLOADING
    DOMNodeIteratorGetFilterMethodInfo      ,
#endif
    dOMNodeIteratorGetFilter                ,


-- ** getPointerBeforeReferenceNode #method:getPointerBeforeReferenceNode#

#if ENABLE_OVERLOADING
    DOMNodeIteratorGetPointerBeforeReferenceNodeMethodInfo,
#endif
    dOMNodeIteratorGetPointerBeforeReferenceNode,


-- ** getReferenceNode #method:getReferenceNode#

#if ENABLE_OVERLOADING
    DOMNodeIteratorGetReferenceNodeMethodInfo,
#endif
    dOMNodeIteratorGetReferenceNode         ,


-- ** getRoot #method:getRoot#

#if ENABLE_OVERLOADING
    DOMNodeIteratorGetRootMethodInfo        ,
#endif
    dOMNodeIteratorGetRoot                  ,


-- ** getWhatToShow #method:getWhatToShow#

#if ENABLE_OVERLOADING
    DOMNodeIteratorGetWhatToShowMethodInfo  ,
#endif
    dOMNodeIteratorGetWhatToShow            ,


-- ** nextNode #method:nextNode#

#if ENABLE_OVERLOADING
    DOMNodeIteratorNextNodeMethodInfo       ,
#endif
    dOMNodeIteratorNextNode                 ,


-- ** previousNode #method:previousNode#

#if ENABLE_OVERLOADING
    DOMNodeIteratorPreviousNodeMethodInfo   ,
#endif
    dOMNodeIteratorPreviousNode             ,




 -- * Properties
-- ** filter #attr:filter#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMNodeIteratorFilterPropertyInfo       ,
#endif
#if ENABLE_OVERLOADING
    dOMNodeIteratorFilter                   ,
#endif
    getDOMNodeIteratorFilter                ,


-- ** pointerBeforeReferenceNode #attr:pointerBeforeReferenceNode#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMNodeIteratorPointerBeforeReferenceNodePropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMNodeIteratorPointerBeforeReferenceNode,
#endif
    getDOMNodeIteratorPointerBeforeReferenceNode,


-- ** referenceNode #attr:referenceNode#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMNodeIteratorReferenceNodePropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMNodeIteratorReferenceNode            ,
#endif
    getDOMNodeIteratorReferenceNode         ,


-- ** root #attr:root#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMNodeIteratorRootPropertyInfo         ,
#endif
#if ENABLE_OVERLOADING
    dOMNodeIteratorRoot                     ,
#endif
    getDOMNodeIteratorRoot                  ,


-- ** whatToShow #attr:whatToShow#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMNodeIteratorWhatToShowPropertyInfo   ,
#endif
#if ENABLE_OVERLOADING
    dOMNodeIteratorWhatToShow               ,
#endif
    getDOMNodeIteratorWhatToShow            ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Interfaces.DOMNodeFilter as WebKit2WebExtension.DOMNodeFilter
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMNode as WebKit2WebExtension.DOMNode
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMObject as WebKit2WebExtension.DOMObject

-- | Memory-managed wrapper type.
newtype DOMNodeIterator = DOMNodeIterator (ManagedPtr DOMNodeIterator)
foreign import ccall "webkit_dom_node_iterator_get_type"
    c_webkit_dom_node_iterator_get_type :: IO GType

instance GObject DOMNodeIterator where
    gobjectType = c_webkit_dom_node_iterator_get_type
    

-- | Type class for types which can be safely cast to `DOMNodeIterator`, for instance with `toDOMNodeIterator`.
class (GObject o, O.IsDescendantOf DOMNodeIterator o) => IsDOMNodeIterator o
instance (GObject o, O.IsDescendantOf DOMNodeIterator o) => IsDOMNodeIterator o

instance O.HasParentTypes DOMNodeIterator
type instance O.ParentTypes DOMNodeIterator = '[WebKit2WebExtension.DOMObject.DOMObject, GObject.Object.Object]

-- | Cast to `DOMNodeIterator`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toDOMNodeIterator :: (MonadIO m, IsDOMNodeIterator o) => o -> m DOMNodeIterator
toDOMNodeIterator = liftIO . unsafeCastTo DOMNodeIterator

-- | A convenience alias for `Nothing` :: `Maybe` `DOMNodeIterator`.
noDOMNodeIterator :: Maybe DOMNodeIterator
noDOMNodeIterator = Nothing

#if ENABLE_OVERLOADING
type family ResolveDOMNodeIteratorMethod (t :: Symbol) (o :: *) :: * where
    ResolveDOMNodeIteratorMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveDOMNodeIteratorMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveDOMNodeIteratorMethod "detach" o = DOMNodeIteratorDetachMethodInfo
    ResolveDOMNodeIteratorMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveDOMNodeIteratorMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveDOMNodeIteratorMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveDOMNodeIteratorMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveDOMNodeIteratorMethod "nextNode" o = DOMNodeIteratorNextNodeMethodInfo
    ResolveDOMNodeIteratorMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveDOMNodeIteratorMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveDOMNodeIteratorMethod "previousNode" o = DOMNodeIteratorPreviousNodeMethodInfo
    ResolveDOMNodeIteratorMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveDOMNodeIteratorMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveDOMNodeIteratorMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveDOMNodeIteratorMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveDOMNodeIteratorMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveDOMNodeIteratorMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveDOMNodeIteratorMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveDOMNodeIteratorMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveDOMNodeIteratorMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveDOMNodeIteratorMethod "getExpandEntityReferences" o = DOMNodeIteratorGetExpandEntityReferencesMethodInfo
    ResolveDOMNodeIteratorMethod "getFilter" o = DOMNodeIteratorGetFilterMethodInfo
    ResolveDOMNodeIteratorMethod "getPointerBeforeReferenceNode" o = DOMNodeIteratorGetPointerBeforeReferenceNodeMethodInfo
    ResolveDOMNodeIteratorMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveDOMNodeIteratorMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveDOMNodeIteratorMethod "getReferenceNode" o = DOMNodeIteratorGetReferenceNodeMethodInfo
    ResolveDOMNodeIteratorMethod "getRoot" o = DOMNodeIteratorGetRootMethodInfo
    ResolveDOMNodeIteratorMethod "getWhatToShow" o = DOMNodeIteratorGetWhatToShowMethodInfo
    ResolveDOMNodeIteratorMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveDOMNodeIteratorMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveDOMNodeIteratorMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveDOMNodeIteratorMethod t DOMNodeIterator, O.MethodInfo info DOMNodeIterator p) => OL.IsLabel t (DOMNodeIterator -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "filter"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeFilter"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@filter@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMNodeIterator #filter
@
-}
getDOMNodeIteratorFilter :: (MonadIO m, IsDOMNodeIterator o) => o -> m (Maybe WebKit2WebExtension.DOMNodeFilter.DOMNodeFilter)
getDOMNodeIteratorFilter obj = liftIO $ B.Properties.getObjectPropertyObject obj "filter" WebKit2WebExtension.DOMNodeFilter.DOMNodeFilter

#if ENABLE_OVERLOADING
data DOMNodeIteratorFilterPropertyInfo
instance AttrInfo DOMNodeIteratorFilterPropertyInfo where
    type AttrAllowedOps DOMNodeIteratorFilterPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMNodeIteratorFilterPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMNodeIteratorFilterPropertyInfo = IsDOMNodeIterator
    type AttrGetType DOMNodeIteratorFilterPropertyInfo = (Maybe WebKit2WebExtension.DOMNodeFilter.DOMNodeFilter)
    type AttrLabel DOMNodeIteratorFilterPropertyInfo = "filter"
    type AttrOrigin DOMNodeIteratorFilterPropertyInfo = DOMNodeIterator
    attrGet _ = getDOMNodeIteratorFilter
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "pointer-before-reference-node"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@pointer-before-reference-node@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMNodeIterator #pointerBeforeReferenceNode
@
-}
getDOMNodeIteratorPointerBeforeReferenceNode :: (MonadIO m, IsDOMNodeIterator o) => o -> m Bool
getDOMNodeIteratorPointerBeforeReferenceNode obj = liftIO $ B.Properties.getObjectPropertyBool obj "pointer-before-reference-node"

#if ENABLE_OVERLOADING
data DOMNodeIteratorPointerBeforeReferenceNodePropertyInfo
instance AttrInfo DOMNodeIteratorPointerBeforeReferenceNodePropertyInfo where
    type AttrAllowedOps DOMNodeIteratorPointerBeforeReferenceNodePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMNodeIteratorPointerBeforeReferenceNodePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMNodeIteratorPointerBeforeReferenceNodePropertyInfo = IsDOMNodeIterator
    type AttrGetType DOMNodeIteratorPointerBeforeReferenceNodePropertyInfo = Bool
    type AttrLabel DOMNodeIteratorPointerBeforeReferenceNodePropertyInfo = "pointer-before-reference-node"
    type AttrOrigin DOMNodeIteratorPointerBeforeReferenceNodePropertyInfo = DOMNodeIterator
    attrGet _ = getDOMNodeIteratorPointerBeforeReferenceNode
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "reference-node"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@reference-node@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMNodeIterator #referenceNode
@
-}
getDOMNodeIteratorReferenceNode :: (MonadIO m, IsDOMNodeIterator o) => o -> m WebKit2WebExtension.DOMNode.DOMNode
getDOMNodeIteratorReferenceNode obj = liftIO $ checkUnexpectedNothing "getDOMNodeIteratorReferenceNode" $ B.Properties.getObjectPropertyObject obj "reference-node" WebKit2WebExtension.DOMNode.DOMNode

#if ENABLE_OVERLOADING
data DOMNodeIteratorReferenceNodePropertyInfo
instance AttrInfo DOMNodeIteratorReferenceNodePropertyInfo where
    type AttrAllowedOps DOMNodeIteratorReferenceNodePropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMNodeIteratorReferenceNodePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMNodeIteratorReferenceNodePropertyInfo = IsDOMNodeIterator
    type AttrGetType DOMNodeIteratorReferenceNodePropertyInfo = WebKit2WebExtension.DOMNode.DOMNode
    type AttrLabel DOMNodeIteratorReferenceNodePropertyInfo = "reference-node"
    type AttrOrigin DOMNodeIteratorReferenceNodePropertyInfo = DOMNodeIterator
    attrGet _ = getDOMNodeIteratorReferenceNode
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "root"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@root@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMNodeIterator #root
@
-}
getDOMNodeIteratorRoot :: (MonadIO m, IsDOMNodeIterator o) => o -> m WebKit2WebExtension.DOMNode.DOMNode
getDOMNodeIteratorRoot obj = liftIO $ checkUnexpectedNothing "getDOMNodeIteratorRoot" $ B.Properties.getObjectPropertyObject obj "root" WebKit2WebExtension.DOMNode.DOMNode

#if ENABLE_OVERLOADING
data DOMNodeIteratorRootPropertyInfo
instance AttrInfo DOMNodeIteratorRootPropertyInfo where
    type AttrAllowedOps DOMNodeIteratorRootPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMNodeIteratorRootPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMNodeIteratorRootPropertyInfo = IsDOMNodeIterator
    type AttrGetType DOMNodeIteratorRootPropertyInfo = WebKit2WebExtension.DOMNode.DOMNode
    type AttrLabel DOMNodeIteratorRootPropertyInfo = "root"
    type AttrOrigin DOMNodeIteratorRootPropertyInfo = DOMNodeIterator
    attrGet _ = getDOMNodeIteratorRoot
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "what-to-show"
   -- Type: TBasicType TULong
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@what-to-show@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMNodeIterator #whatToShow
@
-}
getDOMNodeIteratorWhatToShow :: (MonadIO m, IsDOMNodeIterator o) => o -> m CULong
getDOMNodeIteratorWhatToShow obj = liftIO $ B.Properties.getObjectPropertyULong obj "what-to-show"

#if ENABLE_OVERLOADING
data DOMNodeIteratorWhatToShowPropertyInfo
instance AttrInfo DOMNodeIteratorWhatToShowPropertyInfo where
    type AttrAllowedOps DOMNodeIteratorWhatToShowPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMNodeIteratorWhatToShowPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMNodeIteratorWhatToShowPropertyInfo = IsDOMNodeIterator
    type AttrGetType DOMNodeIteratorWhatToShowPropertyInfo = CULong
    type AttrLabel DOMNodeIteratorWhatToShowPropertyInfo = "what-to-show"
    type AttrOrigin DOMNodeIteratorWhatToShowPropertyInfo = DOMNodeIterator
    attrGet _ = getDOMNodeIteratorWhatToShow
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList DOMNodeIterator
type instance O.AttributeList DOMNodeIterator = DOMNodeIteratorAttributeList
type DOMNodeIteratorAttributeList = ('[ '("coreObject", WebKit2WebExtension.DOMObject.DOMObjectCoreObjectPropertyInfo), '("filter", DOMNodeIteratorFilterPropertyInfo), '("pointerBeforeReferenceNode", DOMNodeIteratorPointerBeforeReferenceNodePropertyInfo), '("referenceNode", DOMNodeIteratorReferenceNodePropertyInfo), '("root", DOMNodeIteratorRootPropertyInfo), '("whatToShow", DOMNodeIteratorWhatToShowPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
dOMNodeIteratorFilter :: AttrLabelProxy "filter"
dOMNodeIteratorFilter = AttrLabelProxy

dOMNodeIteratorPointerBeforeReferenceNode :: AttrLabelProxy "pointerBeforeReferenceNode"
dOMNodeIteratorPointerBeforeReferenceNode = AttrLabelProxy

dOMNodeIteratorReferenceNode :: AttrLabelProxy "referenceNode"
dOMNodeIteratorReferenceNode = AttrLabelProxy

dOMNodeIteratorRoot :: AttrLabelProxy "root"
dOMNodeIteratorRoot = AttrLabelProxy

dOMNodeIteratorWhatToShow :: AttrLabelProxy "whatToShow"
dOMNodeIteratorWhatToShow = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList DOMNodeIterator = DOMNodeIteratorSignalList
type DOMNodeIteratorSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

-- method DOMNodeIterator::detach
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeIterator", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_node_iterator_detach" webkit_dom_node_iterator_detach :: 
    Ptr DOMNodeIterator ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"})
    IO ()

{-# DEPRECATED dOMNodeIteratorDetach ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMNodeIteratorDetach ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMNodeIterator a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMNodeIterator.DOMNodeIterator' -}
    -> m ()
dOMNodeIteratorDetach self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    webkit_dom_node_iterator_detach self'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data DOMNodeIteratorDetachMethodInfo
instance (signature ~ (m ()), MonadIO m, IsDOMNodeIterator a) => O.MethodInfo DOMNodeIteratorDetachMethodInfo a signature where
    overloadedMethod _ = dOMNodeIteratorDetach

#endif

-- method DOMNodeIterator::get_expand_entity_references
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeIterator", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_node_iterator_get_expand_entity_references" webkit_dom_node_iterator_get_expand_entity_references :: 
    Ptr DOMNodeIterator ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"})
    IO CInt

{-# DEPRECATED dOMNodeIteratorGetExpandEntityReferences ["(Since version 2.12)"] #-}
{- |
This function has been removed from the DOM spec and it just returns 'False'.
-}
dOMNodeIteratorGetExpandEntityReferences ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMNodeIterator a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMNodeIterator.DOMNodeIterator' -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool'                                                                                                                                                                       * -}
dOMNodeIteratorGetExpandEntityReferences self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_node_iterator_get_expand_entity_references self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMNodeIteratorGetExpandEntityReferencesMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDOMNodeIterator a) => O.MethodInfo DOMNodeIteratorGetExpandEntityReferencesMethodInfo a signature where
    overloadedMethod _ = dOMNodeIteratorGetExpandEntityReferences

#endif

-- method DOMNodeIterator::get_filter
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeIterator", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeFilter"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_node_iterator_get_filter" webkit_dom_node_iterator_get_filter :: 
    Ptr DOMNodeIterator ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"})
    IO (Ptr WebKit2WebExtension.DOMNodeFilter.DOMNodeFilter)

{-# DEPRECATED dOMNodeIteratorGetFilter ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMNodeIteratorGetFilter ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMNodeIterator a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMNodeIterator.DOMNodeIterator' -}
    -> m WebKit2WebExtension.DOMNodeFilter.DOMNodeFilter
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Interfaces.DOMNodeFilter.DOMNodeFilter' -}
dOMNodeIteratorGetFilter self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_node_iterator_get_filter self'
    checkUnexpectedReturnNULL "dOMNodeIteratorGetFilter" result
    result' <- (wrapObject WebKit2WebExtension.DOMNodeFilter.DOMNodeFilter) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMNodeIteratorGetFilterMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMNodeFilter.DOMNodeFilter), MonadIO m, IsDOMNodeIterator a) => O.MethodInfo DOMNodeIteratorGetFilterMethodInfo a signature where
    overloadedMethod _ = dOMNodeIteratorGetFilter

#endif

-- method DOMNodeIterator::get_pointer_before_reference_node
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeIterator", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_node_iterator_get_pointer_before_reference_node" webkit_dom_node_iterator_get_pointer_before_reference_node :: 
    Ptr DOMNodeIterator ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"})
    IO CInt

{-# DEPRECATED dOMNodeIteratorGetPointerBeforeReferenceNode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMNodeIteratorGetPointerBeforeReferenceNode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMNodeIterator a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMNodeIterator.DOMNodeIterator' -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMNodeIteratorGetPointerBeforeReferenceNode self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_node_iterator_get_pointer_before_reference_node self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMNodeIteratorGetPointerBeforeReferenceNodeMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDOMNodeIterator a) => O.MethodInfo DOMNodeIteratorGetPointerBeforeReferenceNodeMethodInfo a signature where
    overloadedMethod _ = dOMNodeIteratorGetPointerBeforeReferenceNode

#endif

-- method DOMNodeIterator::get_reference_node
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeIterator", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_node_iterator_get_reference_node" webkit_dom_node_iterator_get_reference_node :: 
    Ptr DOMNodeIterator ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"})
    IO (Ptr WebKit2WebExtension.DOMNode.DOMNode)

{-# DEPRECATED dOMNodeIteratorGetReferenceNode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMNodeIteratorGetReferenceNode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMNodeIterator a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMNodeIterator.DOMNodeIterator' -}
    -> m WebKit2WebExtension.DOMNode.DOMNode
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' -}
dOMNodeIteratorGetReferenceNode self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_node_iterator_get_reference_node self'
    checkUnexpectedReturnNULL "dOMNodeIteratorGetReferenceNode" result
    result' <- (newObject WebKit2WebExtension.DOMNode.DOMNode) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMNodeIteratorGetReferenceNodeMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMNode.DOMNode), MonadIO m, IsDOMNodeIterator a) => O.MethodInfo DOMNodeIteratorGetReferenceNodeMethodInfo a signature where
    overloadedMethod _ = dOMNodeIteratorGetReferenceNode

#endif

-- method DOMNodeIterator::get_root
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeIterator", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_node_iterator_get_root" webkit_dom_node_iterator_get_root :: 
    Ptr DOMNodeIterator ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"})
    IO (Ptr WebKit2WebExtension.DOMNode.DOMNode)

{-# DEPRECATED dOMNodeIteratorGetRoot ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMNodeIteratorGetRoot ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMNodeIterator a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMNodeIterator.DOMNodeIterator' -}
    -> m WebKit2WebExtension.DOMNode.DOMNode
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' -}
dOMNodeIteratorGetRoot self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_node_iterator_get_root self'
    checkUnexpectedReturnNULL "dOMNodeIteratorGetRoot" result
    result' <- (newObject WebKit2WebExtension.DOMNode.DOMNode) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMNodeIteratorGetRootMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMNode.DOMNode), MonadIO m, IsDOMNodeIterator a) => O.MethodInfo DOMNodeIteratorGetRootMethodInfo a signature where
    overloadedMethod _ = dOMNodeIteratorGetRoot

#endif

-- method DOMNodeIterator::get_what_to_show
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeIterator", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TULong)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_node_iterator_get_what_to_show" webkit_dom_node_iterator_get_what_to_show :: 
    Ptr DOMNodeIterator ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"})
    IO CULong

{-# DEPRECATED dOMNodeIteratorGetWhatToShow ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMNodeIteratorGetWhatToShow ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMNodeIterator a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMNodeIterator.DOMNodeIterator' -}
    -> m CULong
    {- ^ __Returns:__ A @/gulong/@ -}
dOMNodeIteratorGetWhatToShow self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_node_iterator_get_what_to_show self'
    touchManagedPtr self
    return result

#if ENABLE_OVERLOADING
data DOMNodeIteratorGetWhatToShowMethodInfo
instance (signature ~ (m CULong), MonadIO m, IsDOMNodeIterator a) => O.MethodInfo DOMNodeIteratorGetWhatToShowMethodInfo a signature where
    overloadedMethod _ = dOMNodeIteratorGetWhatToShow

#endif

-- method DOMNodeIterator::next_node
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeIterator", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_node_iterator_next_node" webkit_dom_node_iterator_next_node :: 
    Ptr DOMNodeIterator ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"})
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMNode.DOMNode)

{-# DEPRECATED dOMNodeIteratorNextNode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMNodeIteratorNextNode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMNodeIterator a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMNodeIterator.DOMNodeIterator' -}
    -> m WebKit2WebExtension.DOMNode.DOMNode
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMNodeIteratorNextNode self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    onException (do
        result <- propagateGError $ webkit_dom_node_iterator_next_node self'
        checkUnexpectedReturnNULL "dOMNodeIteratorNextNode" result
        result' <- (newObject WebKit2WebExtension.DOMNode.DOMNode) result
        touchManagedPtr self
        return result'
     ) (do
        return ()
     )

#if ENABLE_OVERLOADING
data DOMNodeIteratorNextNodeMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMNode.DOMNode), MonadIO m, IsDOMNodeIterator a) => O.MethodInfo DOMNodeIteratorNextNodeMethodInfo a signature where
    overloadedMethod _ = dOMNodeIteratorNextNode

#endif

-- method DOMNodeIterator::previous_node
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeIterator", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_node_iterator_previous_node" webkit_dom_node_iterator_previous_node :: 
    Ptr DOMNodeIterator ->                  -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"})
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMNode.DOMNode)

{-# DEPRECATED dOMNodeIteratorPreviousNode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMNodeIteratorPreviousNode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMNodeIterator a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMNodeIterator.DOMNodeIterator' -}
    -> m WebKit2WebExtension.DOMNode.DOMNode
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMNodeIteratorPreviousNode self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    onException (do
        result <- propagateGError $ webkit_dom_node_iterator_previous_node self'
        checkUnexpectedReturnNULL "dOMNodeIteratorPreviousNode" result
        result' <- (newObject WebKit2WebExtension.DOMNode.DOMNode) result
        touchManagedPtr self
        return result'
     ) (do
        return ()
     )

#if ENABLE_OVERLOADING
data DOMNodeIteratorPreviousNodeMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMNode.DOMNode), MonadIO m, IsDOMNodeIterator a) => O.MethodInfo DOMNodeIteratorPreviousNodeMethodInfo a signature where
    overloadedMethod _ = dOMNodeIteratorPreviousNode

#endif


