

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2WebExtension.Objects.DOMText
    ( 

-- * Exported types
    DOMText(..)                             ,
    IsDOMText                               ,
    toDOMText                               ,
    noDOMText                               ,


 -- * Methods
-- ** getWholeText #method:getWholeText#

#if ENABLE_OVERLOADING
    DOMTextGetWholeTextMethodInfo           ,
#endif
    dOMTextGetWholeText                     ,


-- ** replaceWholeText #method:replaceWholeText#

#if ENABLE_OVERLOADING
    DOMTextReplaceWholeTextMethodInfo       ,
#endif
    dOMTextReplaceWholeText                 ,


-- ** splitText #method:splitText#

#if ENABLE_OVERLOADING
    DOMTextSplitTextMethodInfo              ,
#endif
    dOMTextSplitText                        ,




 -- * Properties
-- ** wholeText #attr:wholeText#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMTextWholeTextPropertyInfo            ,
#endif
#if ENABLE_OVERLOADING
    dOMTextWholeText                        ,
#endif
    getDOMTextWholeText                     ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Interfaces.DOMEventTarget as WebKit2WebExtension.DOMEventTarget
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMCharacterData as WebKit2WebExtension.DOMCharacterData
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMNode as WebKit2WebExtension.DOMNode
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMObject as WebKit2WebExtension.DOMObject

-- | Memory-managed wrapper type.
newtype DOMText = DOMText (ManagedPtr DOMText)
foreign import ccall "webkit_dom_text_get_type"
    c_webkit_dom_text_get_type :: IO GType

instance GObject DOMText where
    gobjectType = c_webkit_dom_text_get_type
    

-- | Type class for types which can be safely cast to `DOMText`, for instance with `toDOMText`.
class (GObject o, O.IsDescendantOf DOMText o) => IsDOMText o
instance (GObject o, O.IsDescendantOf DOMText o) => IsDOMText o

instance O.HasParentTypes DOMText
type instance O.ParentTypes DOMText = '[WebKit2WebExtension.DOMCharacterData.DOMCharacterData, WebKit2WebExtension.DOMNode.DOMNode, WebKit2WebExtension.DOMObject.DOMObject, GObject.Object.Object, WebKit2WebExtension.DOMEventTarget.DOMEventTarget]

-- | Cast to `DOMText`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toDOMText :: (MonadIO m, IsDOMText o) => o -> m DOMText
toDOMText = liftIO . unsafeCastTo DOMText

-- | A convenience alias for `Nothing` :: `Maybe` `DOMText`.
noDOMText :: Maybe DOMText
noDOMText = Nothing

#if ENABLE_OVERLOADING
type family ResolveDOMTextMethod (t :: Symbol) (o :: *) :: * where
    ResolveDOMTextMethod "addEventListener" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetAddEventListenerMethodInfo
    ResolveDOMTextMethod "appendChild" o = WebKit2WebExtension.DOMNode.DOMNodeAppendChildMethodInfo
    ResolveDOMTextMethod "appendData" o = WebKit2WebExtension.DOMCharacterData.DOMCharacterDataAppendDataMethodInfo
    ResolveDOMTextMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveDOMTextMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveDOMTextMethod "cloneNodeWithError" o = WebKit2WebExtension.DOMNode.DOMNodeCloneNodeWithErrorMethodInfo
    ResolveDOMTextMethod "compareDocumentPosition" o = WebKit2WebExtension.DOMNode.DOMNodeCompareDocumentPositionMethodInfo
    ResolveDOMTextMethod "contains" o = WebKit2WebExtension.DOMNode.DOMNodeContainsMethodInfo
    ResolveDOMTextMethod "deleteData" o = WebKit2WebExtension.DOMCharacterData.DOMCharacterDataDeleteDataMethodInfo
    ResolveDOMTextMethod "dispatchEvent" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetDispatchEventMethodInfo
    ResolveDOMTextMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveDOMTextMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveDOMTextMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveDOMTextMethod "hasChildNodes" o = WebKit2WebExtension.DOMNode.DOMNodeHasChildNodesMethodInfo
    ResolveDOMTextMethod "insertBefore" o = WebKit2WebExtension.DOMNode.DOMNodeInsertBeforeMethodInfo
    ResolveDOMTextMethod "insertData" o = WebKit2WebExtension.DOMCharacterData.DOMCharacterDataInsertDataMethodInfo
    ResolveDOMTextMethod "isDefaultNamespace" o = WebKit2WebExtension.DOMNode.DOMNodeIsDefaultNamespaceMethodInfo
    ResolveDOMTextMethod "isEqualNode" o = WebKit2WebExtension.DOMNode.DOMNodeIsEqualNodeMethodInfo
    ResolveDOMTextMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveDOMTextMethod "isSameNode" o = WebKit2WebExtension.DOMNode.DOMNodeIsSameNodeMethodInfo
    ResolveDOMTextMethod "isSupported" o = WebKit2WebExtension.DOMNode.DOMNodeIsSupportedMethodInfo
    ResolveDOMTextMethod "lookupNamespaceUri" o = WebKit2WebExtension.DOMNode.DOMNodeLookupNamespaceUriMethodInfo
    ResolveDOMTextMethod "lookupPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeLookupPrefixMethodInfo
    ResolveDOMTextMethod "normalize" o = WebKit2WebExtension.DOMNode.DOMNodeNormalizeMethodInfo
    ResolveDOMTextMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveDOMTextMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveDOMTextMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveDOMTextMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveDOMTextMethod "removeChild" o = WebKit2WebExtension.DOMNode.DOMNodeRemoveChildMethodInfo
    ResolveDOMTextMethod "removeEventListener" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetRemoveEventListenerMethodInfo
    ResolveDOMTextMethod "replaceChild" o = WebKit2WebExtension.DOMNode.DOMNodeReplaceChildMethodInfo
    ResolveDOMTextMethod "replaceData" o = WebKit2WebExtension.DOMCharacterData.DOMCharacterDataReplaceDataMethodInfo
    ResolveDOMTextMethod "replaceWholeText" o = DOMTextReplaceWholeTextMethodInfo
    ResolveDOMTextMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveDOMTextMethod "splitText" o = DOMTextSplitTextMethodInfo
    ResolveDOMTextMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveDOMTextMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveDOMTextMethod "substringData" o = WebKit2WebExtension.DOMCharacterData.DOMCharacterDataSubstringDataMethodInfo
    ResolveDOMTextMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveDOMTextMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveDOMTextMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveDOMTextMethod "getBaseUri" o = WebKit2WebExtension.DOMNode.DOMNodeGetBaseUriMethodInfo
    ResolveDOMTextMethod "getChildNodes" o = WebKit2WebExtension.DOMNode.DOMNodeGetChildNodesMethodInfo
    ResolveDOMTextMethod "getData" o = WebKit2WebExtension.DOMCharacterData.DOMCharacterDataGetDataMethodInfo
    ResolveDOMTextMethod "getFirstChild" o = WebKit2WebExtension.DOMNode.DOMNodeGetFirstChildMethodInfo
    ResolveDOMTextMethod "getLastChild" o = WebKit2WebExtension.DOMNode.DOMNodeGetLastChildMethodInfo
    ResolveDOMTextMethod "getLength" o = WebKit2WebExtension.DOMCharacterData.DOMCharacterDataGetLengthMethodInfo
    ResolveDOMTextMethod "getLocalName" o = WebKit2WebExtension.DOMNode.DOMNodeGetLocalNameMethodInfo
    ResolveDOMTextMethod "getNamespaceUri" o = WebKit2WebExtension.DOMNode.DOMNodeGetNamespaceUriMethodInfo
    ResolveDOMTextMethod "getNextSibling" o = WebKit2WebExtension.DOMNode.DOMNodeGetNextSiblingMethodInfo
    ResolveDOMTextMethod "getNodeName" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeNameMethodInfo
    ResolveDOMTextMethod "getNodeType" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeTypeMethodInfo
    ResolveDOMTextMethod "getNodeValue" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeValueMethodInfo
    ResolveDOMTextMethod "getOwnerDocument" o = WebKit2WebExtension.DOMNode.DOMNodeGetOwnerDocumentMethodInfo
    ResolveDOMTextMethod "getParentElement" o = WebKit2WebExtension.DOMNode.DOMNodeGetParentElementMethodInfo
    ResolveDOMTextMethod "getParentNode" o = WebKit2WebExtension.DOMNode.DOMNodeGetParentNodeMethodInfo
    ResolveDOMTextMethod "getPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeGetPrefixMethodInfo
    ResolveDOMTextMethod "getPreviousSibling" o = WebKit2WebExtension.DOMNode.DOMNodeGetPreviousSiblingMethodInfo
    ResolveDOMTextMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveDOMTextMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveDOMTextMethod "getTextContent" o = WebKit2WebExtension.DOMNode.DOMNodeGetTextContentMethodInfo
    ResolveDOMTextMethod "getWholeText" o = DOMTextGetWholeTextMethodInfo
    ResolveDOMTextMethod "setData" o = WebKit2WebExtension.DOMCharacterData.DOMCharacterDataSetDataMethodInfo
    ResolveDOMTextMethod "setNodeValue" o = WebKit2WebExtension.DOMNode.DOMNodeSetNodeValueMethodInfo
    ResolveDOMTextMethod "setPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeSetPrefixMethodInfo
    ResolveDOMTextMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveDOMTextMethod "setTextContent" o = WebKit2WebExtension.DOMNode.DOMNodeSetTextContentMethodInfo
    ResolveDOMTextMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveDOMTextMethod t DOMText, O.MethodInfo info DOMText p) => OL.IsLabel t (DOMText -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "whole-text"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@whole-text@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMText #wholeText
@
-}
getDOMTextWholeText :: (MonadIO m, IsDOMText o) => o -> m (Maybe T.Text)
getDOMTextWholeText obj = liftIO $ B.Properties.getObjectPropertyString obj "whole-text"

#if ENABLE_OVERLOADING
data DOMTextWholeTextPropertyInfo
instance AttrInfo DOMTextWholeTextPropertyInfo where
    type AttrAllowedOps DOMTextWholeTextPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMTextWholeTextPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMTextWholeTextPropertyInfo = IsDOMText
    type AttrGetType DOMTextWholeTextPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMTextWholeTextPropertyInfo = "whole-text"
    type AttrOrigin DOMTextWholeTextPropertyInfo = DOMText
    attrGet _ = getDOMTextWholeText
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList DOMText
type instance O.AttributeList DOMText = DOMTextAttributeList
type DOMTextAttributeList = ('[ '("baseUri", WebKit2WebExtension.DOMNode.DOMNodeBaseUriPropertyInfo), '("childNodes", WebKit2WebExtension.DOMNode.DOMNodeChildNodesPropertyInfo), '("coreObject", WebKit2WebExtension.DOMObject.DOMObjectCoreObjectPropertyInfo), '("data", WebKit2WebExtension.DOMCharacterData.DOMCharacterDataDataPropertyInfo), '("firstChild", WebKit2WebExtension.DOMNode.DOMNodeFirstChildPropertyInfo), '("lastChild", WebKit2WebExtension.DOMNode.DOMNodeLastChildPropertyInfo), '("length", WebKit2WebExtension.DOMCharacterData.DOMCharacterDataLengthPropertyInfo), '("nextSibling", WebKit2WebExtension.DOMNode.DOMNodeNextSiblingPropertyInfo), '("nodeName", WebKit2WebExtension.DOMNode.DOMNodeNodeNamePropertyInfo), '("nodeType", WebKit2WebExtension.DOMNode.DOMNodeNodeTypePropertyInfo), '("nodeValue", WebKit2WebExtension.DOMNode.DOMNodeNodeValuePropertyInfo), '("ownerDocument", WebKit2WebExtension.DOMNode.DOMNodeOwnerDocumentPropertyInfo), '("parentElement", WebKit2WebExtension.DOMNode.DOMNodeParentElementPropertyInfo), '("parentNode", WebKit2WebExtension.DOMNode.DOMNodeParentNodePropertyInfo), '("previousSibling", WebKit2WebExtension.DOMNode.DOMNodePreviousSiblingPropertyInfo), '("textContent", WebKit2WebExtension.DOMNode.DOMNodeTextContentPropertyInfo), '("wholeText", DOMTextWholeTextPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
dOMTextWholeText :: AttrLabelProxy "wholeText"
dOMTextWholeText = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList DOMText = DOMTextSignalList
type DOMTextSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

-- method DOMText::get_whole_text
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMText"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMText", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_text_get_whole_text" webkit_dom_text_get_whole_text :: 
    Ptr DOMText ->                          -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMText"})
    IO CString

{-# DEPRECATED dOMTextGetWholeText ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMTextGetWholeText ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMText a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMText.DOMText' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMTextGetWholeText self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_text_get_whole_text self'
    checkUnexpectedReturnNULL "dOMTextGetWholeText" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMTextGetWholeTextMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMText a) => O.MethodInfo DOMTextGetWholeTextMethodInfo a signature where
    overloadedMethod _ = dOMTextGetWholeText

#endif

-- method DOMText::replace_whole_text
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMText"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMText", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "content", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMText"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_text_replace_whole_text" webkit_dom_text_replace_whole_text :: 
    Ptr DOMText ->                          -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMText"})
    CString ->                              -- content : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMText)

{-# DEPRECATED dOMTextReplaceWholeText ["(Since version 2.14)"] #-}
{- |
/No description available in the introspection data./
-}
dOMTextReplaceWholeText ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMText a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMText.DOMText' -}
    -> T.Text
    {- ^ /@content@/: A @/gchar/@ -}
    -> m DOMText
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMText.DOMText' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMTextReplaceWholeText self content = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    content' <- textToCString content
    onException (do
        result <- propagateGError $ webkit_dom_text_replace_whole_text self' content'
        checkUnexpectedReturnNULL "dOMTextReplaceWholeText" result
        result' <- (newObject DOMText) result
        touchManagedPtr self
        freeMem content'
        return result'
     ) (do
        freeMem content'
     )

#if ENABLE_OVERLOADING
data DOMTextReplaceWholeTextMethodInfo
instance (signature ~ (T.Text -> m DOMText), MonadIO m, IsDOMText a) => O.MethodInfo DOMTextReplaceWholeTextMethodInfo a signature where
    overloadedMethod _ = dOMTextReplaceWholeText

#endif

-- method DOMText::split_text
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMText"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMText", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "offset", argType = TBasicType TULong, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gulong", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMText"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_text_split_text" webkit_dom_text_split_text :: 
    Ptr DOMText ->                          -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMText"})
    CULong ->                               -- offset : TBasicType TULong
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMText)

{-# DEPRECATED dOMTextSplitText ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMTextSplitText ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMText a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMText.DOMText' -}
    -> CULong
    {- ^ /@offset@/: A @/gulong/@ -}
    -> m DOMText
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMText.DOMText' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMTextSplitText self offset = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    onException (do
        result <- propagateGError $ webkit_dom_text_split_text self' offset
        checkUnexpectedReturnNULL "dOMTextSplitText" result
        result' <- (newObject DOMText) result
        touchManagedPtr self
        return result'
     ) (do
        return ()
     )

#if ENABLE_OVERLOADING
data DOMTextSplitTextMethodInfo
instance (signature ~ (CULong -> m DOMText), MonadIO m, IsDOMText a) => O.MethodInfo DOMTextSplitTextMethodInfo a signature where
    overloadedMethod _ = dOMTextSplitText

#endif


