

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2WebExtension.Objects.WebEditor
    ( 

-- * Exported types
    WebEditor(..)                           ,
    IsWebEditor                             ,
    toWebEditor                             ,
    noWebEditor                             ,


 -- * Methods
-- ** getPage #method:getPage#

#if ENABLE_OVERLOADING
    WebEditorGetPageMethodInfo              ,
#endif
    webEditorGetPage                        ,




 -- * Signals
-- ** selectionChanged #signal:selectionChanged#

    C_WebEditorSelectionChangedCallback     ,
    WebEditorSelectionChangedCallback       ,
#if ENABLE_OVERLOADING
    WebEditorSelectionChangedSignalInfo     ,
#endif
    afterWebEditorSelectionChanged          ,
    genClosure_WebEditorSelectionChanged    ,
    mk_WebEditorSelectionChangedCallback    ,
    noWebEditorSelectionChangedCallback     ,
    onWebEditorSelectionChanged             ,
    wrap_WebEditorSelectionChangedCallback  ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.WebPage as WebKit2WebExtension.WebPage

-- | Memory-managed wrapper type.
newtype WebEditor = WebEditor (ManagedPtr WebEditor)
foreign import ccall "webkit_web_editor_get_type"
    c_webkit_web_editor_get_type :: IO GType

instance GObject WebEditor where
    gobjectType = c_webkit_web_editor_get_type
    

-- | Type class for types which can be safely cast to `WebEditor`, for instance with `toWebEditor`.
class (GObject o, O.IsDescendantOf WebEditor o) => IsWebEditor o
instance (GObject o, O.IsDescendantOf WebEditor o) => IsWebEditor o

instance O.HasParentTypes WebEditor
type instance O.ParentTypes WebEditor = '[GObject.Object.Object]

-- | Cast to `WebEditor`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toWebEditor :: (MonadIO m, IsWebEditor o) => o -> m WebEditor
toWebEditor = liftIO . unsafeCastTo WebEditor

-- | A convenience alias for `Nothing` :: `Maybe` `WebEditor`.
noWebEditor :: Maybe WebEditor
noWebEditor = Nothing

#if ENABLE_OVERLOADING
type family ResolveWebEditorMethod (t :: Symbol) (o :: *) :: * where
    ResolveWebEditorMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveWebEditorMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveWebEditorMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveWebEditorMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveWebEditorMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveWebEditorMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveWebEditorMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveWebEditorMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveWebEditorMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveWebEditorMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveWebEditorMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveWebEditorMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveWebEditorMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveWebEditorMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveWebEditorMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveWebEditorMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveWebEditorMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveWebEditorMethod "getPage" o = WebEditorGetPageMethodInfo
    ResolveWebEditorMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveWebEditorMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveWebEditorMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveWebEditorMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveWebEditorMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveWebEditorMethod t WebEditor, O.MethodInfo info WebEditor p) => OL.IsLabel t (WebEditor -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- signal WebEditor::selection-changed
{- |
This signal is emitted for every selection change inside a 'GI.WebKit2WebExtension.Objects.WebPage.WebPage'
as well as for every caret position change as the caret is a collapsed
selection.

/Since: 2.10/
-}
type WebEditorSelectionChangedCallback =
    IO ()

-- | A convenience synonym for @`Nothing` :: `Maybe` `WebEditorSelectionChangedCallback`@.
noWebEditorSelectionChangedCallback :: Maybe WebEditorSelectionChangedCallback
noWebEditorSelectionChangedCallback = Nothing

-- | Type for the callback on the (unwrapped) C side.
type C_WebEditorSelectionChangedCallback =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

-- | Generate a function pointer callable from C code, from a `C_WebEditorSelectionChangedCallback`.
foreign import ccall "wrapper"
    mk_WebEditorSelectionChangedCallback :: C_WebEditorSelectionChangedCallback -> IO (FunPtr C_WebEditorSelectionChangedCallback)

-- | Wrap the callback into a `GClosure`.
genClosure_WebEditorSelectionChanged :: MonadIO m => WebEditorSelectionChangedCallback -> m (GClosure C_WebEditorSelectionChangedCallback)
genClosure_WebEditorSelectionChanged cb = liftIO $ do
    let cb' = wrap_WebEditorSelectionChangedCallback cb
    mk_WebEditorSelectionChangedCallback cb' >>= B.GClosure.newGClosure


-- | Wrap a `WebEditorSelectionChangedCallback` into a `C_WebEditorSelectionChangedCallback`.
wrap_WebEditorSelectionChangedCallback ::
    WebEditorSelectionChangedCallback ->
    C_WebEditorSelectionChangedCallback
wrap_WebEditorSelectionChangedCallback _cb _ _ = do
    _cb 


{- |
Connect a signal handler for the “@selection-changed@” signal, to be run before the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.on' webEditor #selectionChanged callback
@
-}
onWebEditorSelectionChanged :: (IsWebEditor a, MonadIO m) => a -> WebEditorSelectionChangedCallback -> m SignalHandlerId
onWebEditorSelectionChanged obj cb = liftIO $ do
    let cb' = wrap_WebEditorSelectionChangedCallback cb
    cb'' <- mk_WebEditorSelectionChangedCallback cb'
    connectSignalFunPtr obj "selection-changed" cb'' SignalConnectBefore

{- |
Connect a signal handler for the “@selection-changed@” signal, to be run after the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.after' webEditor #selectionChanged callback
@
-}
afterWebEditorSelectionChanged :: (IsWebEditor a, MonadIO m) => a -> WebEditorSelectionChangedCallback -> m SignalHandlerId
afterWebEditorSelectionChanged obj cb = liftIO $ do
    let cb' = wrap_WebEditorSelectionChangedCallback cb
    cb'' <- mk_WebEditorSelectionChangedCallback cb'
    connectSignalFunPtr obj "selection-changed" cb'' SignalConnectAfter


#if ENABLE_OVERLOADING
instance O.HasAttributeList WebEditor
type instance O.AttributeList WebEditor = WebEditorAttributeList
type WebEditorAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
data WebEditorSelectionChangedSignalInfo
instance SignalInfo WebEditorSelectionChangedSignalInfo where
    type HaskellCallbackType WebEditorSelectionChangedSignalInfo = WebEditorSelectionChangedCallback
    connectSignal _ obj cb connectMode = do
        let cb' = wrap_WebEditorSelectionChangedCallback cb
        cb'' <- mk_WebEditorSelectionChangedCallback cb'
        connectSignalFunPtr obj "selection-changed" cb'' connectMode

type instance O.SignalList WebEditor = WebEditorSignalList
type WebEditorSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo), '("selectionChanged", WebEditorSelectionChangedSignalInfo)] :: [(Symbol, *)])

#endif

-- method WebEditor::get_page
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "editor", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "WebEditor"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitWebEditor", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "WebPage"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_web_editor_get_page" webkit_web_editor_get_page :: 
    Ptr WebEditor ->                        -- editor : TInterface (Name {namespace = "WebKit2WebExtension", name = "WebEditor"})
    IO (Ptr WebKit2WebExtension.WebPage.WebPage)

{- |
Gets the 'GI.WebKit2WebExtension.Objects.WebPage.WebPage' that is associated with the 'GI.WebKit2WebExtension.Objects.WebEditor.WebEditor' that can
be used to access the 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' currently loaded into it.

/Since: 2.10/
-}
webEditorGetPage ::
    (B.CallStack.HasCallStack, MonadIO m, IsWebEditor a) =>
    a
    {- ^ /@editor@/: a 'GI.WebKit2WebExtension.Objects.WebEditor.WebEditor' -}
    -> m WebKit2WebExtension.WebPage.WebPage
    {- ^ __Returns:__ the associated 'GI.WebKit2WebExtension.Objects.WebPage.WebPage' -}
webEditorGetPage editor = liftIO $ do
    editor' <- unsafeManagedPtrCastPtr editor
    result <- webkit_web_editor_get_page editor'
    checkUnexpectedReturnNULL "webEditorGetPage" result
    result' <- (newObject WebKit2WebExtension.WebPage.WebPage) result
    touchManagedPtr editor
    return result'

#if ENABLE_OVERLOADING
data WebEditorGetPageMethodInfo
instance (signature ~ (m WebKit2WebExtension.WebPage.WebPage), MonadIO m, IsWebEditor a) => O.MethodInfo WebEditorGetPageMethodInfo a signature where
    overloadedMethod _ = webEditorGetPage

#endif


