

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2WebExtension.Objects.DOMDocument
    ( 

-- * Exported types
    DOMDocument(..)                         ,
    IsDOMDocument                           ,
    toDOMDocument                           ,
    noDOMDocument                           ,


 -- * Methods
-- ** adoptNode #method:adoptNode#

#if ENABLE_OVERLOADING
    DOMDocumentAdoptNodeMethodInfo          ,
#endif
    dOMDocumentAdoptNode                    ,


-- ** caretRangeFromPoint #method:caretRangeFromPoint#

#if ENABLE_OVERLOADING
    DOMDocumentCaretRangeFromPointMethodInfo,
#endif
    dOMDocumentCaretRangeFromPoint          ,


-- ** createAttribute #method:createAttribute#

#if ENABLE_OVERLOADING
    DOMDocumentCreateAttributeMethodInfo    ,
#endif
    dOMDocumentCreateAttribute              ,


-- ** createAttributeNs #method:createAttributeNs#

#if ENABLE_OVERLOADING
    DOMDocumentCreateAttributeNsMethodInfo  ,
#endif
    dOMDocumentCreateAttributeNs            ,


-- ** createCdataSection #method:createCdataSection#

#if ENABLE_OVERLOADING
    DOMDocumentCreateCdataSectionMethodInfo ,
#endif
    dOMDocumentCreateCdataSection           ,


-- ** createComment #method:createComment#

#if ENABLE_OVERLOADING
    DOMDocumentCreateCommentMethodInfo      ,
#endif
    dOMDocumentCreateComment                ,


-- ** createCssStyleDeclaration #method:createCssStyleDeclaration#

#if ENABLE_OVERLOADING
    DOMDocumentCreateCssStyleDeclarationMethodInfo,
#endif
    dOMDocumentCreateCssStyleDeclaration    ,


-- ** createDocumentFragment #method:createDocumentFragment#

#if ENABLE_OVERLOADING
    DOMDocumentCreateDocumentFragmentMethodInfo,
#endif
    dOMDocumentCreateDocumentFragment       ,


-- ** createElement #method:createElement#

#if ENABLE_OVERLOADING
    DOMDocumentCreateElementMethodInfo      ,
#endif
    dOMDocumentCreateElement                ,


-- ** createElementNs #method:createElementNs#

#if ENABLE_OVERLOADING
    DOMDocumentCreateElementNsMethodInfo    ,
#endif
    dOMDocumentCreateElementNs              ,


-- ** createEntityReference #method:createEntityReference#

#if ENABLE_OVERLOADING
    DOMDocumentCreateEntityReferenceMethodInfo,
#endif
    dOMDocumentCreateEntityReference        ,


-- ** createEvent #method:createEvent#

#if ENABLE_OVERLOADING
    DOMDocumentCreateEventMethodInfo        ,
#endif
    dOMDocumentCreateEvent                  ,


-- ** createExpression #method:createExpression#

#if ENABLE_OVERLOADING
    DOMDocumentCreateExpressionMethodInfo   ,
#endif
    dOMDocumentCreateExpression             ,


-- ** createNodeIterator #method:createNodeIterator#

#if ENABLE_OVERLOADING
    DOMDocumentCreateNodeIteratorMethodInfo ,
#endif
    dOMDocumentCreateNodeIterator           ,


-- ** createNsResolver #method:createNsResolver#

#if ENABLE_OVERLOADING
    DOMDocumentCreateNsResolverMethodInfo   ,
#endif
    dOMDocumentCreateNsResolver             ,


-- ** createProcessingInstruction #method:createProcessingInstruction#

#if ENABLE_OVERLOADING
    DOMDocumentCreateProcessingInstructionMethodInfo,
#endif
    dOMDocumentCreateProcessingInstruction  ,


-- ** createRange #method:createRange#

#if ENABLE_OVERLOADING
    DOMDocumentCreateRangeMethodInfo        ,
#endif
    dOMDocumentCreateRange                  ,


-- ** createTextNode #method:createTextNode#

#if ENABLE_OVERLOADING
    DOMDocumentCreateTextNodeMethodInfo     ,
#endif
    dOMDocumentCreateTextNode               ,


-- ** createTreeWalker #method:createTreeWalker#

#if ENABLE_OVERLOADING
    DOMDocumentCreateTreeWalkerMethodInfo   ,
#endif
    dOMDocumentCreateTreeWalker             ,


-- ** elementFromPoint #method:elementFromPoint#

#if ENABLE_OVERLOADING
    DOMDocumentElementFromPointMethodInfo   ,
#endif
    dOMDocumentElementFromPoint             ,


-- ** evaluate #method:evaluate#

#if ENABLE_OVERLOADING
    DOMDocumentEvaluateMethodInfo           ,
#endif
    dOMDocumentEvaluate                     ,


-- ** execCommand #method:execCommand#

#if ENABLE_OVERLOADING
    DOMDocumentExecCommandMethodInfo        ,
#endif
    dOMDocumentExecCommand                  ,


-- ** exitPointerLock #method:exitPointerLock#

#if ENABLE_OVERLOADING
    DOMDocumentExitPointerLockMethodInfo    ,
#endif
    dOMDocumentExitPointerLock              ,


-- ** getActiveElement #method:getActiveElement#

#if ENABLE_OVERLOADING
    DOMDocumentGetActiveElementMethodInfo   ,
#endif
    dOMDocumentGetActiveElement             ,


-- ** getAnchors #method:getAnchors#

#if ENABLE_OVERLOADING
    DOMDocumentGetAnchorsMethodInfo         ,
#endif
    dOMDocumentGetAnchors                   ,


-- ** getApplets #method:getApplets#

#if ENABLE_OVERLOADING
    DOMDocumentGetAppletsMethodInfo         ,
#endif
    dOMDocumentGetApplets                   ,


-- ** getBody #method:getBody#

#if ENABLE_OVERLOADING
    DOMDocumentGetBodyMethodInfo            ,
#endif
    dOMDocumentGetBody                      ,


-- ** getCharacterSet #method:getCharacterSet#

#if ENABLE_OVERLOADING
    DOMDocumentGetCharacterSetMethodInfo    ,
#endif
    dOMDocumentGetCharacterSet              ,


-- ** getCharset #method:getCharset#

#if ENABLE_OVERLOADING
    DOMDocumentGetCharsetMethodInfo         ,
#endif
    dOMDocumentGetCharset                   ,


-- ** getChildElementCount #method:getChildElementCount#

#if ENABLE_OVERLOADING
    DOMDocumentGetChildElementCountMethodInfo,
#endif
    dOMDocumentGetChildElementCount         ,


-- ** getChildren #method:getChildren#

#if ENABLE_OVERLOADING
    DOMDocumentGetChildrenMethodInfo        ,
#endif
    dOMDocumentGetChildren                  ,


-- ** getCompatMode #method:getCompatMode#

#if ENABLE_OVERLOADING
    DOMDocumentGetCompatModeMethodInfo      ,
#endif
    dOMDocumentGetCompatMode                ,


-- ** getContentType #method:getContentType#

#if ENABLE_OVERLOADING
    DOMDocumentGetContentTypeMethodInfo     ,
#endif
    dOMDocumentGetContentType               ,


-- ** getCookie #method:getCookie#

#if ENABLE_OVERLOADING
    DOMDocumentGetCookieMethodInfo          ,
#endif
    dOMDocumentGetCookie                    ,


-- ** getCurrentScript #method:getCurrentScript#

#if ENABLE_OVERLOADING
    DOMDocumentGetCurrentScriptMethodInfo   ,
#endif
    dOMDocumentGetCurrentScript             ,


-- ** getDefaultCharset #method:getDefaultCharset#

#if ENABLE_OVERLOADING
    DOMDocumentGetDefaultCharsetMethodInfo  ,
#endif
    dOMDocumentGetDefaultCharset            ,


-- ** getDefaultView #method:getDefaultView#

#if ENABLE_OVERLOADING
    DOMDocumentGetDefaultViewMethodInfo     ,
#endif
    dOMDocumentGetDefaultView               ,


-- ** getDesignMode #method:getDesignMode#

#if ENABLE_OVERLOADING
    DOMDocumentGetDesignModeMethodInfo      ,
#endif
    dOMDocumentGetDesignMode                ,


-- ** getDir #method:getDir#

#if ENABLE_OVERLOADING
    DOMDocumentGetDirMethodInfo             ,
#endif
    dOMDocumentGetDir                       ,


-- ** getDoctype #method:getDoctype#

#if ENABLE_OVERLOADING
    DOMDocumentGetDoctypeMethodInfo         ,
#endif
    dOMDocumentGetDoctype                   ,


-- ** getDocumentElement #method:getDocumentElement#

#if ENABLE_OVERLOADING
    DOMDocumentGetDocumentElementMethodInfo ,
#endif
    dOMDocumentGetDocumentElement           ,


-- ** getDocumentUri #method:getDocumentUri#

#if ENABLE_OVERLOADING
    DOMDocumentGetDocumentUriMethodInfo     ,
#endif
    dOMDocumentGetDocumentUri               ,


-- ** getDomain #method:getDomain#

#if ENABLE_OVERLOADING
    DOMDocumentGetDomainMethodInfo          ,
#endif
    dOMDocumentGetDomain                    ,


-- ** getElementById #method:getElementById#

#if ENABLE_OVERLOADING
    DOMDocumentGetElementByIdMethodInfo     ,
#endif
    dOMDocumentGetElementById               ,


-- ** getElementsByClassName #method:getElementsByClassName#

#if ENABLE_OVERLOADING
    DOMDocumentGetElementsByClassNameMethodInfo,
#endif
    dOMDocumentGetElementsByClassName       ,


-- ** getElementsByClassNameAsHtmlCollection #method:getElementsByClassNameAsHtmlCollection#

#if ENABLE_OVERLOADING
    DOMDocumentGetElementsByClassNameAsHtmlCollectionMethodInfo,
#endif
    dOMDocumentGetElementsByClassNameAsHtmlCollection,


-- ** getElementsByName #method:getElementsByName#

#if ENABLE_OVERLOADING
    DOMDocumentGetElementsByNameMethodInfo  ,
#endif
    dOMDocumentGetElementsByName            ,


-- ** getElementsByTagName #method:getElementsByTagName#

#if ENABLE_OVERLOADING
    DOMDocumentGetElementsByTagNameMethodInfo,
#endif
    dOMDocumentGetElementsByTagName         ,


-- ** getElementsByTagNameAsHtmlCollection #method:getElementsByTagNameAsHtmlCollection#

#if ENABLE_OVERLOADING
    DOMDocumentGetElementsByTagNameAsHtmlCollectionMethodInfo,
#endif
    dOMDocumentGetElementsByTagNameAsHtmlCollection,


-- ** getElementsByTagNameNs #method:getElementsByTagNameNs#

#if ENABLE_OVERLOADING
    DOMDocumentGetElementsByTagNameNsMethodInfo,
#endif
    dOMDocumentGetElementsByTagNameNs       ,


-- ** getElementsByTagNameNsAsHtmlCollection #method:getElementsByTagNameNsAsHtmlCollection#

#if ENABLE_OVERLOADING
    DOMDocumentGetElementsByTagNameNsAsHtmlCollectionMethodInfo,
#endif
    dOMDocumentGetElementsByTagNameNsAsHtmlCollection,


-- ** getEmbeds #method:getEmbeds#

#if ENABLE_OVERLOADING
    DOMDocumentGetEmbedsMethodInfo          ,
#endif
    dOMDocumentGetEmbeds                    ,


-- ** getFirstElementChild #method:getFirstElementChild#

#if ENABLE_OVERLOADING
    DOMDocumentGetFirstElementChildMethodInfo,
#endif
    dOMDocumentGetFirstElementChild         ,


-- ** getForms #method:getForms#

#if ENABLE_OVERLOADING
    DOMDocumentGetFormsMethodInfo           ,
#endif
    dOMDocumentGetForms                     ,


-- ** getHead #method:getHead#

#if ENABLE_OVERLOADING
    DOMDocumentGetHeadMethodInfo            ,
#endif
    dOMDocumentGetHead                      ,


-- ** getHidden #method:getHidden#

#if ENABLE_OVERLOADING
    DOMDocumentGetHiddenMethodInfo          ,
#endif
    dOMDocumentGetHidden                    ,


-- ** getImages #method:getImages#

#if ENABLE_OVERLOADING
    DOMDocumentGetImagesMethodInfo          ,
#endif
    dOMDocumentGetImages                    ,


-- ** getImplementation #method:getImplementation#

#if ENABLE_OVERLOADING
    DOMDocumentGetImplementationMethodInfo  ,
#endif
    dOMDocumentGetImplementation            ,


-- ** getInputEncoding #method:getInputEncoding#

#if ENABLE_OVERLOADING
    DOMDocumentGetInputEncodingMethodInfo   ,
#endif
    dOMDocumentGetInputEncoding             ,


-- ** getLastElementChild #method:getLastElementChild#

#if ENABLE_OVERLOADING
    DOMDocumentGetLastElementChildMethodInfo,
#endif
    dOMDocumentGetLastElementChild          ,


-- ** getLastModified #method:getLastModified#

#if ENABLE_OVERLOADING
    DOMDocumentGetLastModifiedMethodInfo    ,
#endif
    dOMDocumentGetLastModified              ,


-- ** getLinks #method:getLinks#

#if ENABLE_OVERLOADING
    DOMDocumentGetLinksMethodInfo           ,
#endif
    dOMDocumentGetLinks                     ,


-- ** getOrigin #method:getOrigin#

#if ENABLE_OVERLOADING
    DOMDocumentGetOriginMethodInfo          ,
#endif
    dOMDocumentGetOrigin                    ,


-- ** getOverrideStyle #method:getOverrideStyle#

#if ENABLE_OVERLOADING
    DOMDocumentGetOverrideStyleMethodInfo   ,
#endif
    dOMDocumentGetOverrideStyle             ,


-- ** getPlugins #method:getPlugins#

#if ENABLE_OVERLOADING
    DOMDocumentGetPluginsMethodInfo         ,
#endif
    dOMDocumentGetPlugins                   ,


-- ** getPointerLockElement #method:getPointerLockElement#

#if ENABLE_OVERLOADING
    DOMDocumentGetPointerLockElementMethodInfo,
#endif
    dOMDocumentGetPointerLockElement        ,


-- ** getPreferredStylesheetSet #method:getPreferredStylesheetSet#

#if ENABLE_OVERLOADING
    DOMDocumentGetPreferredStylesheetSetMethodInfo,
#endif
    dOMDocumentGetPreferredStylesheetSet    ,


-- ** getReadyState #method:getReadyState#

#if ENABLE_OVERLOADING
    DOMDocumentGetReadyStateMethodInfo      ,
#endif
    dOMDocumentGetReadyState                ,


-- ** getReferrer #method:getReferrer#

#if ENABLE_OVERLOADING
    DOMDocumentGetReferrerMethodInfo        ,
#endif
    dOMDocumentGetReferrer                  ,


-- ** getScripts #method:getScripts#

#if ENABLE_OVERLOADING
    DOMDocumentGetScriptsMethodInfo         ,
#endif
    dOMDocumentGetScripts                   ,


-- ** getScrollingElement #method:getScrollingElement#

#if ENABLE_OVERLOADING
    DOMDocumentGetScrollingElementMethodInfo,
#endif
    dOMDocumentGetScrollingElement          ,


-- ** getSelectedStylesheetSet #method:getSelectedStylesheetSet#

#if ENABLE_OVERLOADING
    DOMDocumentGetSelectedStylesheetSetMethodInfo,
#endif
    dOMDocumentGetSelectedStylesheetSet     ,


-- ** getStyleSheets #method:getStyleSheets#

#if ENABLE_OVERLOADING
    DOMDocumentGetStyleSheetsMethodInfo     ,
#endif
    dOMDocumentGetStyleSheets               ,


-- ** getTitle #method:getTitle#

#if ENABLE_OVERLOADING
    DOMDocumentGetTitleMethodInfo           ,
#endif
    dOMDocumentGetTitle                     ,


-- ** getUrl #method:getUrl#

#if ENABLE_OVERLOADING
    DOMDocumentGetUrlMethodInfo             ,
#endif
    dOMDocumentGetUrl                       ,


-- ** getVisibilityState #method:getVisibilityState#

#if ENABLE_OVERLOADING
    DOMDocumentGetVisibilityStateMethodInfo ,
#endif
    dOMDocumentGetVisibilityState           ,


-- ** getWebkitCurrentFullscreenElement #method:getWebkitCurrentFullscreenElement#

#if ENABLE_OVERLOADING
    DOMDocumentGetWebkitCurrentFullscreenElementMethodInfo,
#endif
    dOMDocumentGetWebkitCurrentFullscreenElement,


-- ** getWebkitFullscreenElement #method:getWebkitFullscreenElement#

#if ENABLE_OVERLOADING
    DOMDocumentGetWebkitFullscreenElementMethodInfo,
#endif
    dOMDocumentGetWebkitFullscreenElement   ,


-- ** getWebkitFullscreenEnabled #method:getWebkitFullscreenEnabled#

#if ENABLE_OVERLOADING
    DOMDocumentGetWebkitFullscreenEnabledMethodInfo,
#endif
    dOMDocumentGetWebkitFullscreenEnabled   ,


-- ** getWebkitFullscreenKeyboardInputAllowed #method:getWebkitFullscreenKeyboardInputAllowed#

#if ENABLE_OVERLOADING
    DOMDocumentGetWebkitFullscreenKeyboardInputAllowedMethodInfo,
#endif
    dOMDocumentGetWebkitFullscreenKeyboardInputAllowed,


-- ** getWebkitIsFullscreen #method:getWebkitIsFullscreen#

#if ENABLE_OVERLOADING
    DOMDocumentGetWebkitIsFullscreenMethodInfo,
#endif
    dOMDocumentGetWebkitIsFullscreen        ,


-- ** getXmlEncoding #method:getXmlEncoding#

#if ENABLE_OVERLOADING
    DOMDocumentGetXmlEncodingMethodInfo     ,
#endif
    dOMDocumentGetXmlEncoding               ,


-- ** getXmlStandalone #method:getXmlStandalone#

#if ENABLE_OVERLOADING
    DOMDocumentGetXmlStandaloneMethodInfo   ,
#endif
    dOMDocumentGetXmlStandalone             ,


-- ** getXmlVersion #method:getXmlVersion#

#if ENABLE_OVERLOADING
    DOMDocumentGetXmlVersionMethodInfo      ,
#endif
    dOMDocumentGetXmlVersion                ,


-- ** hasFocus #method:hasFocus#

#if ENABLE_OVERLOADING
    DOMDocumentHasFocusMethodInfo           ,
#endif
    dOMDocumentHasFocus                     ,


-- ** importNode #method:importNode#

#if ENABLE_OVERLOADING
    DOMDocumentImportNodeMethodInfo         ,
#endif
    dOMDocumentImportNode                   ,


-- ** queryCommandEnabled #method:queryCommandEnabled#

#if ENABLE_OVERLOADING
    DOMDocumentQueryCommandEnabledMethodInfo,
#endif
    dOMDocumentQueryCommandEnabled          ,


-- ** queryCommandIndeterm #method:queryCommandIndeterm#

#if ENABLE_OVERLOADING
    DOMDocumentQueryCommandIndetermMethodInfo,
#endif
    dOMDocumentQueryCommandIndeterm         ,


-- ** queryCommandState #method:queryCommandState#

#if ENABLE_OVERLOADING
    DOMDocumentQueryCommandStateMethodInfo  ,
#endif
    dOMDocumentQueryCommandState            ,


-- ** queryCommandSupported #method:queryCommandSupported#

#if ENABLE_OVERLOADING
    DOMDocumentQueryCommandSupportedMethodInfo,
#endif
    dOMDocumentQueryCommandSupported        ,


-- ** queryCommandValue #method:queryCommandValue#

#if ENABLE_OVERLOADING
    DOMDocumentQueryCommandValueMethodInfo  ,
#endif
    dOMDocumentQueryCommandValue            ,


-- ** querySelector #method:querySelector#

#if ENABLE_OVERLOADING
    DOMDocumentQuerySelectorMethodInfo      ,
#endif
    dOMDocumentQuerySelector                ,


-- ** querySelectorAll #method:querySelectorAll#

#if ENABLE_OVERLOADING
    DOMDocumentQuerySelectorAllMethodInfo   ,
#endif
    dOMDocumentQuerySelectorAll             ,


-- ** setBody #method:setBody#

#if ENABLE_OVERLOADING
    DOMDocumentSetBodyMethodInfo            ,
#endif
    dOMDocumentSetBody                      ,


-- ** setCharset #method:setCharset#

#if ENABLE_OVERLOADING
    DOMDocumentSetCharsetMethodInfo         ,
#endif
    dOMDocumentSetCharset                   ,


-- ** setCookie #method:setCookie#

#if ENABLE_OVERLOADING
    DOMDocumentSetCookieMethodInfo          ,
#endif
    dOMDocumentSetCookie                    ,


-- ** setDesignMode #method:setDesignMode#

#if ENABLE_OVERLOADING
    DOMDocumentSetDesignModeMethodInfo      ,
#endif
    dOMDocumentSetDesignMode                ,


-- ** setDir #method:setDir#

#if ENABLE_OVERLOADING
    DOMDocumentSetDirMethodInfo             ,
#endif
    dOMDocumentSetDir                       ,


-- ** setDocumentUri #method:setDocumentUri#

#if ENABLE_OVERLOADING
    DOMDocumentSetDocumentUriMethodInfo     ,
#endif
    dOMDocumentSetDocumentUri               ,


-- ** setSelectedStylesheetSet #method:setSelectedStylesheetSet#

#if ENABLE_OVERLOADING
    DOMDocumentSetSelectedStylesheetSetMethodInfo,
#endif
    dOMDocumentSetSelectedStylesheetSet     ,


-- ** setTitle #method:setTitle#

#if ENABLE_OVERLOADING
    DOMDocumentSetTitleMethodInfo           ,
#endif
    dOMDocumentSetTitle                     ,


-- ** setXmlStandalone #method:setXmlStandalone#

#if ENABLE_OVERLOADING
    DOMDocumentSetXmlStandaloneMethodInfo   ,
#endif
    dOMDocumentSetXmlStandalone             ,


-- ** setXmlVersion #method:setXmlVersion#

#if ENABLE_OVERLOADING
    DOMDocumentSetXmlVersionMethodInfo      ,
#endif
    dOMDocumentSetXmlVersion                ,


-- ** webkitCancelFullscreen #method:webkitCancelFullscreen#

#if ENABLE_OVERLOADING
    DOMDocumentWebkitCancelFullscreenMethodInfo,
#endif
    dOMDocumentWebkitCancelFullscreen       ,


-- ** webkitExitFullscreen #method:webkitExitFullscreen#

#if ENABLE_OVERLOADING
    DOMDocumentWebkitExitFullscreenMethodInfo,
#endif
    dOMDocumentWebkitExitFullscreen         ,




 -- * Properties
-- ** activeElement #attr:activeElement#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentActiveElementPropertyInfo    ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentActiveElement                ,
#endif
    getDOMDocumentActiveElement             ,


-- ** anchors #attr:anchors#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentAnchorsPropertyInfo          ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentAnchors                      ,
#endif
    getDOMDocumentAnchors                   ,


-- ** applets #attr:applets#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentAppletsPropertyInfo          ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentApplets                      ,
#endif
    getDOMDocumentApplets                   ,


-- ** body #attr:body#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentBodyPropertyInfo             ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentBody                         ,
#endif
    getDOMDocumentBody                      ,


-- ** characterSet #attr:characterSet#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentCharacterSetPropertyInfo     ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentCharacterSet                 ,
#endif
    getDOMDocumentCharacterSet              ,


-- ** charset #attr:charset#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentCharsetPropertyInfo          ,
#endif
    constructDOMDocumentCharset             ,
#if ENABLE_OVERLOADING
    dOMDocumentCharset                      ,
#endif
    getDOMDocumentCharset                   ,
    setDOMDocumentCharset                   ,


-- ** childElementCount #attr:childElementCount#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentChildElementCountPropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentChildElementCount            ,
#endif
    getDOMDocumentChildElementCount         ,


-- ** children #attr:children#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentChildrenPropertyInfo         ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentChildren                     ,
#endif
    getDOMDocumentChildren                  ,


-- ** compatMode #attr:compatMode#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentCompatModePropertyInfo       ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentCompatMode                   ,
#endif
    getDOMDocumentCompatMode                ,


-- ** contentType #attr:contentType#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentContentTypePropertyInfo      ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentContentType                  ,
#endif
    getDOMDocumentContentType               ,


-- ** cookie #attr:cookie#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentCookiePropertyInfo           ,
#endif
    clearDOMDocumentCookie                  ,
    constructDOMDocumentCookie              ,
#if ENABLE_OVERLOADING
    dOMDocumentCookie                       ,
#endif
    getDOMDocumentCookie                    ,
    setDOMDocumentCookie                    ,


-- ** currentScript #attr:currentScript#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentCurrentScriptPropertyInfo    ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentCurrentScript                ,
#endif
    getDOMDocumentCurrentScript             ,


-- ** defaultView #attr:defaultView#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentDefaultViewPropertyInfo      ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentDefaultView                  ,
#endif
    getDOMDocumentDefaultView               ,


-- ** designMode #attr:designMode#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentDesignModePropertyInfo       ,
#endif
    constructDOMDocumentDesignMode          ,
#if ENABLE_OVERLOADING
    dOMDocumentDesignMode                   ,
#endif
    getDOMDocumentDesignMode                ,
    setDOMDocumentDesignMode                ,


-- ** dir #attr:dir#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentDirPropertyInfo              ,
#endif
    constructDOMDocumentDir                 ,
#if ENABLE_OVERLOADING
    dOMDocumentDir                          ,
#endif
    getDOMDocumentDir                       ,
    setDOMDocumentDir                       ,


-- ** doctype #attr:doctype#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentDoctypePropertyInfo          ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentDoctype                      ,
#endif
    getDOMDocumentDoctype                   ,


-- ** documentElement #attr:documentElement#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentDocumentElementPropertyInfo  ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentDocumentElement              ,
#endif
    getDOMDocumentDocumentElement           ,


-- ** documentUri #attr:documentUri#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentDocumentUriPropertyInfo      ,
#endif
    constructDOMDocumentDocumentUri         ,
#if ENABLE_OVERLOADING
    dOMDocumentDocumentUri                  ,
#endif
    getDOMDocumentDocumentUri               ,
    setDOMDocumentDocumentUri               ,


-- ** domain #attr:domain#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentDomainPropertyInfo           ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentDomain                       ,
#endif
    getDOMDocumentDomain                    ,


-- ** embeds #attr:embeds#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentEmbedsPropertyInfo           ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentEmbeds                       ,
#endif
    getDOMDocumentEmbeds                    ,


-- ** firstElementChild #attr:firstElementChild#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentFirstElementChildPropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentFirstElementChild            ,
#endif
    getDOMDocumentFirstElementChild         ,


-- ** forms #attr:forms#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentFormsPropertyInfo            ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentForms                        ,
#endif
    getDOMDocumentForms                     ,


-- ** head #attr:head#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentHeadPropertyInfo             ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentHead                         ,
#endif
    getDOMDocumentHead                      ,


-- ** hidden #attr:hidden#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentHiddenPropertyInfo           ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentHidden                       ,
#endif
    getDOMDocumentHidden                    ,


-- ** images #attr:images#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentImagesPropertyInfo           ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentImages                       ,
#endif
    getDOMDocumentImages                    ,


-- ** implementation #attr:implementation#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentImplementationPropertyInfo   ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentImplementation               ,
#endif
    getDOMDocumentImplementation            ,


-- ** inputEncoding #attr:inputEncoding#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentInputEncodingPropertyInfo    ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentInputEncoding                ,
#endif
    getDOMDocumentInputEncoding             ,


-- ** lastElementChild #attr:lastElementChild#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentLastElementChildPropertyInfo ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentLastElementChild             ,
#endif
    getDOMDocumentLastElementChild          ,


-- ** lastModified #attr:lastModified#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentLastModifiedPropertyInfo     ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentLastModified                 ,
#endif
    getDOMDocumentLastModified              ,


-- ** links #attr:links#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentLinksPropertyInfo            ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentLinks                        ,
#endif
    getDOMDocumentLinks                     ,


-- ** origin #attr:origin#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentOriginPropertyInfo           ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentOrigin                       ,
#endif
    getDOMDocumentOrigin                    ,


-- ** plugins #attr:plugins#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentPluginsPropertyInfo          ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentPlugins                      ,
#endif
    getDOMDocumentPlugins                   ,


-- ** pointerLockElement #attr:pointerLockElement#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentPointerLockElementPropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentPointerLockElement           ,
#endif
    getDOMDocumentPointerLockElement        ,


-- ** preferredStylesheetSet #attr:preferredStylesheetSet#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentPreferredStylesheetSetPropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentPreferredStylesheetSet       ,
#endif
    getDOMDocumentPreferredStylesheetSet    ,


-- ** readyState #attr:readyState#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentReadyStatePropertyInfo       ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentReadyState                   ,
#endif
    getDOMDocumentReadyState                ,


-- ** referrer #attr:referrer#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentReferrerPropertyInfo         ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentReferrer                     ,
#endif
    getDOMDocumentReferrer                  ,


-- ** scripts #attr:scripts#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentScriptsPropertyInfo          ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentScripts                      ,
#endif
    getDOMDocumentScripts                   ,


-- ** scrollingElement #attr:scrollingElement#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentScrollingElementPropertyInfo ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentScrollingElement             ,
#endif
    getDOMDocumentScrollingElement          ,


-- ** selectedStylesheetSet #attr:selectedStylesheetSet#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentSelectedStylesheetSetPropertyInfo,
#endif
    constructDOMDocumentSelectedStylesheetSet,
#if ENABLE_OVERLOADING
    dOMDocumentSelectedStylesheetSet        ,
#endif
    getDOMDocumentSelectedStylesheetSet     ,
    setDOMDocumentSelectedStylesheetSet     ,


-- ** styleSheets #attr:styleSheets#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentStyleSheetsPropertyInfo      ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentStyleSheets                  ,
#endif
    getDOMDocumentStyleSheets               ,


-- ** title #attr:title#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentTitlePropertyInfo            ,
#endif
    constructDOMDocumentTitle               ,
#if ENABLE_OVERLOADING
    dOMDocumentTitle                        ,
#endif
    getDOMDocumentTitle                     ,
    setDOMDocumentTitle                     ,


-- ** url #attr:url#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentUrlPropertyInfo              ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentUrl                          ,
#endif
    getDOMDocumentUrl                       ,


-- ** visibilityState #attr:visibilityState#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentVisibilityStatePropertyInfo  ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentVisibilityState              ,
#endif
    getDOMDocumentVisibilityState           ,


-- ** webkitCurrentFullScreenElement #attr:webkitCurrentFullScreenElement#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentWebkitCurrentFullScreenElementPropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentWebkitCurrentFullScreenElement,
#endif
    getDOMDocumentWebkitCurrentFullScreenElement,


-- ** webkitFullScreenKeyboardInputAllowed #attr:webkitFullScreenKeyboardInputAllowed#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentWebkitFullScreenKeyboardInputAllowed,
#endif
    getDOMDocumentWebkitFullScreenKeyboardInputAllowed,


-- ** webkitFullscreenElement #attr:webkitFullscreenElement#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentWebkitFullscreenElementPropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentWebkitFullscreenElement      ,
#endif
    getDOMDocumentWebkitFullscreenElement   ,


-- ** webkitFullscreenEnabled #attr:webkitFullscreenEnabled#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentWebkitFullscreenEnabledPropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentWebkitFullscreenEnabled      ,
#endif
    getDOMDocumentWebkitFullscreenEnabled   ,


-- ** webkitIsFullScreen #attr:webkitIsFullScreen#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentWebkitIsFullScreenPropertyInfo,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentWebkitIsFullScreen           ,
#endif
    getDOMDocumentWebkitIsFullScreen        ,


-- ** xmlEncoding #attr:xmlEncoding#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentXmlEncodingPropertyInfo      ,
#endif
#if ENABLE_OVERLOADING
    dOMDocumentXmlEncoding                  ,
#endif
    getDOMDocumentXmlEncoding               ,


-- ** xmlStandalone #attr:xmlStandalone#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentXmlStandalonePropertyInfo    ,
#endif
    constructDOMDocumentXmlStandalone       ,
#if ENABLE_OVERLOADING
    dOMDocumentXmlStandalone                ,
#endif
    getDOMDocumentXmlStandalone             ,
    setDOMDocumentXmlStandalone             ,


-- ** xmlVersion #attr:xmlVersion#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DOMDocumentXmlVersionPropertyInfo       ,
#endif
    clearDOMDocumentXmlVersion              ,
    constructDOMDocumentXmlVersion          ,
#if ENABLE_OVERLOADING
    dOMDocumentXmlVersion                   ,
#endif
    getDOMDocumentXmlVersion                ,
    setDOMDocumentXmlVersion                ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Interfaces.DOMEventTarget as WebKit2WebExtension.DOMEventTarget
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Interfaces.DOMNodeFilter as WebKit2WebExtension.DOMNodeFilter
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Interfaces.DOMXPathNSResolver as WebKit2WebExtension.DOMXPathNSResolver
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMAttr as WebKit2WebExtension.DOMAttr
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMCDATASection as WebKit2WebExtension.DOMCDATASection
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMCSSStyleDeclaration as WebKit2WebExtension.DOMCSSStyleDeclaration
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMComment as WebKit2WebExtension.DOMComment
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMDOMImplementation as WebKit2WebExtension.DOMDOMImplementation
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMDOMWindow as WebKit2WebExtension.DOMDOMWindow
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMDocumentFragment as WebKit2WebExtension.DOMDocumentFragment
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMDocumentType as WebKit2WebExtension.DOMDocumentType
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMElement as WebKit2WebExtension.DOMElement
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMEntityReference as WebKit2WebExtension.DOMEntityReference
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMEvent as WebKit2WebExtension.DOMEvent
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMHTMLCollection as WebKit2WebExtension.DOMHTMLCollection
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMHTMLElement as WebKit2WebExtension.DOMHTMLElement
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMHTMLHeadElement as WebKit2WebExtension.DOMHTMLHeadElement
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMHTMLScriptElement as WebKit2WebExtension.DOMHTMLScriptElement
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMNode as WebKit2WebExtension.DOMNode
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMNodeIterator as WebKit2WebExtension.DOMNodeIterator
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMNodeList as WebKit2WebExtension.DOMNodeList
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMObject as WebKit2WebExtension.DOMObject
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMProcessingInstruction as WebKit2WebExtension.DOMProcessingInstruction
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMRange as WebKit2WebExtension.DOMRange
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMStyleSheetList as WebKit2WebExtension.DOMStyleSheetList
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMText as WebKit2WebExtension.DOMText
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMTreeWalker as WebKit2WebExtension.DOMTreeWalker
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMXPathExpression as WebKit2WebExtension.DOMXPathExpression
import {-# SOURCE #-} qualified GI.WebKit2WebExtension.Objects.DOMXPathResult as WebKit2WebExtension.DOMXPathResult

-- | Memory-managed wrapper type.
newtype DOMDocument = DOMDocument (ManagedPtr DOMDocument)
foreign import ccall "webkit_dom_document_get_type"
    c_webkit_dom_document_get_type :: IO GType

instance GObject DOMDocument where
    gobjectType = c_webkit_dom_document_get_type
    

-- | Type class for types which can be safely cast to `DOMDocument`, for instance with `toDOMDocument`.
class (GObject o, O.IsDescendantOf DOMDocument o) => IsDOMDocument o
instance (GObject o, O.IsDescendantOf DOMDocument o) => IsDOMDocument o

instance O.HasParentTypes DOMDocument
type instance O.ParentTypes DOMDocument = '[WebKit2WebExtension.DOMNode.DOMNode, WebKit2WebExtension.DOMObject.DOMObject, GObject.Object.Object, WebKit2WebExtension.DOMEventTarget.DOMEventTarget]

-- | Cast to `DOMDocument`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toDOMDocument :: (MonadIO m, IsDOMDocument o) => o -> m DOMDocument
toDOMDocument = liftIO . unsafeCastTo DOMDocument

-- | A convenience alias for `Nothing` :: `Maybe` `DOMDocument`.
noDOMDocument :: Maybe DOMDocument
noDOMDocument = Nothing

#if ENABLE_OVERLOADING
type family ResolveDOMDocumentMethod (t :: Symbol) (o :: *) :: * where
    ResolveDOMDocumentMethod "addEventListener" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetAddEventListenerMethodInfo
    ResolveDOMDocumentMethod "adoptNode" o = DOMDocumentAdoptNodeMethodInfo
    ResolveDOMDocumentMethod "appendChild" o = WebKit2WebExtension.DOMNode.DOMNodeAppendChildMethodInfo
    ResolveDOMDocumentMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveDOMDocumentMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveDOMDocumentMethod "caretRangeFromPoint" o = DOMDocumentCaretRangeFromPointMethodInfo
    ResolveDOMDocumentMethod "cloneNodeWithError" o = WebKit2WebExtension.DOMNode.DOMNodeCloneNodeWithErrorMethodInfo
    ResolveDOMDocumentMethod "compareDocumentPosition" o = WebKit2WebExtension.DOMNode.DOMNodeCompareDocumentPositionMethodInfo
    ResolveDOMDocumentMethod "contains" o = WebKit2WebExtension.DOMNode.DOMNodeContainsMethodInfo
    ResolveDOMDocumentMethod "createAttribute" o = DOMDocumentCreateAttributeMethodInfo
    ResolveDOMDocumentMethod "createAttributeNs" o = DOMDocumentCreateAttributeNsMethodInfo
    ResolveDOMDocumentMethod "createCdataSection" o = DOMDocumentCreateCdataSectionMethodInfo
    ResolveDOMDocumentMethod "createComment" o = DOMDocumentCreateCommentMethodInfo
    ResolveDOMDocumentMethod "createCssStyleDeclaration" o = DOMDocumentCreateCssStyleDeclarationMethodInfo
    ResolveDOMDocumentMethod "createDocumentFragment" o = DOMDocumentCreateDocumentFragmentMethodInfo
    ResolveDOMDocumentMethod "createElement" o = DOMDocumentCreateElementMethodInfo
    ResolveDOMDocumentMethod "createElementNs" o = DOMDocumentCreateElementNsMethodInfo
    ResolveDOMDocumentMethod "createEntityReference" o = DOMDocumentCreateEntityReferenceMethodInfo
    ResolveDOMDocumentMethod "createEvent" o = DOMDocumentCreateEventMethodInfo
    ResolveDOMDocumentMethod "createExpression" o = DOMDocumentCreateExpressionMethodInfo
    ResolveDOMDocumentMethod "createNodeIterator" o = DOMDocumentCreateNodeIteratorMethodInfo
    ResolveDOMDocumentMethod "createNsResolver" o = DOMDocumentCreateNsResolverMethodInfo
    ResolveDOMDocumentMethod "createProcessingInstruction" o = DOMDocumentCreateProcessingInstructionMethodInfo
    ResolveDOMDocumentMethod "createRange" o = DOMDocumentCreateRangeMethodInfo
    ResolveDOMDocumentMethod "createTextNode" o = DOMDocumentCreateTextNodeMethodInfo
    ResolveDOMDocumentMethod "createTreeWalker" o = DOMDocumentCreateTreeWalkerMethodInfo
    ResolveDOMDocumentMethod "dispatchEvent" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetDispatchEventMethodInfo
    ResolveDOMDocumentMethod "elementFromPoint" o = DOMDocumentElementFromPointMethodInfo
    ResolveDOMDocumentMethod "evaluate" o = DOMDocumentEvaluateMethodInfo
    ResolveDOMDocumentMethod "execCommand" o = DOMDocumentExecCommandMethodInfo
    ResolveDOMDocumentMethod "exitPointerLock" o = DOMDocumentExitPointerLockMethodInfo
    ResolveDOMDocumentMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveDOMDocumentMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveDOMDocumentMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveDOMDocumentMethod "hasChildNodes" o = WebKit2WebExtension.DOMNode.DOMNodeHasChildNodesMethodInfo
    ResolveDOMDocumentMethod "hasFocus" o = DOMDocumentHasFocusMethodInfo
    ResolveDOMDocumentMethod "importNode" o = DOMDocumentImportNodeMethodInfo
    ResolveDOMDocumentMethod "insertBefore" o = WebKit2WebExtension.DOMNode.DOMNodeInsertBeforeMethodInfo
    ResolveDOMDocumentMethod "isDefaultNamespace" o = WebKit2WebExtension.DOMNode.DOMNodeIsDefaultNamespaceMethodInfo
    ResolveDOMDocumentMethod "isEqualNode" o = WebKit2WebExtension.DOMNode.DOMNodeIsEqualNodeMethodInfo
    ResolveDOMDocumentMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveDOMDocumentMethod "isSameNode" o = WebKit2WebExtension.DOMNode.DOMNodeIsSameNodeMethodInfo
    ResolveDOMDocumentMethod "isSupported" o = WebKit2WebExtension.DOMNode.DOMNodeIsSupportedMethodInfo
    ResolveDOMDocumentMethod "lookupNamespaceUri" o = WebKit2WebExtension.DOMNode.DOMNodeLookupNamespaceUriMethodInfo
    ResolveDOMDocumentMethod "lookupPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeLookupPrefixMethodInfo
    ResolveDOMDocumentMethod "normalize" o = WebKit2WebExtension.DOMNode.DOMNodeNormalizeMethodInfo
    ResolveDOMDocumentMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveDOMDocumentMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveDOMDocumentMethod "queryCommandEnabled" o = DOMDocumentQueryCommandEnabledMethodInfo
    ResolveDOMDocumentMethod "queryCommandIndeterm" o = DOMDocumentQueryCommandIndetermMethodInfo
    ResolveDOMDocumentMethod "queryCommandState" o = DOMDocumentQueryCommandStateMethodInfo
    ResolveDOMDocumentMethod "queryCommandSupported" o = DOMDocumentQueryCommandSupportedMethodInfo
    ResolveDOMDocumentMethod "queryCommandValue" o = DOMDocumentQueryCommandValueMethodInfo
    ResolveDOMDocumentMethod "querySelector" o = DOMDocumentQuerySelectorMethodInfo
    ResolveDOMDocumentMethod "querySelectorAll" o = DOMDocumentQuerySelectorAllMethodInfo
    ResolveDOMDocumentMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveDOMDocumentMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveDOMDocumentMethod "removeChild" o = WebKit2WebExtension.DOMNode.DOMNodeRemoveChildMethodInfo
    ResolveDOMDocumentMethod "removeEventListener" o = WebKit2WebExtension.DOMEventTarget.DOMEventTargetRemoveEventListenerMethodInfo
    ResolveDOMDocumentMethod "replaceChild" o = WebKit2WebExtension.DOMNode.DOMNodeReplaceChildMethodInfo
    ResolveDOMDocumentMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveDOMDocumentMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveDOMDocumentMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveDOMDocumentMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveDOMDocumentMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveDOMDocumentMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveDOMDocumentMethod "webkitCancelFullscreen" o = DOMDocumentWebkitCancelFullscreenMethodInfo
    ResolveDOMDocumentMethod "webkitExitFullscreen" o = DOMDocumentWebkitExitFullscreenMethodInfo
    ResolveDOMDocumentMethod "getActiveElement" o = DOMDocumentGetActiveElementMethodInfo
    ResolveDOMDocumentMethod "getAnchors" o = DOMDocumentGetAnchorsMethodInfo
    ResolveDOMDocumentMethod "getApplets" o = DOMDocumentGetAppletsMethodInfo
    ResolveDOMDocumentMethod "getBaseUri" o = WebKit2WebExtension.DOMNode.DOMNodeGetBaseUriMethodInfo
    ResolveDOMDocumentMethod "getBody" o = DOMDocumentGetBodyMethodInfo
    ResolveDOMDocumentMethod "getCharacterSet" o = DOMDocumentGetCharacterSetMethodInfo
    ResolveDOMDocumentMethod "getCharset" o = DOMDocumentGetCharsetMethodInfo
    ResolveDOMDocumentMethod "getChildElementCount" o = DOMDocumentGetChildElementCountMethodInfo
    ResolveDOMDocumentMethod "getChildNodes" o = WebKit2WebExtension.DOMNode.DOMNodeGetChildNodesMethodInfo
    ResolveDOMDocumentMethod "getChildren" o = DOMDocumentGetChildrenMethodInfo
    ResolveDOMDocumentMethod "getCompatMode" o = DOMDocumentGetCompatModeMethodInfo
    ResolveDOMDocumentMethod "getContentType" o = DOMDocumentGetContentTypeMethodInfo
    ResolveDOMDocumentMethod "getCookie" o = DOMDocumentGetCookieMethodInfo
    ResolveDOMDocumentMethod "getCurrentScript" o = DOMDocumentGetCurrentScriptMethodInfo
    ResolveDOMDocumentMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveDOMDocumentMethod "getDefaultCharset" o = DOMDocumentGetDefaultCharsetMethodInfo
    ResolveDOMDocumentMethod "getDefaultView" o = DOMDocumentGetDefaultViewMethodInfo
    ResolveDOMDocumentMethod "getDesignMode" o = DOMDocumentGetDesignModeMethodInfo
    ResolveDOMDocumentMethod "getDir" o = DOMDocumentGetDirMethodInfo
    ResolveDOMDocumentMethod "getDoctype" o = DOMDocumentGetDoctypeMethodInfo
    ResolveDOMDocumentMethod "getDocumentElement" o = DOMDocumentGetDocumentElementMethodInfo
    ResolveDOMDocumentMethod "getDocumentUri" o = DOMDocumentGetDocumentUriMethodInfo
    ResolveDOMDocumentMethod "getDomain" o = DOMDocumentGetDomainMethodInfo
    ResolveDOMDocumentMethod "getElementById" o = DOMDocumentGetElementByIdMethodInfo
    ResolveDOMDocumentMethod "getElementsByClassName" o = DOMDocumentGetElementsByClassNameMethodInfo
    ResolveDOMDocumentMethod "getElementsByClassNameAsHtmlCollection" o = DOMDocumentGetElementsByClassNameAsHtmlCollectionMethodInfo
    ResolveDOMDocumentMethod "getElementsByName" o = DOMDocumentGetElementsByNameMethodInfo
    ResolveDOMDocumentMethod "getElementsByTagName" o = DOMDocumentGetElementsByTagNameMethodInfo
    ResolveDOMDocumentMethod "getElementsByTagNameAsHtmlCollection" o = DOMDocumentGetElementsByTagNameAsHtmlCollectionMethodInfo
    ResolveDOMDocumentMethod "getElementsByTagNameNs" o = DOMDocumentGetElementsByTagNameNsMethodInfo
    ResolveDOMDocumentMethod "getElementsByTagNameNsAsHtmlCollection" o = DOMDocumentGetElementsByTagNameNsAsHtmlCollectionMethodInfo
    ResolveDOMDocumentMethod "getEmbeds" o = DOMDocumentGetEmbedsMethodInfo
    ResolveDOMDocumentMethod "getFirstChild" o = WebKit2WebExtension.DOMNode.DOMNodeGetFirstChildMethodInfo
    ResolveDOMDocumentMethod "getFirstElementChild" o = DOMDocumentGetFirstElementChildMethodInfo
    ResolveDOMDocumentMethod "getForms" o = DOMDocumentGetFormsMethodInfo
    ResolveDOMDocumentMethod "getHead" o = DOMDocumentGetHeadMethodInfo
    ResolveDOMDocumentMethod "getHidden" o = DOMDocumentGetHiddenMethodInfo
    ResolveDOMDocumentMethod "getImages" o = DOMDocumentGetImagesMethodInfo
    ResolveDOMDocumentMethod "getImplementation" o = DOMDocumentGetImplementationMethodInfo
    ResolveDOMDocumentMethod "getInputEncoding" o = DOMDocumentGetInputEncodingMethodInfo
    ResolveDOMDocumentMethod "getLastChild" o = WebKit2WebExtension.DOMNode.DOMNodeGetLastChildMethodInfo
    ResolveDOMDocumentMethod "getLastElementChild" o = DOMDocumentGetLastElementChildMethodInfo
    ResolveDOMDocumentMethod "getLastModified" o = DOMDocumentGetLastModifiedMethodInfo
    ResolveDOMDocumentMethod "getLinks" o = DOMDocumentGetLinksMethodInfo
    ResolveDOMDocumentMethod "getLocalName" o = WebKit2WebExtension.DOMNode.DOMNodeGetLocalNameMethodInfo
    ResolveDOMDocumentMethod "getNamespaceUri" o = WebKit2WebExtension.DOMNode.DOMNodeGetNamespaceUriMethodInfo
    ResolveDOMDocumentMethod "getNextSibling" o = WebKit2WebExtension.DOMNode.DOMNodeGetNextSiblingMethodInfo
    ResolveDOMDocumentMethod "getNodeName" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeNameMethodInfo
    ResolveDOMDocumentMethod "getNodeType" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeTypeMethodInfo
    ResolveDOMDocumentMethod "getNodeValue" o = WebKit2WebExtension.DOMNode.DOMNodeGetNodeValueMethodInfo
    ResolveDOMDocumentMethod "getOrigin" o = DOMDocumentGetOriginMethodInfo
    ResolveDOMDocumentMethod "getOverrideStyle" o = DOMDocumentGetOverrideStyleMethodInfo
    ResolveDOMDocumentMethod "getOwnerDocument" o = WebKit2WebExtension.DOMNode.DOMNodeGetOwnerDocumentMethodInfo
    ResolveDOMDocumentMethod "getParentElement" o = WebKit2WebExtension.DOMNode.DOMNodeGetParentElementMethodInfo
    ResolveDOMDocumentMethod "getParentNode" o = WebKit2WebExtension.DOMNode.DOMNodeGetParentNodeMethodInfo
    ResolveDOMDocumentMethod "getPlugins" o = DOMDocumentGetPluginsMethodInfo
    ResolveDOMDocumentMethod "getPointerLockElement" o = DOMDocumentGetPointerLockElementMethodInfo
    ResolveDOMDocumentMethod "getPreferredStylesheetSet" o = DOMDocumentGetPreferredStylesheetSetMethodInfo
    ResolveDOMDocumentMethod "getPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeGetPrefixMethodInfo
    ResolveDOMDocumentMethod "getPreviousSibling" o = WebKit2WebExtension.DOMNode.DOMNodeGetPreviousSiblingMethodInfo
    ResolveDOMDocumentMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveDOMDocumentMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveDOMDocumentMethod "getReadyState" o = DOMDocumentGetReadyStateMethodInfo
    ResolveDOMDocumentMethod "getReferrer" o = DOMDocumentGetReferrerMethodInfo
    ResolveDOMDocumentMethod "getScripts" o = DOMDocumentGetScriptsMethodInfo
    ResolveDOMDocumentMethod "getScrollingElement" o = DOMDocumentGetScrollingElementMethodInfo
    ResolveDOMDocumentMethod "getSelectedStylesheetSet" o = DOMDocumentGetSelectedStylesheetSetMethodInfo
    ResolveDOMDocumentMethod "getStyleSheets" o = DOMDocumentGetStyleSheetsMethodInfo
    ResolveDOMDocumentMethod "getTextContent" o = WebKit2WebExtension.DOMNode.DOMNodeGetTextContentMethodInfo
    ResolveDOMDocumentMethod "getTitle" o = DOMDocumentGetTitleMethodInfo
    ResolveDOMDocumentMethod "getUrl" o = DOMDocumentGetUrlMethodInfo
    ResolveDOMDocumentMethod "getVisibilityState" o = DOMDocumentGetVisibilityStateMethodInfo
    ResolveDOMDocumentMethod "getWebkitCurrentFullscreenElement" o = DOMDocumentGetWebkitCurrentFullscreenElementMethodInfo
    ResolveDOMDocumentMethod "getWebkitFullscreenElement" o = DOMDocumentGetWebkitFullscreenElementMethodInfo
    ResolveDOMDocumentMethod "getWebkitFullscreenEnabled" o = DOMDocumentGetWebkitFullscreenEnabledMethodInfo
    ResolveDOMDocumentMethod "getWebkitFullscreenKeyboardInputAllowed" o = DOMDocumentGetWebkitFullscreenKeyboardInputAllowedMethodInfo
    ResolveDOMDocumentMethod "getWebkitIsFullscreen" o = DOMDocumentGetWebkitIsFullscreenMethodInfo
    ResolveDOMDocumentMethod "getXmlEncoding" o = DOMDocumentGetXmlEncodingMethodInfo
    ResolveDOMDocumentMethod "getXmlStandalone" o = DOMDocumentGetXmlStandaloneMethodInfo
    ResolveDOMDocumentMethod "getXmlVersion" o = DOMDocumentGetXmlVersionMethodInfo
    ResolveDOMDocumentMethod "setBody" o = DOMDocumentSetBodyMethodInfo
    ResolveDOMDocumentMethod "setCharset" o = DOMDocumentSetCharsetMethodInfo
    ResolveDOMDocumentMethod "setCookie" o = DOMDocumentSetCookieMethodInfo
    ResolveDOMDocumentMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveDOMDocumentMethod "setDesignMode" o = DOMDocumentSetDesignModeMethodInfo
    ResolveDOMDocumentMethod "setDir" o = DOMDocumentSetDirMethodInfo
    ResolveDOMDocumentMethod "setDocumentUri" o = DOMDocumentSetDocumentUriMethodInfo
    ResolveDOMDocumentMethod "setNodeValue" o = WebKit2WebExtension.DOMNode.DOMNodeSetNodeValueMethodInfo
    ResolveDOMDocumentMethod "setPrefix" o = WebKit2WebExtension.DOMNode.DOMNodeSetPrefixMethodInfo
    ResolveDOMDocumentMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveDOMDocumentMethod "setSelectedStylesheetSet" o = DOMDocumentSetSelectedStylesheetSetMethodInfo
    ResolveDOMDocumentMethod "setTextContent" o = WebKit2WebExtension.DOMNode.DOMNodeSetTextContentMethodInfo
    ResolveDOMDocumentMethod "setTitle" o = DOMDocumentSetTitleMethodInfo
    ResolveDOMDocumentMethod "setXmlStandalone" o = DOMDocumentSetXmlStandaloneMethodInfo
    ResolveDOMDocumentMethod "setXmlVersion" o = DOMDocumentSetXmlVersionMethodInfo
    ResolveDOMDocumentMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveDOMDocumentMethod t DOMDocument, O.MethodInfo info DOMDocument p) => OL.IsLabel t (DOMDocument -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "active-element"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@active-element@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #activeElement
@
-}
getDOMDocumentActiveElement :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMElement.DOMElement
getDOMDocumentActiveElement obj = liftIO $ checkUnexpectedNothing "getDOMDocumentActiveElement" $ B.Properties.getObjectPropertyObject obj "active-element" WebKit2WebExtension.DOMElement.DOMElement

#if ENABLE_OVERLOADING
data DOMDocumentActiveElementPropertyInfo
instance AttrInfo DOMDocumentActiveElementPropertyInfo where
    type AttrAllowedOps DOMDocumentActiveElementPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentActiveElementPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentActiveElementPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentActiveElementPropertyInfo = WebKit2WebExtension.DOMElement.DOMElement
    type AttrLabel DOMDocumentActiveElementPropertyInfo = "active-element"
    type AttrOrigin DOMDocumentActiveElementPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentActiveElement
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "anchors"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@anchors@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #anchors
@
-}
getDOMDocumentAnchors :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
getDOMDocumentAnchors obj = liftIO $ B.Properties.getObjectPropertyObject obj "anchors" WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection

#if ENABLE_OVERLOADING
data DOMDocumentAnchorsPropertyInfo
instance AttrInfo DOMDocumentAnchorsPropertyInfo where
    type AttrAllowedOps DOMDocumentAnchorsPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentAnchorsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentAnchorsPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentAnchorsPropertyInfo = (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
    type AttrLabel DOMDocumentAnchorsPropertyInfo = "anchors"
    type AttrOrigin DOMDocumentAnchorsPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentAnchors
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "applets"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@applets@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #applets
@
-}
getDOMDocumentApplets :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
getDOMDocumentApplets obj = liftIO $ B.Properties.getObjectPropertyObject obj "applets" WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection

#if ENABLE_OVERLOADING
data DOMDocumentAppletsPropertyInfo
instance AttrInfo DOMDocumentAppletsPropertyInfo where
    type AttrAllowedOps DOMDocumentAppletsPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentAppletsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentAppletsPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentAppletsPropertyInfo = (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
    type AttrLabel DOMDocumentAppletsPropertyInfo = "applets"
    type AttrOrigin DOMDocumentAppletsPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentApplets
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "body"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@body@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #body
@
-}
getDOMDocumentBody :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMHTMLElement.DOMHTMLElement
getDOMDocumentBody obj = liftIO $ checkUnexpectedNothing "getDOMDocumentBody" $ B.Properties.getObjectPropertyObject obj "body" WebKit2WebExtension.DOMHTMLElement.DOMHTMLElement

#if ENABLE_OVERLOADING
data DOMDocumentBodyPropertyInfo
instance AttrInfo DOMDocumentBodyPropertyInfo where
    type AttrAllowedOps DOMDocumentBodyPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentBodyPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentBodyPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentBodyPropertyInfo = WebKit2WebExtension.DOMHTMLElement.DOMHTMLElement
    type AttrLabel DOMDocumentBodyPropertyInfo = "body"
    type AttrOrigin DOMDocumentBodyPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentBody
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "character-set"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@character-set@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #characterSet
@
-}
getDOMDocumentCharacterSet :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentCharacterSet obj = liftIO $ B.Properties.getObjectPropertyString obj "character-set"

#if ENABLE_OVERLOADING
data DOMDocumentCharacterSetPropertyInfo
instance AttrInfo DOMDocumentCharacterSetPropertyInfo where
    type AttrAllowedOps DOMDocumentCharacterSetPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentCharacterSetPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentCharacterSetPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentCharacterSetPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentCharacterSetPropertyInfo = "character-set"
    type AttrOrigin DOMDocumentCharacterSetPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentCharacterSet
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "charset"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Just False)

{- |
Get the value of the “@charset@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #charset
@
-}
getDOMDocumentCharset :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentCharset obj = liftIO $ B.Properties.getObjectPropertyString obj "charset"

{- |
Set the value of the “@charset@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMDocument [ #charset 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMDocumentCharset :: (MonadIO m, IsDOMDocument o) => o -> T.Text -> m ()
setDOMDocumentCharset obj val = liftIO $ B.Properties.setObjectPropertyString obj "charset" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@charset@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMDocumentCharset :: (IsDOMDocument o) => T.Text -> IO (GValueConstruct o)
constructDOMDocumentCharset val = B.Properties.constructObjectPropertyString "charset" (Just val)

#if ENABLE_OVERLOADING
data DOMDocumentCharsetPropertyInfo
instance AttrInfo DOMDocumentCharsetPropertyInfo where
    type AttrAllowedOps DOMDocumentCharsetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentCharsetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMDocumentCharsetPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentCharsetPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentCharsetPropertyInfo = "charset"
    type AttrOrigin DOMDocumentCharsetPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentCharset
    attrSet _ = setDOMDocumentCharset
    attrConstruct _ = constructDOMDocumentCharset
    attrClear _ = undefined
#endif

-- VVV Prop "child-element-count"
   -- Type: TBasicType TULong
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@child-element-count@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #childElementCount
@
-}
getDOMDocumentChildElementCount :: (MonadIO m, IsDOMDocument o) => o -> m CULong
getDOMDocumentChildElementCount obj = liftIO $ B.Properties.getObjectPropertyULong obj "child-element-count"

#if ENABLE_OVERLOADING
data DOMDocumentChildElementCountPropertyInfo
instance AttrInfo DOMDocumentChildElementCountPropertyInfo where
    type AttrAllowedOps DOMDocumentChildElementCountPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentChildElementCountPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentChildElementCountPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentChildElementCountPropertyInfo = CULong
    type AttrLabel DOMDocumentChildElementCountPropertyInfo = "child-element-count"
    type AttrOrigin DOMDocumentChildElementCountPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentChildElementCount
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "children"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@children@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #children
@
-}
getDOMDocumentChildren :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
getDOMDocumentChildren obj = liftIO $ B.Properties.getObjectPropertyObject obj "children" WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection

#if ENABLE_OVERLOADING
data DOMDocumentChildrenPropertyInfo
instance AttrInfo DOMDocumentChildrenPropertyInfo where
    type AttrAllowedOps DOMDocumentChildrenPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentChildrenPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentChildrenPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentChildrenPropertyInfo = (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
    type AttrLabel DOMDocumentChildrenPropertyInfo = "children"
    type AttrOrigin DOMDocumentChildrenPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentChildren
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "compat-mode"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@compat-mode@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #compatMode
@
-}
getDOMDocumentCompatMode :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentCompatMode obj = liftIO $ B.Properties.getObjectPropertyString obj "compat-mode"

#if ENABLE_OVERLOADING
data DOMDocumentCompatModePropertyInfo
instance AttrInfo DOMDocumentCompatModePropertyInfo where
    type AttrAllowedOps DOMDocumentCompatModePropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentCompatModePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentCompatModePropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentCompatModePropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentCompatModePropertyInfo = "compat-mode"
    type AttrOrigin DOMDocumentCompatModePropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentCompatMode
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "content-type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@content-type@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #contentType
@
-}
getDOMDocumentContentType :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentContentType obj = liftIO $ B.Properties.getObjectPropertyString obj "content-type"

#if ENABLE_OVERLOADING
data DOMDocumentContentTypePropertyInfo
instance AttrInfo DOMDocumentContentTypePropertyInfo where
    type AttrAllowedOps DOMDocumentContentTypePropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentContentTypePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentContentTypePropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentContentTypePropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentContentTypePropertyInfo = "content-type"
    type AttrOrigin DOMDocumentContentTypePropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentContentType
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "cookie"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@cookie@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #cookie
@
-}
getDOMDocumentCookie :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentCookie obj = liftIO $ B.Properties.getObjectPropertyString obj "cookie"

{- |
Set the value of the “@cookie@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMDocument [ #cookie 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMDocumentCookie :: (MonadIO m, IsDOMDocument o) => o -> T.Text -> m ()
setDOMDocumentCookie obj val = liftIO $ B.Properties.setObjectPropertyString obj "cookie" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@cookie@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMDocumentCookie :: (IsDOMDocument o) => T.Text -> IO (GValueConstruct o)
constructDOMDocumentCookie val = B.Properties.constructObjectPropertyString "cookie" (Just val)

{- |
Set the value of the “@cookie@” property to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #cookie
@
-}
clearDOMDocumentCookie :: (MonadIO m, IsDOMDocument o) => o -> m ()
clearDOMDocumentCookie obj = liftIO $ B.Properties.setObjectPropertyString obj "cookie" (Nothing :: Maybe T.Text)

#if ENABLE_OVERLOADING
data DOMDocumentCookiePropertyInfo
instance AttrInfo DOMDocumentCookiePropertyInfo where
    type AttrAllowedOps DOMDocumentCookiePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentCookiePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMDocumentCookiePropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentCookiePropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentCookiePropertyInfo = "cookie"
    type AttrOrigin DOMDocumentCookiePropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentCookie
    attrSet _ = setDOMDocumentCookie
    attrConstruct _ = constructDOMDocumentCookie
    attrClear _ = clearDOMDocumentCookie
#endif

-- VVV Prop "current-script"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLScriptElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@current-script@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #currentScript
@
-}
getDOMDocumentCurrentScript :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMHTMLScriptElement.DOMHTMLScriptElement
getDOMDocumentCurrentScript obj = liftIO $ checkUnexpectedNothing "getDOMDocumentCurrentScript" $ B.Properties.getObjectPropertyObject obj "current-script" WebKit2WebExtension.DOMHTMLScriptElement.DOMHTMLScriptElement

#if ENABLE_OVERLOADING
data DOMDocumentCurrentScriptPropertyInfo
instance AttrInfo DOMDocumentCurrentScriptPropertyInfo where
    type AttrAllowedOps DOMDocumentCurrentScriptPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentCurrentScriptPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentCurrentScriptPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentCurrentScriptPropertyInfo = WebKit2WebExtension.DOMHTMLScriptElement.DOMHTMLScriptElement
    type AttrLabel DOMDocumentCurrentScriptPropertyInfo = "current-script"
    type AttrOrigin DOMDocumentCurrentScriptPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentCurrentScript
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "default-view"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDOMWindow"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@default-view@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #defaultView
@
-}
getDOMDocumentDefaultView :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMDOMWindow.DOMDOMWindow)
getDOMDocumentDefaultView obj = liftIO $ B.Properties.getObjectPropertyObject obj "default-view" WebKit2WebExtension.DOMDOMWindow.DOMDOMWindow

#if ENABLE_OVERLOADING
data DOMDocumentDefaultViewPropertyInfo
instance AttrInfo DOMDocumentDefaultViewPropertyInfo where
    type AttrAllowedOps DOMDocumentDefaultViewPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentDefaultViewPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentDefaultViewPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentDefaultViewPropertyInfo = (Maybe WebKit2WebExtension.DOMDOMWindow.DOMDOMWindow)
    type AttrLabel DOMDocumentDefaultViewPropertyInfo = "default-view"
    type AttrOrigin DOMDocumentDefaultViewPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentDefaultView
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "design-mode"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Just False)

{- |
Get the value of the “@design-mode@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #designMode
@
-}
getDOMDocumentDesignMode :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentDesignMode obj = liftIO $ B.Properties.getObjectPropertyString obj "design-mode"

{- |
Set the value of the “@design-mode@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMDocument [ #designMode 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMDocumentDesignMode :: (MonadIO m, IsDOMDocument o) => o -> T.Text -> m ()
setDOMDocumentDesignMode obj val = liftIO $ B.Properties.setObjectPropertyString obj "design-mode" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@design-mode@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMDocumentDesignMode :: (IsDOMDocument o) => T.Text -> IO (GValueConstruct o)
constructDOMDocumentDesignMode val = B.Properties.constructObjectPropertyString "design-mode" (Just val)

#if ENABLE_OVERLOADING
data DOMDocumentDesignModePropertyInfo
instance AttrInfo DOMDocumentDesignModePropertyInfo where
    type AttrAllowedOps DOMDocumentDesignModePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentDesignModePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMDocumentDesignModePropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentDesignModePropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentDesignModePropertyInfo = "design-mode"
    type AttrOrigin DOMDocumentDesignModePropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentDesignMode
    attrSet _ = setDOMDocumentDesignMode
    attrConstruct _ = constructDOMDocumentDesignMode
    attrClear _ = undefined
#endif

-- VVV Prop "dir"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Just False)

{- |
Get the value of the “@dir@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #dir
@
-}
getDOMDocumentDir :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentDir obj = liftIO $ B.Properties.getObjectPropertyString obj "dir"

{- |
Set the value of the “@dir@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMDocument [ #dir 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMDocumentDir :: (MonadIO m, IsDOMDocument o) => o -> T.Text -> m ()
setDOMDocumentDir obj val = liftIO $ B.Properties.setObjectPropertyString obj "dir" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@dir@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMDocumentDir :: (IsDOMDocument o) => T.Text -> IO (GValueConstruct o)
constructDOMDocumentDir val = B.Properties.constructObjectPropertyString "dir" (Just val)

#if ENABLE_OVERLOADING
data DOMDocumentDirPropertyInfo
instance AttrInfo DOMDocumentDirPropertyInfo where
    type AttrAllowedOps DOMDocumentDirPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentDirPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMDocumentDirPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentDirPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentDirPropertyInfo = "dir"
    type AttrOrigin DOMDocumentDirPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentDir
    attrSet _ = setDOMDocumentDir
    attrConstruct _ = constructDOMDocumentDir
    attrClear _ = undefined
#endif

-- VVV Prop "doctype"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@doctype@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #doctype
@
-}
getDOMDocumentDoctype :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMDocumentType.DOMDocumentType
getDOMDocumentDoctype obj = liftIO $ checkUnexpectedNothing "getDOMDocumentDoctype" $ B.Properties.getObjectPropertyObject obj "doctype" WebKit2WebExtension.DOMDocumentType.DOMDocumentType

#if ENABLE_OVERLOADING
data DOMDocumentDoctypePropertyInfo
instance AttrInfo DOMDocumentDoctypePropertyInfo where
    type AttrAllowedOps DOMDocumentDoctypePropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentDoctypePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentDoctypePropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentDoctypePropertyInfo = WebKit2WebExtension.DOMDocumentType.DOMDocumentType
    type AttrLabel DOMDocumentDoctypePropertyInfo = "doctype"
    type AttrOrigin DOMDocumentDoctypePropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentDoctype
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "document-element"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@document-element@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #documentElement
@
-}
getDOMDocumentDocumentElement :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMElement.DOMElement
getDOMDocumentDocumentElement obj = liftIO $ checkUnexpectedNothing "getDOMDocumentDocumentElement" $ B.Properties.getObjectPropertyObject obj "document-element" WebKit2WebExtension.DOMElement.DOMElement

#if ENABLE_OVERLOADING
data DOMDocumentDocumentElementPropertyInfo
instance AttrInfo DOMDocumentDocumentElementPropertyInfo where
    type AttrAllowedOps DOMDocumentDocumentElementPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentDocumentElementPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentDocumentElementPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentDocumentElementPropertyInfo = WebKit2WebExtension.DOMElement.DOMElement
    type AttrLabel DOMDocumentDocumentElementPropertyInfo = "document-element"
    type AttrOrigin DOMDocumentDocumentElementPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentDocumentElement
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "document-uri"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Just False)

{- |
Get the value of the “@document-uri@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #documentUri
@
-}
getDOMDocumentDocumentUri :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentDocumentUri obj = liftIO $ B.Properties.getObjectPropertyString obj "document-uri"

{- |
Set the value of the “@document-uri@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMDocument [ #documentUri 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMDocumentDocumentUri :: (MonadIO m, IsDOMDocument o) => o -> T.Text -> m ()
setDOMDocumentDocumentUri obj val = liftIO $ B.Properties.setObjectPropertyString obj "document-uri" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@document-uri@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMDocumentDocumentUri :: (IsDOMDocument o) => T.Text -> IO (GValueConstruct o)
constructDOMDocumentDocumentUri val = B.Properties.constructObjectPropertyString "document-uri" (Just val)

#if ENABLE_OVERLOADING
data DOMDocumentDocumentUriPropertyInfo
instance AttrInfo DOMDocumentDocumentUriPropertyInfo where
    type AttrAllowedOps DOMDocumentDocumentUriPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentDocumentUriPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMDocumentDocumentUriPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentDocumentUriPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentDocumentUriPropertyInfo = "document-uri"
    type AttrOrigin DOMDocumentDocumentUriPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentDocumentUri
    attrSet _ = setDOMDocumentDocumentUri
    attrConstruct _ = constructDOMDocumentDocumentUri
    attrClear _ = undefined
#endif

-- VVV Prop "domain"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@domain@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #domain
@
-}
getDOMDocumentDomain :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentDomain obj = liftIO $ B.Properties.getObjectPropertyString obj "domain"

#if ENABLE_OVERLOADING
data DOMDocumentDomainPropertyInfo
instance AttrInfo DOMDocumentDomainPropertyInfo where
    type AttrAllowedOps DOMDocumentDomainPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentDomainPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentDomainPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentDomainPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentDomainPropertyInfo = "domain"
    type AttrOrigin DOMDocumentDomainPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentDomain
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "embeds"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@embeds@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #embeds
@
-}
getDOMDocumentEmbeds :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
getDOMDocumentEmbeds obj = liftIO $ B.Properties.getObjectPropertyObject obj "embeds" WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection

#if ENABLE_OVERLOADING
data DOMDocumentEmbedsPropertyInfo
instance AttrInfo DOMDocumentEmbedsPropertyInfo where
    type AttrAllowedOps DOMDocumentEmbedsPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentEmbedsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentEmbedsPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentEmbedsPropertyInfo = (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
    type AttrLabel DOMDocumentEmbedsPropertyInfo = "embeds"
    type AttrOrigin DOMDocumentEmbedsPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentEmbeds
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "first-element-child"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@first-element-child@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #firstElementChild
@
-}
getDOMDocumentFirstElementChild :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMElement.DOMElement
getDOMDocumentFirstElementChild obj = liftIO $ checkUnexpectedNothing "getDOMDocumentFirstElementChild" $ B.Properties.getObjectPropertyObject obj "first-element-child" WebKit2WebExtension.DOMElement.DOMElement

#if ENABLE_OVERLOADING
data DOMDocumentFirstElementChildPropertyInfo
instance AttrInfo DOMDocumentFirstElementChildPropertyInfo where
    type AttrAllowedOps DOMDocumentFirstElementChildPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentFirstElementChildPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentFirstElementChildPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentFirstElementChildPropertyInfo = WebKit2WebExtension.DOMElement.DOMElement
    type AttrLabel DOMDocumentFirstElementChildPropertyInfo = "first-element-child"
    type AttrOrigin DOMDocumentFirstElementChildPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentFirstElementChild
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "forms"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@forms@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #forms
@
-}
getDOMDocumentForms :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
getDOMDocumentForms obj = liftIO $ B.Properties.getObjectPropertyObject obj "forms" WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection

#if ENABLE_OVERLOADING
data DOMDocumentFormsPropertyInfo
instance AttrInfo DOMDocumentFormsPropertyInfo where
    type AttrAllowedOps DOMDocumentFormsPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentFormsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentFormsPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentFormsPropertyInfo = (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
    type AttrLabel DOMDocumentFormsPropertyInfo = "forms"
    type AttrOrigin DOMDocumentFormsPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentForms
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "head"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLHeadElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@head@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #head
@
-}
getDOMDocumentHead :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMHTMLHeadElement.DOMHTMLHeadElement
getDOMDocumentHead obj = liftIO $ checkUnexpectedNothing "getDOMDocumentHead" $ B.Properties.getObjectPropertyObject obj "head" WebKit2WebExtension.DOMHTMLHeadElement.DOMHTMLHeadElement

#if ENABLE_OVERLOADING
data DOMDocumentHeadPropertyInfo
instance AttrInfo DOMDocumentHeadPropertyInfo where
    type AttrAllowedOps DOMDocumentHeadPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentHeadPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentHeadPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentHeadPropertyInfo = WebKit2WebExtension.DOMHTMLHeadElement.DOMHTMLHeadElement
    type AttrLabel DOMDocumentHeadPropertyInfo = "head"
    type AttrOrigin DOMDocumentHeadPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentHead
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "hidden"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@hidden@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #hidden
@
-}
getDOMDocumentHidden :: (MonadIO m, IsDOMDocument o) => o -> m Bool
getDOMDocumentHidden obj = liftIO $ B.Properties.getObjectPropertyBool obj "hidden"

#if ENABLE_OVERLOADING
data DOMDocumentHiddenPropertyInfo
instance AttrInfo DOMDocumentHiddenPropertyInfo where
    type AttrAllowedOps DOMDocumentHiddenPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentHiddenPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentHiddenPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentHiddenPropertyInfo = Bool
    type AttrLabel DOMDocumentHiddenPropertyInfo = "hidden"
    type AttrOrigin DOMDocumentHiddenPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentHidden
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "images"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@images@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #images
@
-}
getDOMDocumentImages :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
getDOMDocumentImages obj = liftIO $ B.Properties.getObjectPropertyObject obj "images" WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection

#if ENABLE_OVERLOADING
data DOMDocumentImagesPropertyInfo
instance AttrInfo DOMDocumentImagesPropertyInfo where
    type AttrAllowedOps DOMDocumentImagesPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentImagesPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentImagesPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentImagesPropertyInfo = (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
    type AttrLabel DOMDocumentImagesPropertyInfo = "images"
    type AttrOrigin DOMDocumentImagesPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentImages
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "implementation"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDOMImplementation"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@implementation@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #implementation
@
-}
getDOMDocumentImplementation :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMDOMImplementation.DOMDOMImplementation)
getDOMDocumentImplementation obj = liftIO $ B.Properties.getObjectPropertyObject obj "implementation" WebKit2WebExtension.DOMDOMImplementation.DOMDOMImplementation

#if ENABLE_OVERLOADING
data DOMDocumentImplementationPropertyInfo
instance AttrInfo DOMDocumentImplementationPropertyInfo where
    type AttrAllowedOps DOMDocumentImplementationPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentImplementationPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentImplementationPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentImplementationPropertyInfo = (Maybe WebKit2WebExtension.DOMDOMImplementation.DOMDOMImplementation)
    type AttrLabel DOMDocumentImplementationPropertyInfo = "implementation"
    type AttrOrigin DOMDocumentImplementationPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentImplementation
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "input-encoding"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@input-encoding@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #inputEncoding
@
-}
getDOMDocumentInputEncoding :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentInputEncoding obj = liftIO $ B.Properties.getObjectPropertyString obj "input-encoding"

#if ENABLE_OVERLOADING
data DOMDocumentInputEncodingPropertyInfo
instance AttrInfo DOMDocumentInputEncodingPropertyInfo where
    type AttrAllowedOps DOMDocumentInputEncodingPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentInputEncodingPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentInputEncodingPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentInputEncodingPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentInputEncodingPropertyInfo = "input-encoding"
    type AttrOrigin DOMDocumentInputEncodingPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentInputEncoding
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "last-element-child"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@last-element-child@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #lastElementChild
@
-}
getDOMDocumentLastElementChild :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMElement.DOMElement
getDOMDocumentLastElementChild obj = liftIO $ checkUnexpectedNothing "getDOMDocumentLastElementChild" $ B.Properties.getObjectPropertyObject obj "last-element-child" WebKit2WebExtension.DOMElement.DOMElement

#if ENABLE_OVERLOADING
data DOMDocumentLastElementChildPropertyInfo
instance AttrInfo DOMDocumentLastElementChildPropertyInfo where
    type AttrAllowedOps DOMDocumentLastElementChildPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentLastElementChildPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentLastElementChildPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentLastElementChildPropertyInfo = WebKit2WebExtension.DOMElement.DOMElement
    type AttrLabel DOMDocumentLastElementChildPropertyInfo = "last-element-child"
    type AttrOrigin DOMDocumentLastElementChildPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentLastElementChild
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "last-modified"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@last-modified@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #lastModified
@
-}
getDOMDocumentLastModified :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentLastModified obj = liftIO $ B.Properties.getObjectPropertyString obj "last-modified"

#if ENABLE_OVERLOADING
data DOMDocumentLastModifiedPropertyInfo
instance AttrInfo DOMDocumentLastModifiedPropertyInfo where
    type AttrAllowedOps DOMDocumentLastModifiedPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentLastModifiedPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentLastModifiedPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentLastModifiedPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentLastModifiedPropertyInfo = "last-modified"
    type AttrOrigin DOMDocumentLastModifiedPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentLastModified
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "links"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@links@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #links
@
-}
getDOMDocumentLinks :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
getDOMDocumentLinks obj = liftIO $ B.Properties.getObjectPropertyObject obj "links" WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection

#if ENABLE_OVERLOADING
data DOMDocumentLinksPropertyInfo
instance AttrInfo DOMDocumentLinksPropertyInfo where
    type AttrAllowedOps DOMDocumentLinksPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentLinksPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentLinksPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentLinksPropertyInfo = (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
    type AttrLabel DOMDocumentLinksPropertyInfo = "links"
    type AttrOrigin DOMDocumentLinksPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentLinks
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "origin"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@origin@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #origin
@
-}
getDOMDocumentOrigin :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentOrigin obj = liftIO $ B.Properties.getObjectPropertyString obj "origin"

#if ENABLE_OVERLOADING
data DOMDocumentOriginPropertyInfo
instance AttrInfo DOMDocumentOriginPropertyInfo where
    type AttrAllowedOps DOMDocumentOriginPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentOriginPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentOriginPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentOriginPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentOriginPropertyInfo = "origin"
    type AttrOrigin DOMDocumentOriginPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentOrigin
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "plugins"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@plugins@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #plugins
@
-}
getDOMDocumentPlugins :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
getDOMDocumentPlugins obj = liftIO $ B.Properties.getObjectPropertyObject obj "plugins" WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection

#if ENABLE_OVERLOADING
data DOMDocumentPluginsPropertyInfo
instance AttrInfo DOMDocumentPluginsPropertyInfo where
    type AttrAllowedOps DOMDocumentPluginsPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentPluginsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentPluginsPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentPluginsPropertyInfo = (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
    type AttrLabel DOMDocumentPluginsPropertyInfo = "plugins"
    type AttrOrigin DOMDocumentPluginsPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentPlugins
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "pointer-lock-element"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@pointer-lock-element@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #pointerLockElement
@
-}
getDOMDocumentPointerLockElement :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMElement.DOMElement
getDOMDocumentPointerLockElement obj = liftIO $ checkUnexpectedNothing "getDOMDocumentPointerLockElement" $ B.Properties.getObjectPropertyObject obj "pointer-lock-element" WebKit2WebExtension.DOMElement.DOMElement

#if ENABLE_OVERLOADING
data DOMDocumentPointerLockElementPropertyInfo
instance AttrInfo DOMDocumentPointerLockElementPropertyInfo where
    type AttrAllowedOps DOMDocumentPointerLockElementPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentPointerLockElementPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentPointerLockElementPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentPointerLockElementPropertyInfo = WebKit2WebExtension.DOMElement.DOMElement
    type AttrLabel DOMDocumentPointerLockElementPropertyInfo = "pointer-lock-element"
    type AttrOrigin DOMDocumentPointerLockElementPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentPointerLockElement
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "preferred-stylesheet-set"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@preferred-stylesheet-set@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #preferredStylesheetSet
@
-}
getDOMDocumentPreferredStylesheetSet :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentPreferredStylesheetSet obj = liftIO $ B.Properties.getObjectPropertyString obj "preferred-stylesheet-set"

#if ENABLE_OVERLOADING
data DOMDocumentPreferredStylesheetSetPropertyInfo
instance AttrInfo DOMDocumentPreferredStylesheetSetPropertyInfo where
    type AttrAllowedOps DOMDocumentPreferredStylesheetSetPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentPreferredStylesheetSetPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentPreferredStylesheetSetPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentPreferredStylesheetSetPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentPreferredStylesheetSetPropertyInfo = "preferred-stylesheet-set"
    type AttrOrigin DOMDocumentPreferredStylesheetSetPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentPreferredStylesheetSet
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "ready-state"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@ready-state@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #readyState
@
-}
getDOMDocumentReadyState :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentReadyState obj = liftIO $ B.Properties.getObjectPropertyString obj "ready-state"

#if ENABLE_OVERLOADING
data DOMDocumentReadyStatePropertyInfo
instance AttrInfo DOMDocumentReadyStatePropertyInfo where
    type AttrAllowedOps DOMDocumentReadyStatePropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentReadyStatePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentReadyStatePropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentReadyStatePropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentReadyStatePropertyInfo = "ready-state"
    type AttrOrigin DOMDocumentReadyStatePropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentReadyState
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "referrer"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@referrer@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #referrer
@
-}
getDOMDocumentReferrer :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentReferrer obj = liftIO $ B.Properties.getObjectPropertyString obj "referrer"

#if ENABLE_OVERLOADING
data DOMDocumentReferrerPropertyInfo
instance AttrInfo DOMDocumentReferrerPropertyInfo where
    type AttrAllowedOps DOMDocumentReferrerPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentReferrerPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentReferrerPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentReferrerPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentReferrerPropertyInfo = "referrer"
    type AttrOrigin DOMDocumentReferrerPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentReferrer
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "scripts"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@scripts@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #scripts
@
-}
getDOMDocumentScripts :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
getDOMDocumentScripts obj = liftIO $ B.Properties.getObjectPropertyObject obj "scripts" WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection

#if ENABLE_OVERLOADING
data DOMDocumentScriptsPropertyInfo
instance AttrInfo DOMDocumentScriptsPropertyInfo where
    type AttrAllowedOps DOMDocumentScriptsPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentScriptsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentScriptsPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentScriptsPropertyInfo = (Maybe WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)
    type AttrLabel DOMDocumentScriptsPropertyInfo = "scripts"
    type AttrOrigin DOMDocumentScriptsPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentScripts
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "scrolling-element"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@scrolling-element@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #scrollingElement
@
-}
getDOMDocumentScrollingElement :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMElement.DOMElement
getDOMDocumentScrollingElement obj = liftIO $ checkUnexpectedNothing "getDOMDocumentScrollingElement" $ B.Properties.getObjectPropertyObject obj "scrolling-element" WebKit2WebExtension.DOMElement.DOMElement

#if ENABLE_OVERLOADING
data DOMDocumentScrollingElementPropertyInfo
instance AttrInfo DOMDocumentScrollingElementPropertyInfo where
    type AttrAllowedOps DOMDocumentScrollingElementPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentScrollingElementPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentScrollingElementPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentScrollingElementPropertyInfo = WebKit2WebExtension.DOMElement.DOMElement
    type AttrLabel DOMDocumentScrollingElementPropertyInfo = "scrolling-element"
    type AttrOrigin DOMDocumentScrollingElementPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentScrollingElement
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "selected-stylesheet-set"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Just False)

{- |
Get the value of the “@selected-stylesheet-set@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #selectedStylesheetSet
@
-}
getDOMDocumentSelectedStylesheetSet :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentSelectedStylesheetSet obj = liftIO $ B.Properties.getObjectPropertyString obj "selected-stylesheet-set"

{- |
Set the value of the “@selected-stylesheet-set@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMDocument [ #selectedStylesheetSet 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMDocumentSelectedStylesheetSet :: (MonadIO m, IsDOMDocument o) => o -> T.Text -> m ()
setDOMDocumentSelectedStylesheetSet obj val = liftIO $ B.Properties.setObjectPropertyString obj "selected-stylesheet-set" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@selected-stylesheet-set@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMDocumentSelectedStylesheetSet :: (IsDOMDocument o) => T.Text -> IO (GValueConstruct o)
constructDOMDocumentSelectedStylesheetSet val = B.Properties.constructObjectPropertyString "selected-stylesheet-set" (Just val)

#if ENABLE_OVERLOADING
data DOMDocumentSelectedStylesheetSetPropertyInfo
instance AttrInfo DOMDocumentSelectedStylesheetSetPropertyInfo where
    type AttrAllowedOps DOMDocumentSelectedStylesheetSetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentSelectedStylesheetSetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMDocumentSelectedStylesheetSetPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentSelectedStylesheetSetPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentSelectedStylesheetSetPropertyInfo = "selected-stylesheet-set"
    type AttrOrigin DOMDocumentSelectedStylesheetSetPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentSelectedStylesheetSet
    attrSet _ = setDOMDocumentSelectedStylesheetSet
    attrConstruct _ = constructDOMDocumentSelectedStylesheetSet
    attrClear _ = undefined
#endif

-- VVV Prop "style-sheets"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMStyleSheetList"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@style-sheets@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #styleSheets
@
-}
getDOMDocumentStyleSheets :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMStyleSheetList.DOMStyleSheetList
getDOMDocumentStyleSheets obj = liftIO $ checkUnexpectedNothing "getDOMDocumentStyleSheets" $ B.Properties.getObjectPropertyObject obj "style-sheets" WebKit2WebExtension.DOMStyleSheetList.DOMStyleSheetList

#if ENABLE_OVERLOADING
data DOMDocumentStyleSheetsPropertyInfo
instance AttrInfo DOMDocumentStyleSheetsPropertyInfo where
    type AttrAllowedOps DOMDocumentStyleSheetsPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentStyleSheetsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentStyleSheetsPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentStyleSheetsPropertyInfo = WebKit2WebExtension.DOMStyleSheetList.DOMStyleSheetList
    type AttrLabel DOMDocumentStyleSheetsPropertyInfo = "style-sheets"
    type AttrOrigin DOMDocumentStyleSheetsPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentStyleSheets
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "title"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Just False)

{- |
Get the value of the “@title@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #title
@
-}
getDOMDocumentTitle :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentTitle obj = liftIO $ B.Properties.getObjectPropertyString obj "title"

{- |
Set the value of the “@title@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMDocument [ #title 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMDocumentTitle :: (MonadIO m, IsDOMDocument o) => o -> T.Text -> m ()
setDOMDocumentTitle obj val = liftIO $ B.Properties.setObjectPropertyString obj "title" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@title@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMDocumentTitle :: (IsDOMDocument o) => T.Text -> IO (GValueConstruct o)
constructDOMDocumentTitle val = B.Properties.constructObjectPropertyString "title" (Just val)

#if ENABLE_OVERLOADING
data DOMDocumentTitlePropertyInfo
instance AttrInfo DOMDocumentTitlePropertyInfo where
    type AttrAllowedOps DOMDocumentTitlePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentTitlePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMDocumentTitlePropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentTitlePropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentTitlePropertyInfo = "title"
    type AttrOrigin DOMDocumentTitlePropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentTitle
    attrSet _ = setDOMDocumentTitle
    attrConstruct _ = constructDOMDocumentTitle
    attrClear _ = undefined
#endif

-- VVV Prop "url"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@url@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #url
@
-}
getDOMDocumentUrl :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentUrl obj = liftIO $ B.Properties.getObjectPropertyString obj "url"

#if ENABLE_OVERLOADING
data DOMDocumentUrlPropertyInfo
instance AttrInfo DOMDocumentUrlPropertyInfo where
    type AttrAllowedOps DOMDocumentUrlPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentUrlPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentUrlPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentUrlPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentUrlPropertyInfo = "url"
    type AttrOrigin DOMDocumentUrlPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentUrl
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "visibility-state"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@visibility-state@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #visibilityState
@
-}
getDOMDocumentVisibilityState :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentVisibilityState obj = liftIO $ B.Properties.getObjectPropertyString obj "visibility-state"

#if ENABLE_OVERLOADING
data DOMDocumentVisibilityStatePropertyInfo
instance AttrInfo DOMDocumentVisibilityStatePropertyInfo where
    type AttrAllowedOps DOMDocumentVisibilityStatePropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentVisibilityStatePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentVisibilityStatePropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentVisibilityStatePropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentVisibilityStatePropertyInfo = "visibility-state"
    type AttrOrigin DOMDocumentVisibilityStatePropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentVisibilityState
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "webkit-current-full-screen-element"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@webkit-current-full-screen-element@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #webkitCurrentFullScreenElement
@
-}
getDOMDocumentWebkitCurrentFullScreenElement :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe WebKit2WebExtension.DOMElement.DOMElement)
getDOMDocumentWebkitCurrentFullScreenElement obj = liftIO $ B.Properties.getObjectPropertyObject obj "webkit-current-full-screen-element" WebKit2WebExtension.DOMElement.DOMElement

#if ENABLE_OVERLOADING
data DOMDocumentWebkitCurrentFullScreenElementPropertyInfo
instance AttrInfo DOMDocumentWebkitCurrentFullScreenElementPropertyInfo where
    type AttrAllowedOps DOMDocumentWebkitCurrentFullScreenElementPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentWebkitCurrentFullScreenElementPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentWebkitCurrentFullScreenElementPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentWebkitCurrentFullScreenElementPropertyInfo = (Maybe WebKit2WebExtension.DOMElement.DOMElement)
    type AttrLabel DOMDocumentWebkitCurrentFullScreenElementPropertyInfo = "webkit-current-full-screen-element"
    type AttrOrigin DOMDocumentWebkitCurrentFullScreenElementPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentWebkitCurrentFullScreenElement
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "webkit-full-screen-keyboard-input-allowed"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@webkit-full-screen-keyboard-input-allowed@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #webkitFullScreenKeyboardInputAllowed
@
-}
getDOMDocumentWebkitFullScreenKeyboardInputAllowed :: (MonadIO m, IsDOMDocument o) => o -> m Bool
getDOMDocumentWebkitFullScreenKeyboardInputAllowed obj = liftIO $ B.Properties.getObjectPropertyBool obj "webkit-full-screen-keyboard-input-allowed"

#if ENABLE_OVERLOADING
data DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo
instance AttrInfo DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo where
    type AttrAllowedOps DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo = Bool
    type AttrLabel DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo = "webkit-full-screen-keyboard-input-allowed"
    type AttrOrigin DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentWebkitFullScreenKeyboardInputAllowed
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "webkit-fullscreen-element"
   -- Type: TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"})
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@webkit-fullscreen-element@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #webkitFullscreenElement
@
-}
getDOMDocumentWebkitFullscreenElement :: (MonadIO m, IsDOMDocument o) => o -> m WebKit2WebExtension.DOMElement.DOMElement
getDOMDocumentWebkitFullscreenElement obj = liftIO $ checkUnexpectedNothing "getDOMDocumentWebkitFullscreenElement" $ B.Properties.getObjectPropertyObject obj "webkit-fullscreen-element" WebKit2WebExtension.DOMElement.DOMElement

#if ENABLE_OVERLOADING
data DOMDocumentWebkitFullscreenElementPropertyInfo
instance AttrInfo DOMDocumentWebkitFullscreenElementPropertyInfo where
    type AttrAllowedOps DOMDocumentWebkitFullscreenElementPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentWebkitFullscreenElementPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentWebkitFullscreenElementPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentWebkitFullscreenElementPropertyInfo = WebKit2WebExtension.DOMElement.DOMElement
    type AttrLabel DOMDocumentWebkitFullscreenElementPropertyInfo = "webkit-fullscreen-element"
    type AttrOrigin DOMDocumentWebkitFullscreenElementPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentWebkitFullscreenElement
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "webkit-fullscreen-enabled"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@webkit-fullscreen-enabled@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #webkitFullscreenEnabled
@
-}
getDOMDocumentWebkitFullscreenEnabled :: (MonadIO m, IsDOMDocument o) => o -> m Bool
getDOMDocumentWebkitFullscreenEnabled obj = liftIO $ B.Properties.getObjectPropertyBool obj "webkit-fullscreen-enabled"

#if ENABLE_OVERLOADING
data DOMDocumentWebkitFullscreenEnabledPropertyInfo
instance AttrInfo DOMDocumentWebkitFullscreenEnabledPropertyInfo where
    type AttrAllowedOps DOMDocumentWebkitFullscreenEnabledPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentWebkitFullscreenEnabledPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentWebkitFullscreenEnabledPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentWebkitFullscreenEnabledPropertyInfo = Bool
    type AttrLabel DOMDocumentWebkitFullscreenEnabledPropertyInfo = "webkit-fullscreen-enabled"
    type AttrOrigin DOMDocumentWebkitFullscreenEnabledPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentWebkitFullscreenEnabled
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "webkit-is-full-screen"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@webkit-is-full-screen@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #webkitIsFullScreen
@
-}
getDOMDocumentWebkitIsFullScreen :: (MonadIO m, IsDOMDocument o) => o -> m Bool
getDOMDocumentWebkitIsFullScreen obj = liftIO $ B.Properties.getObjectPropertyBool obj "webkit-is-full-screen"

#if ENABLE_OVERLOADING
data DOMDocumentWebkitIsFullScreenPropertyInfo
instance AttrInfo DOMDocumentWebkitIsFullScreenPropertyInfo where
    type AttrAllowedOps DOMDocumentWebkitIsFullScreenPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentWebkitIsFullScreenPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentWebkitIsFullScreenPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentWebkitIsFullScreenPropertyInfo = Bool
    type AttrLabel DOMDocumentWebkitIsFullScreenPropertyInfo = "webkit-is-full-screen"
    type AttrOrigin DOMDocumentWebkitIsFullScreenPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentWebkitIsFullScreen
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "xml-encoding"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@xml-encoding@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #xmlEncoding
@
-}
getDOMDocumentXmlEncoding :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentXmlEncoding obj = liftIO $ B.Properties.getObjectPropertyString obj "xml-encoding"

#if ENABLE_OVERLOADING
data DOMDocumentXmlEncodingPropertyInfo
instance AttrInfo DOMDocumentXmlEncodingPropertyInfo where
    type AttrAllowedOps DOMDocumentXmlEncodingPropertyInfo = '[ 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentXmlEncodingPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDocumentXmlEncodingPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentXmlEncodingPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentXmlEncodingPropertyInfo = "xml-encoding"
    type AttrOrigin DOMDocumentXmlEncodingPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentXmlEncoding
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "xml-standalone"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@xml-standalone@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #xmlStandalone
@
-}
getDOMDocumentXmlStandalone :: (MonadIO m, IsDOMDocument o) => o -> m Bool
getDOMDocumentXmlStandalone obj = liftIO $ B.Properties.getObjectPropertyBool obj "xml-standalone"

{- |
Set the value of the “@xml-standalone@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMDocument [ #xmlStandalone 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMDocumentXmlStandalone :: (MonadIO m, IsDOMDocument o) => o -> Bool -> m ()
setDOMDocumentXmlStandalone obj val = liftIO $ B.Properties.setObjectPropertyBool obj "xml-standalone" val

{- |
Construct a `GValueConstruct` with valid value for the “@xml-standalone@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMDocumentXmlStandalone :: (IsDOMDocument o) => Bool -> IO (GValueConstruct o)
constructDOMDocumentXmlStandalone val = B.Properties.constructObjectPropertyBool "xml-standalone" val

#if ENABLE_OVERLOADING
data DOMDocumentXmlStandalonePropertyInfo
instance AttrInfo DOMDocumentXmlStandalonePropertyInfo where
    type AttrAllowedOps DOMDocumentXmlStandalonePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMDocumentXmlStandalonePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMDocumentXmlStandalonePropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentXmlStandalonePropertyInfo = Bool
    type AttrLabel DOMDocumentXmlStandalonePropertyInfo = "xml-standalone"
    type AttrOrigin DOMDocumentXmlStandalonePropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentXmlStandalone
    attrSet _ = setDOMDocumentXmlStandalone
    attrConstruct _ = constructDOMDocumentXmlStandalone
    attrClear _ = undefined
#endif

-- VVV Prop "xml-version"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@xml-version@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dOMDocument #xmlVersion
@
-}
getDOMDocumentXmlVersion :: (MonadIO m, IsDOMDocument o) => o -> m (Maybe T.Text)
getDOMDocumentXmlVersion obj = liftIO $ B.Properties.getObjectPropertyString obj "xml-version"

{- |
Set the value of the “@xml-version@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dOMDocument [ #xmlVersion 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDOMDocumentXmlVersion :: (MonadIO m, IsDOMDocument o) => o -> T.Text -> m ()
setDOMDocumentXmlVersion obj val = liftIO $ B.Properties.setObjectPropertyString obj "xml-version" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@xml-version@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDOMDocumentXmlVersion :: (IsDOMDocument o) => T.Text -> IO (GValueConstruct o)
constructDOMDocumentXmlVersion val = B.Properties.constructObjectPropertyString "xml-version" (Just val)

{- |
Set the value of the “@xml-version@” property to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #xmlVersion
@
-}
clearDOMDocumentXmlVersion :: (MonadIO m, IsDOMDocument o) => o -> m ()
clearDOMDocumentXmlVersion obj = liftIO $ B.Properties.setObjectPropertyString obj "xml-version" (Nothing :: Maybe T.Text)

#if ENABLE_OVERLOADING
data DOMDocumentXmlVersionPropertyInfo
instance AttrInfo DOMDocumentXmlVersionPropertyInfo where
    type AttrAllowedOps DOMDocumentXmlVersionPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint DOMDocumentXmlVersionPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMDocumentXmlVersionPropertyInfo = IsDOMDocument
    type AttrGetType DOMDocumentXmlVersionPropertyInfo = (Maybe T.Text)
    type AttrLabel DOMDocumentXmlVersionPropertyInfo = "xml-version"
    type AttrOrigin DOMDocumentXmlVersionPropertyInfo = DOMDocument
    attrGet _ = getDOMDocumentXmlVersion
    attrSet _ = setDOMDocumentXmlVersion
    attrConstruct _ = constructDOMDocumentXmlVersion
    attrClear _ = clearDOMDocumentXmlVersion
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList DOMDocument
type instance O.AttributeList DOMDocument = DOMDocumentAttributeList
type DOMDocumentAttributeList = ('[ '("activeElement", DOMDocumentActiveElementPropertyInfo), '("anchors", DOMDocumentAnchorsPropertyInfo), '("applets", DOMDocumentAppletsPropertyInfo), '("baseUri", WebKit2WebExtension.DOMNode.DOMNodeBaseUriPropertyInfo), '("body", DOMDocumentBodyPropertyInfo), '("characterSet", DOMDocumentCharacterSetPropertyInfo), '("charset", DOMDocumentCharsetPropertyInfo), '("childElementCount", DOMDocumentChildElementCountPropertyInfo), '("childNodes", WebKit2WebExtension.DOMNode.DOMNodeChildNodesPropertyInfo), '("children", DOMDocumentChildrenPropertyInfo), '("compatMode", DOMDocumentCompatModePropertyInfo), '("contentType", DOMDocumentContentTypePropertyInfo), '("cookie", DOMDocumentCookiePropertyInfo), '("coreObject", WebKit2WebExtension.DOMObject.DOMObjectCoreObjectPropertyInfo), '("currentScript", DOMDocumentCurrentScriptPropertyInfo), '("defaultView", DOMDocumentDefaultViewPropertyInfo), '("designMode", DOMDocumentDesignModePropertyInfo), '("dir", DOMDocumentDirPropertyInfo), '("doctype", DOMDocumentDoctypePropertyInfo), '("documentElement", DOMDocumentDocumentElementPropertyInfo), '("documentUri", DOMDocumentDocumentUriPropertyInfo), '("domain", DOMDocumentDomainPropertyInfo), '("embeds", DOMDocumentEmbedsPropertyInfo), '("firstChild", WebKit2WebExtension.DOMNode.DOMNodeFirstChildPropertyInfo), '("firstElementChild", DOMDocumentFirstElementChildPropertyInfo), '("forms", DOMDocumentFormsPropertyInfo), '("head", DOMDocumentHeadPropertyInfo), '("hidden", DOMDocumentHiddenPropertyInfo), '("images", DOMDocumentImagesPropertyInfo), '("implementation", DOMDocumentImplementationPropertyInfo), '("inputEncoding", DOMDocumentInputEncodingPropertyInfo), '("lastChild", WebKit2WebExtension.DOMNode.DOMNodeLastChildPropertyInfo), '("lastElementChild", DOMDocumentLastElementChildPropertyInfo), '("lastModified", DOMDocumentLastModifiedPropertyInfo), '("links", DOMDocumentLinksPropertyInfo), '("nextSibling", WebKit2WebExtension.DOMNode.DOMNodeNextSiblingPropertyInfo), '("nodeName", WebKit2WebExtension.DOMNode.DOMNodeNodeNamePropertyInfo), '("nodeType", WebKit2WebExtension.DOMNode.DOMNodeNodeTypePropertyInfo), '("nodeValue", WebKit2WebExtension.DOMNode.DOMNodeNodeValuePropertyInfo), '("origin", DOMDocumentOriginPropertyInfo), '("ownerDocument", WebKit2WebExtension.DOMNode.DOMNodeOwnerDocumentPropertyInfo), '("parentElement", WebKit2WebExtension.DOMNode.DOMNodeParentElementPropertyInfo), '("parentNode", WebKit2WebExtension.DOMNode.DOMNodeParentNodePropertyInfo), '("plugins", DOMDocumentPluginsPropertyInfo), '("pointerLockElement", DOMDocumentPointerLockElementPropertyInfo), '("preferredStylesheetSet", DOMDocumentPreferredStylesheetSetPropertyInfo), '("previousSibling", WebKit2WebExtension.DOMNode.DOMNodePreviousSiblingPropertyInfo), '("readyState", DOMDocumentReadyStatePropertyInfo), '("referrer", DOMDocumentReferrerPropertyInfo), '("scripts", DOMDocumentScriptsPropertyInfo), '("scrollingElement", DOMDocumentScrollingElementPropertyInfo), '("selectedStylesheetSet", DOMDocumentSelectedStylesheetSetPropertyInfo), '("styleSheets", DOMDocumentStyleSheetsPropertyInfo), '("textContent", WebKit2WebExtension.DOMNode.DOMNodeTextContentPropertyInfo), '("title", DOMDocumentTitlePropertyInfo), '("url", DOMDocumentUrlPropertyInfo), '("visibilityState", DOMDocumentVisibilityStatePropertyInfo), '("webkitCurrentFullScreenElement", DOMDocumentWebkitCurrentFullScreenElementPropertyInfo), '("webkitFullScreenKeyboardInputAllowed", DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo), '("webkitFullscreenElement", DOMDocumentWebkitFullscreenElementPropertyInfo), '("webkitFullscreenEnabled", DOMDocumentWebkitFullscreenEnabledPropertyInfo), '("webkitIsFullScreen", DOMDocumentWebkitIsFullScreenPropertyInfo), '("xmlEncoding", DOMDocumentXmlEncodingPropertyInfo), '("xmlStandalone", DOMDocumentXmlStandalonePropertyInfo), '("xmlVersion", DOMDocumentXmlVersionPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
dOMDocumentActiveElement :: AttrLabelProxy "activeElement"
dOMDocumentActiveElement = AttrLabelProxy

dOMDocumentAnchors :: AttrLabelProxy "anchors"
dOMDocumentAnchors = AttrLabelProxy

dOMDocumentApplets :: AttrLabelProxy "applets"
dOMDocumentApplets = AttrLabelProxy

dOMDocumentBody :: AttrLabelProxy "body"
dOMDocumentBody = AttrLabelProxy

dOMDocumentCharacterSet :: AttrLabelProxy "characterSet"
dOMDocumentCharacterSet = AttrLabelProxy

dOMDocumentCharset :: AttrLabelProxy "charset"
dOMDocumentCharset = AttrLabelProxy

dOMDocumentChildElementCount :: AttrLabelProxy "childElementCount"
dOMDocumentChildElementCount = AttrLabelProxy

dOMDocumentChildren :: AttrLabelProxy "children"
dOMDocumentChildren = AttrLabelProxy

dOMDocumentCompatMode :: AttrLabelProxy "compatMode"
dOMDocumentCompatMode = AttrLabelProxy

dOMDocumentContentType :: AttrLabelProxy "contentType"
dOMDocumentContentType = AttrLabelProxy

dOMDocumentCookie :: AttrLabelProxy "cookie"
dOMDocumentCookie = AttrLabelProxy

dOMDocumentCurrentScript :: AttrLabelProxy "currentScript"
dOMDocumentCurrentScript = AttrLabelProxy

dOMDocumentDefaultView :: AttrLabelProxy "defaultView"
dOMDocumentDefaultView = AttrLabelProxy

dOMDocumentDesignMode :: AttrLabelProxy "designMode"
dOMDocumentDesignMode = AttrLabelProxy

dOMDocumentDir :: AttrLabelProxy "dir"
dOMDocumentDir = AttrLabelProxy

dOMDocumentDoctype :: AttrLabelProxy "doctype"
dOMDocumentDoctype = AttrLabelProxy

dOMDocumentDocumentElement :: AttrLabelProxy "documentElement"
dOMDocumentDocumentElement = AttrLabelProxy

dOMDocumentDocumentUri :: AttrLabelProxy "documentUri"
dOMDocumentDocumentUri = AttrLabelProxy

dOMDocumentDomain :: AttrLabelProxy "domain"
dOMDocumentDomain = AttrLabelProxy

dOMDocumentEmbeds :: AttrLabelProxy "embeds"
dOMDocumentEmbeds = AttrLabelProxy

dOMDocumentFirstElementChild :: AttrLabelProxy "firstElementChild"
dOMDocumentFirstElementChild = AttrLabelProxy

dOMDocumentForms :: AttrLabelProxy "forms"
dOMDocumentForms = AttrLabelProxy

dOMDocumentHead :: AttrLabelProxy "head"
dOMDocumentHead = AttrLabelProxy

dOMDocumentHidden :: AttrLabelProxy "hidden"
dOMDocumentHidden = AttrLabelProxy

dOMDocumentImages :: AttrLabelProxy "images"
dOMDocumentImages = AttrLabelProxy

dOMDocumentImplementation :: AttrLabelProxy "implementation"
dOMDocumentImplementation = AttrLabelProxy

dOMDocumentInputEncoding :: AttrLabelProxy "inputEncoding"
dOMDocumentInputEncoding = AttrLabelProxy

dOMDocumentLastElementChild :: AttrLabelProxy "lastElementChild"
dOMDocumentLastElementChild = AttrLabelProxy

dOMDocumentLastModified :: AttrLabelProxy "lastModified"
dOMDocumentLastModified = AttrLabelProxy

dOMDocumentLinks :: AttrLabelProxy "links"
dOMDocumentLinks = AttrLabelProxy

dOMDocumentOrigin :: AttrLabelProxy "origin"
dOMDocumentOrigin = AttrLabelProxy

dOMDocumentPlugins :: AttrLabelProxy "plugins"
dOMDocumentPlugins = AttrLabelProxy

dOMDocumentPointerLockElement :: AttrLabelProxy "pointerLockElement"
dOMDocumentPointerLockElement = AttrLabelProxy

dOMDocumentPreferredStylesheetSet :: AttrLabelProxy "preferredStylesheetSet"
dOMDocumentPreferredStylesheetSet = AttrLabelProxy

dOMDocumentReadyState :: AttrLabelProxy "readyState"
dOMDocumentReadyState = AttrLabelProxy

dOMDocumentReferrer :: AttrLabelProxy "referrer"
dOMDocumentReferrer = AttrLabelProxy

dOMDocumentScripts :: AttrLabelProxy "scripts"
dOMDocumentScripts = AttrLabelProxy

dOMDocumentScrollingElement :: AttrLabelProxy "scrollingElement"
dOMDocumentScrollingElement = AttrLabelProxy

dOMDocumentSelectedStylesheetSet :: AttrLabelProxy "selectedStylesheetSet"
dOMDocumentSelectedStylesheetSet = AttrLabelProxy

dOMDocumentStyleSheets :: AttrLabelProxy "styleSheets"
dOMDocumentStyleSheets = AttrLabelProxy

dOMDocumentTitle :: AttrLabelProxy "title"
dOMDocumentTitle = AttrLabelProxy

dOMDocumentUrl :: AttrLabelProxy "url"
dOMDocumentUrl = AttrLabelProxy

dOMDocumentVisibilityState :: AttrLabelProxy "visibilityState"
dOMDocumentVisibilityState = AttrLabelProxy

dOMDocumentWebkitCurrentFullScreenElement :: AttrLabelProxy "webkitCurrentFullScreenElement"
dOMDocumentWebkitCurrentFullScreenElement = AttrLabelProxy

dOMDocumentWebkitFullScreenKeyboardInputAllowed :: AttrLabelProxy "webkitFullScreenKeyboardInputAllowed"
dOMDocumentWebkitFullScreenKeyboardInputAllowed = AttrLabelProxy

dOMDocumentWebkitFullscreenElement :: AttrLabelProxy "webkitFullscreenElement"
dOMDocumentWebkitFullscreenElement = AttrLabelProxy

dOMDocumentWebkitFullscreenEnabled :: AttrLabelProxy "webkitFullscreenEnabled"
dOMDocumentWebkitFullscreenEnabled = AttrLabelProxy

dOMDocumentWebkitIsFullScreen :: AttrLabelProxy "webkitIsFullScreen"
dOMDocumentWebkitIsFullScreen = AttrLabelProxy

dOMDocumentXmlEncoding :: AttrLabelProxy "xmlEncoding"
dOMDocumentXmlEncoding = AttrLabelProxy

dOMDocumentXmlStandalone :: AttrLabelProxy "xmlStandalone"
dOMDocumentXmlStandalone = AttrLabelProxy

dOMDocumentXmlVersion :: AttrLabelProxy "xmlVersion"
dOMDocumentXmlVersion = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList DOMDocument = DOMDocumentSignalList
type DOMDocumentSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

-- method DOMDocument::adopt_node
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "source", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNode", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_adopt_node" webkit_dom_document_adopt_node :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    Ptr WebKit2WebExtension.DOMNode.DOMNode -> -- source : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"})
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMNode.DOMNode)

{-# DEPRECATED dOMDocumentAdoptNode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentAdoptNode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> b
    {- ^ /@source@/: A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' -}
    -> m WebKit2WebExtension.DOMNode.DOMNode
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentAdoptNode self source = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    source' <- unsafeManagedPtrCastPtr source
    onException (do
        result <- propagateGError $ webkit_dom_document_adopt_node self' source'
        checkUnexpectedReturnNULL "dOMDocumentAdoptNode" result
        result' <- (newObject WebKit2WebExtension.DOMNode.DOMNode) result
        touchManagedPtr self
        touchManagedPtr source
        return result'
     ) (do
        return ()
     )

#if ENABLE_OVERLOADING
data DOMDocumentAdoptNodeMethodInfo
instance (signature ~ (b -> m WebKit2WebExtension.DOMNode.DOMNode), MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b) => O.MethodInfo DOMDocumentAdoptNodeMethodInfo a signature where
    overloadedMethod _ = dOMDocumentAdoptNode

#endif

-- method DOMDocument::caret_range_from_point
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "x", argType = TBasicType TLong, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #glong", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "y", argType = TBasicType TLong, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #glong", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMRange"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_caret_range_from_point" webkit_dom_document_caret_range_from_point :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CLong ->                                -- x : TBasicType TLong
    CLong ->                                -- y : TBasicType TLong
    IO (Ptr WebKit2WebExtension.DOMRange.DOMRange)

{-# DEPRECATED dOMDocumentCaretRangeFromPoint ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentCaretRangeFromPoint ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> CLong
    {- ^ /@x@/: A @/glong/@ -}
    -> CLong
    {- ^ /@y@/: A @/glong/@ -}
    -> m WebKit2WebExtension.DOMRange.DOMRange
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMRange.DOMRange' -}
dOMDocumentCaretRangeFromPoint self x y = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_caret_range_from_point self' x y
    checkUnexpectedReturnNULL "dOMDocumentCaretRangeFromPoint" result
    result' <- (wrapObject WebKit2WebExtension.DOMRange.DOMRange) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentCaretRangeFromPointMethodInfo
instance (signature ~ (CLong -> CLong -> m WebKit2WebExtension.DOMRange.DOMRange), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCaretRangeFromPointMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCaretRangeFromPoint

#endif

-- method DOMDocument::create_attribute
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMAttr"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_attribute" webkit_dom_document_create_attribute :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- name : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMAttr.DOMAttr)

{-# DEPRECATED dOMDocumentCreateAttribute ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateAttribute ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@name@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMAttr.DOMAttr
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMAttr.DOMAttr' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateAttribute self name = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    name' <- textToCString name
    onException (do
        result <- propagateGError $ webkit_dom_document_create_attribute self' name'
        checkUnexpectedReturnNULL "dOMDocumentCreateAttribute" result
        result' <- (newObject WebKit2WebExtension.DOMAttr.DOMAttr) result
        touchManagedPtr self
        freeMem name'
        return result'
     ) (do
        freeMem name'
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateAttributeMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMAttr.DOMAttr), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateAttributeMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateAttribute

#endif

-- method DOMDocument::create_attribute_ns
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "namespaceURI", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "qualifiedName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMAttr"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_attribute_ns" webkit_dom_document_create_attribute_ns :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- namespaceURI : TBasicType TUTF8
    CString ->                              -- qualifiedName : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMAttr.DOMAttr)

{-# DEPRECATED dOMDocumentCreateAttributeNs ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateAttributeNs ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> Maybe (T.Text)
    {- ^ /@namespaceURI@/: A @/gchar/@ -}
    -> T.Text
    {- ^ /@qualifiedName@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMAttr.DOMAttr
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMAttr.DOMAttr' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateAttributeNs self namespaceURI qualifiedName = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    maybeNamespaceURI <- case namespaceURI of
        Nothing -> return nullPtr
        Just jNamespaceURI -> do
            jNamespaceURI' <- textToCString jNamespaceURI
            return jNamespaceURI'
    qualifiedName' <- textToCString qualifiedName
    onException (do
        result <- propagateGError $ webkit_dom_document_create_attribute_ns self' maybeNamespaceURI qualifiedName'
        checkUnexpectedReturnNULL "dOMDocumentCreateAttributeNs" result
        result' <- (newObject WebKit2WebExtension.DOMAttr.DOMAttr) result
        touchManagedPtr self
        freeMem maybeNamespaceURI
        freeMem qualifiedName'
        return result'
     ) (do
        freeMem maybeNamespaceURI
        freeMem qualifiedName'
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateAttributeNsMethodInfo
instance (signature ~ (Maybe (T.Text) -> T.Text -> m WebKit2WebExtension.DOMAttr.DOMAttr), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateAttributeNsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateAttributeNs

#endif

-- method DOMDocument::create_cdata_section
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "data", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMCDATASection"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_cdata_section" webkit_dom_document_create_cdata_section :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- data : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMCDATASection.DOMCDATASection)

{-# DEPRECATED dOMDocumentCreateCdataSection ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateCdataSection ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@data@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMCDATASection.DOMCDATASection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMCDATASection.DOMCDATASection' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateCdataSection self data_ = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    data_' <- textToCString data_
    onException (do
        result <- propagateGError $ webkit_dom_document_create_cdata_section self' data_'
        checkUnexpectedReturnNULL "dOMDocumentCreateCdataSection" result
        result' <- (newObject WebKit2WebExtension.DOMCDATASection.DOMCDATASection) result
        touchManagedPtr self
        freeMem data_'
        return result'
     ) (do
        freeMem data_'
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateCdataSectionMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMCDATASection.DOMCDATASection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateCdataSectionMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateCdataSection

#endif

-- method DOMDocument::create_comment
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "data", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMComment"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_create_comment" webkit_dom_document_create_comment :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- data : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMComment.DOMComment)

{-# DEPRECATED dOMDocumentCreateComment ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateComment ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@data@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMComment.DOMComment
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMComment.DOMComment' -}
dOMDocumentCreateComment self data_ = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    data_' <- textToCString data_
    result <- webkit_dom_document_create_comment self' data_'
    checkUnexpectedReturnNULL "dOMDocumentCreateComment" result
    result' <- (newObject WebKit2WebExtension.DOMComment.DOMComment) result
    touchManagedPtr self
    freeMem data_'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentCreateCommentMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMComment.DOMComment), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateCommentMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateComment

#endif

-- method DOMDocument::create_css_style_declaration
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMCSSStyleDeclaration"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_create_css_style_declaration" webkit_dom_document_create_css_style_declaration :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMCSSStyleDeclaration.DOMCSSStyleDeclaration)

{-# DEPRECATED dOMDocumentCreateCssStyleDeclaration ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateCssStyleDeclaration ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMCSSStyleDeclaration.DOMCSSStyleDeclaration
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMCSSStyleDeclaration.DOMCSSStyleDeclaration' -}
dOMDocumentCreateCssStyleDeclaration self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_create_css_style_declaration self'
    checkUnexpectedReturnNULL "dOMDocumentCreateCssStyleDeclaration" result
    result' <- (wrapObject WebKit2WebExtension.DOMCSSStyleDeclaration.DOMCSSStyleDeclaration) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentCreateCssStyleDeclarationMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMCSSStyleDeclaration.DOMCSSStyleDeclaration), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateCssStyleDeclarationMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateCssStyleDeclaration

#endif

-- method DOMDocument::create_document_fragment
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentFragment"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_create_document_fragment" webkit_dom_document_create_document_fragment :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMDocumentFragment.DOMDocumentFragment)

{-# DEPRECATED dOMDocumentCreateDocumentFragment ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateDocumentFragment ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMDocumentFragment.DOMDocumentFragment
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMDocumentFragment.DOMDocumentFragment' -}
dOMDocumentCreateDocumentFragment self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_create_document_fragment self'
    checkUnexpectedReturnNULL "dOMDocumentCreateDocumentFragment" result
    result' <- (newObject WebKit2WebExtension.DOMDocumentFragment.DOMDocumentFragment) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentCreateDocumentFragmentMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMDocumentFragment.DOMDocumentFragment), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateDocumentFragmentMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateDocumentFragment

#endif

-- method DOMDocument::create_element
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "tagName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_element" webkit_dom_document_create_element :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- tagName : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentCreateElement ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateElement ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@tagName@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateElement self tagName = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    tagName' <- textToCString tagName
    onException (do
        result <- propagateGError $ webkit_dom_document_create_element self' tagName'
        checkUnexpectedReturnNULL "dOMDocumentCreateElement" result
        result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
        touchManagedPtr self
        freeMem tagName'
        return result'
     ) (do
        freeMem tagName'
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateElementMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateElementMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateElement

#endif

-- method DOMDocument::create_element_ns
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "namespaceURI", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "qualifiedName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_element_ns" webkit_dom_document_create_element_ns :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- namespaceURI : TBasicType TUTF8
    CString ->                              -- qualifiedName : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentCreateElementNs ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateElementNs ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> Maybe (T.Text)
    {- ^ /@namespaceURI@/: A @/gchar/@ -}
    -> T.Text
    {- ^ /@qualifiedName@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateElementNs self namespaceURI qualifiedName = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    maybeNamespaceURI <- case namespaceURI of
        Nothing -> return nullPtr
        Just jNamespaceURI -> do
            jNamespaceURI' <- textToCString jNamespaceURI
            return jNamespaceURI'
    qualifiedName' <- textToCString qualifiedName
    onException (do
        result <- propagateGError $ webkit_dom_document_create_element_ns self' maybeNamespaceURI qualifiedName'
        checkUnexpectedReturnNULL "dOMDocumentCreateElementNs" result
        result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
        touchManagedPtr self
        freeMem maybeNamespaceURI
        freeMem qualifiedName'
        return result'
     ) (do
        freeMem maybeNamespaceURI
        freeMem qualifiedName'
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateElementNsMethodInfo
instance (signature ~ (Maybe (T.Text) -> T.Text -> m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateElementNsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateElementNs

#endif

-- method DOMDocument::create_entity_reference
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMEntityReference"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_entity_reference" webkit_dom_document_create_entity_reference :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- name : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMEntityReference.DOMEntityReference)

{-# DEPRECATED dOMDocumentCreateEntityReference ["(Since version 2.12)"] #-}
{- |
This function has been removed from the DOM spec and it just returns 'Nothing'.
-}
dOMDocumentCreateEntityReference ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> Maybe (T.Text)
    {- ^ /@name@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMEntityReference.DOMEntityReference
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMEntityReference.DOMEntityReference' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateEntityReference self name = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    maybeName <- case name of
        Nothing -> return nullPtr
        Just jName -> do
            jName' <- textToCString jName
            return jName'
    onException (do
        result <- propagateGError $ webkit_dom_document_create_entity_reference self' maybeName
        checkUnexpectedReturnNULL "dOMDocumentCreateEntityReference" result
        result' <- (newObject WebKit2WebExtension.DOMEntityReference.DOMEntityReference) result
        touchManagedPtr self
        freeMem maybeName
        return result'
     ) (do
        freeMem maybeName
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateEntityReferenceMethodInfo
instance (signature ~ (Maybe (T.Text) -> m WebKit2WebExtension.DOMEntityReference.DOMEntityReference), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateEntityReferenceMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateEntityReference

#endif

-- method DOMDocument::create_event
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "eventType", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMEvent"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_event" webkit_dom_document_create_event :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- eventType : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMEvent.DOMEvent)

{-# DEPRECATED dOMDocumentCreateEvent ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateEvent ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@eventType@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMEvent.DOMEvent
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMEvent.DOMEvent' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateEvent self eventType = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    eventType' <- textToCString eventType
    onException (do
        result <- propagateGError $ webkit_dom_document_create_event self' eventType'
        checkUnexpectedReturnNULL "dOMDocumentCreateEvent" result
        result' <- (wrapObject WebKit2WebExtension.DOMEvent.DOMEvent) result
        touchManagedPtr self
        freeMem eventType'
        return result'
     ) (do
        freeMem eventType'
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateEventMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMEvent.DOMEvent), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateEventMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateEvent

#endif

-- method DOMDocument::create_expression
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "expression", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "resolver", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathNSResolver"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMXPathNSResolver", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathExpression"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_expression" webkit_dom_document_create_expression :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- expression : TBasicType TUTF8
    Ptr WebKit2WebExtension.DOMXPathNSResolver.DOMXPathNSResolver -> -- resolver : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathNSResolver"})
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMXPathExpression.DOMXPathExpression)

{-# DEPRECATED dOMDocumentCreateExpression ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateExpression ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMXPathNSResolver.IsDOMXPathNSResolver b) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@expression@/: A @/gchar/@ -}
    -> b
    {- ^ /@resolver@/: A 'GI.WebKit2WebExtension.Interfaces.DOMXPathNSResolver.DOMXPathNSResolver' -}
    -> m WebKit2WebExtension.DOMXPathExpression.DOMXPathExpression
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMXPathExpression.DOMXPathExpression' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateExpression self expression resolver = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    expression' <- textToCString expression
    resolver' <- unsafeManagedPtrCastPtr resolver
    onException (do
        result <- propagateGError $ webkit_dom_document_create_expression self' expression' resolver'
        checkUnexpectedReturnNULL "dOMDocumentCreateExpression" result
        result' <- (wrapObject WebKit2WebExtension.DOMXPathExpression.DOMXPathExpression) result
        touchManagedPtr self
        touchManagedPtr resolver
        freeMem expression'
        return result'
     ) (do
        freeMem expression'
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateExpressionMethodInfo
instance (signature ~ (T.Text -> b -> m WebKit2WebExtension.DOMXPathExpression.DOMXPathExpression), MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMXPathNSResolver.IsDOMXPathNSResolver b) => O.MethodInfo DOMDocumentCreateExpressionMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateExpression

#endif

-- method DOMDocument::create_node_iterator
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "root", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNode", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "whatToShow", argType = TBasicType TULong, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gulong", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "filter", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeFilter"}), direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeFilter", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "expandEntityReferences", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gboolean", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeIterator"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_node_iterator" webkit_dom_document_create_node_iterator :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    Ptr WebKit2WebExtension.DOMNode.DOMNode -> -- root : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"})
    CULong ->                               -- whatToShow : TBasicType TULong
    Ptr WebKit2WebExtension.DOMNodeFilter.DOMNodeFilter -> -- filter : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeFilter"})
    CInt ->                                 -- expandEntityReferences : TBasicType TBoolean
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMNodeIterator.DOMNodeIterator)

{-# DEPRECATED dOMDocumentCreateNodeIterator ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateNodeIterator ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b, WebKit2WebExtension.DOMNodeFilter.IsDOMNodeFilter c) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> b
    {- ^ /@root@/: A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' -}
    -> CULong
    {- ^ /@whatToShow@/: A @/gulong/@ -}
    -> Maybe (c)
    {- ^ /@filter@/: A 'GI.WebKit2WebExtension.Interfaces.DOMNodeFilter.DOMNodeFilter' -}
    -> Bool
    {- ^ /@expandEntityReferences@/: A 'Bool' -}
    -> m WebKit2WebExtension.DOMNodeIterator.DOMNodeIterator
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNodeIterator.DOMNodeIterator' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateNodeIterator self root whatToShow filter expandEntityReferences = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    root' <- unsafeManagedPtrCastPtr root
    maybeFilter <- case filter of
        Nothing -> return nullPtr
        Just jFilter -> do
            jFilter' <- unsafeManagedPtrCastPtr jFilter
            return jFilter'
    let expandEntityReferences' = (fromIntegral . fromEnum) expandEntityReferences
    onException (do
        result <- propagateGError $ webkit_dom_document_create_node_iterator self' root' whatToShow maybeFilter expandEntityReferences'
        checkUnexpectedReturnNULL "dOMDocumentCreateNodeIterator" result
        result' <- (wrapObject WebKit2WebExtension.DOMNodeIterator.DOMNodeIterator) result
        touchManagedPtr self
        touchManagedPtr root
        whenJust filter touchManagedPtr
        return result'
     ) (do
        return ()
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateNodeIteratorMethodInfo
instance (signature ~ (b -> CULong -> Maybe (c) -> Bool -> m WebKit2WebExtension.DOMNodeIterator.DOMNodeIterator), MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b, WebKit2WebExtension.DOMNodeFilter.IsDOMNodeFilter c) => O.MethodInfo DOMDocumentCreateNodeIteratorMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateNodeIterator

#endif

-- method DOMDocument::create_ns_resolver
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "nodeResolver", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNode", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathNSResolver"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_create_ns_resolver" webkit_dom_document_create_ns_resolver :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    Ptr WebKit2WebExtension.DOMNode.DOMNode -> -- nodeResolver : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"})
    IO (Ptr WebKit2WebExtension.DOMXPathNSResolver.DOMXPathNSResolver)

{-# DEPRECATED dOMDocumentCreateNsResolver ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateNsResolver ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> b
    {- ^ /@nodeResolver@/: A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' -}
    -> m WebKit2WebExtension.DOMXPathNSResolver.DOMXPathNSResolver
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Interfaces.DOMXPathNSResolver.DOMXPathNSResolver' -}
dOMDocumentCreateNsResolver self nodeResolver = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    nodeResolver' <- unsafeManagedPtrCastPtr nodeResolver
    result <- webkit_dom_document_create_ns_resolver self' nodeResolver'
    checkUnexpectedReturnNULL "dOMDocumentCreateNsResolver" result
    result' <- (wrapObject WebKit2WebExtension.DOMXPathNSResolver.DOMXPathNSResolver) result
    touchManagedPtr self
    touchManagedPtr nodeResolver
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentCreateNsResolverMethodInfo
instance (signature ~ (b -> m WebKit2WebExtension.DOMXPathNSResolver.DOMXPathNSResolver), MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b) => O.MethodInfo DOMDocumentCreateNsResolverMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateNsResolver

#endif

-- method DOMDocument::create_processing_instruction
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "target", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "data", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMProcessingInstruction"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_processing_instruction" webkit_dom_document_create_processing_instruction :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- target : TBasicType TUTF8
    CString ->                              -- data : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMProcessingInstruction.DOMProcessingInstruction)

{-# DEPRECATED dOMDocumentCreateProcessingInstruction ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateProcessingInstruction ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@target@/: A @/gchar/@ -}
    -> T.Text
    {- ^ /@data@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMProcessingInstruction.DOMProcessingInstruction
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMProcessingInstruction.DOMProcessingInstruction' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateProcessingInstruction self target data_ = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    target' <- textToCString target
    data_' <- textToCString data_
    onException (do
        result <- propagateGError $ webkit_dom_document_create_processing_instruction self' target' data_'
        checkUnexpectedReturnNULL "dOMDocumentCreateProcessingInstruction" result
        result' <- (newObject WebKit2WebExtension.DOMProcessingInstruction.DOMProcessingInstruction) result
        touchManagedPtr self
        freeMem target'
        freeMem data_'
        return result'
     ) (do
        freeMem target'
        freeMem data_'
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateProcessingInstructionMethodInfo
instance (signature ~ (T.Text -> T.Text -> m WebKit2WebExtension.DOMProcessingInstruction.DOMProcessingInstruction), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateProcessingInstructionMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateProcessingInstruction

#endif

-- method DOMDocument::create_range
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMRange"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_create_range" webkit_dom_document_create_range :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMRange.DOMRange)

{-# DEPRECATED dOMDocumentCreateRange ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateRange ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMRange.DOMRange
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMRange.DOMRange' -}
dOMDocumentCreateRange self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_create_range self'
    checkUnexpectedReturnNULL "dOMDocumentCreateRange" result
    result' <- (wrapObject WebKit2WebExtension.DOMRange.DOMRange) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentCreateRangeMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMRange.DOMRange), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateRangeMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateRange

#endif

-- method DOMDocument::create_text_node
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "data", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMText"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_create_text_node" webkit_dom_document_create_text_node :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- data : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMText.DOMText)

{-# DEPRECATED dOMDocumentCreateTextNode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateTextNode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@data@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMText.DOMText
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMText.DOMText' -}
dOMDocumentCreateTextNode self data_ = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    data_' <- textToCString data_
    result <- webkit_dom_document_create_text_node self' data_'
    checkUnexpectedReturnNULL "dOMDocumentCreateTextNode" result
    result' <- (newObject WebKit2WebExtension.DOMText.DOMText) result
    touchManagedPtr self
    freeMem data_'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentCreateTextNodeMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMText.DOMText), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentCreateTextNodeMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateTextNode

#endif

-- method DOMDocument::create_tree_walker
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "root", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNode", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "whatToShow", argType = TBasicType TULong, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gulong", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "filter", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeFilter"}), direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNodeFilter", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "expandEntityReferences", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gboolean", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMTreeWalker"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_create_tree_walker" webkit_dom_document_create_tree_walker :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    Ptr WebKit2WebExtension.DOMNode.DOMNode -> -- root : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"})
    CULong ->                               -- whatToShow : TBasicType TULong
    Ptr WebKit2WebExtension.DOMNodeFilter.DOMNodeFilter -> -- filter : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeFilter"})
    CInt ->                                 -- expandEntityReferences : TBasicType TBoolean
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMTreeWalker.DOMTreeWalker)

{-# DEPRECATED dOMDocumentCreateTreeWalker ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentCreateTreeWalker ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b, WebKit2WebExtension.DOMNodeFilter.IsDOMNodeFilter c) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> b
    {- ^ /@root@/: A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' -}
    -> CULong
    {- ^ /@whatToShow@/: A @/gulong/@ -}
    -> Maybe (c)
    {- ^ /@filter@/: A 'GI.WebKit2WebExtension.Interfaces.DOMNodeFilter.DOMNodeFilter' -}
    -> Bool
    {- ^ /@expandEntityReferences@/: A 'Bool' -}
    -> m WebKit2WebExtension.DOMTreeWalker.DOMTreeWalker
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMTreeWalker.DOMTreeWalker' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentCreateTreeWalker self root whatToShow filter expandEntityReferences = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    root' <- unsafeManagedPtrCastPtr root
    maybeFilter <- case filter of
        Nothing -> return nullPtr
        Just jFilter -> do
            jFilter' <- unsafeManagedPtrCastPtr jFilter
            return jFilter'
    let expandEntityReferences' = (fromIntegral . fromEnum) expandEntityReferences
    onException (do
        result <- propagateGError $ webkit_dom_document_create_tree_walker self' root' whatToShow maybeFilter expandEntityReferences'
        checkUnexpectedReturnNULL "dOMDocumentCreateTreeWalker" result
        result' <- (wrapObject WebKit2WebExtension.DOMTreeWalker.DOMTreeWalker) result
        touchManagedPtr self
        touchManagedPtr root
        whenJust filter touchManagedPtr
        return result'
     ) (do
        return ()
     )

#if ENABLE_OVERLOADING
data DOMDocumentCreateTreeWalkerMethodInfo
instance (signature ~ (b -> CULong -> Maybe (c) -> Bool -> m WebKit2WebExtension.DOMTreeWalker.DOMTreeWalker), MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b, WebKit2WebExtension.DOMNodeFilter.IsDOMNodeFilter c) => O.MethodInfo DOMDocumentCreateTreeWalkerMethodInfo a signature where
    overloadedMethod _ = dOMDocumentCreateTreeWalker

#endif

-- method DOMDocument::element_from_point
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "x", argType = TBasicType TLong, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #glong", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "y", argType = TBasicType TLong, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #glong", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_element_from_point" webkit_dom_document_element_from_point :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CLong ->                                -- x : TBasicType TLong
    CLong ->                                -- y : TBasicType TLong
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentElementFromPoint ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentElementFromPoint ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> CLong
    {- ^ /@x@/: A @/glong/@ -}
    -> CLong
    {- ^ /@y@/: A @/glong/@ -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
dOMDocumentElementFromPoint self x y = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_element_from_point self' x y
    checkUnexpectedReturnNULL "dOMDocumentElementFromPoint" result
    result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentElementFromPointMethodInfo
instance (signature ~ (CLong -> CLong -> m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentElementFromPointMethodInfo a signature where
    overloadedMethod _ = dOMDocumentElementFromPoint

#endif

-- method DOMDocument::evaluate
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "expression", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "contextNode", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNode", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "resolver", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathNSResolver"}), direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "A #WebKitDOMXPathNSResolver", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "type", argType = TBasicType TUInt16, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gushort", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "inResult", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathResult"}), direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "A #WebKitDOMXPathResult", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathResult"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_evaluate" webkit_dom_document_evaluate :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- expression : TBasicType TUTF8
    Ptr WebKit2WebExtension.DOMNode.DOMNode -> -- contextNode : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"})
    Ptr WebKit2WebExtension.DOMXPathNSResolver.DOMXPathNSResolver -> -- resolver : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathNSResolver"})
    Word16 ->                               -- type : TBasicType TUInt16
    Ptr WebKit2WebExtension.DOMXPathResult.DOMXPathResult -> -- inResult : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMXPathResult"})
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMXPathResult.DOMXPathResult)

{-# DEPRECATED dOMDocumentEvaluate ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentEvaluate ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b, WebKit2WebExtension.DOMXPathNSResolver.IsDOMXPathNSResolver c, WebKit2WebExtension.DOMXPathResult.IsDOMXPathResult d) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@expression@/: A @/gchar/@ -}
    -> b
    {- ^ /@contextNode@/: A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' -}
    -> Maybe (c)
    {- ^ /@resolver@/: A 'GI.WebKit2WebExtension.Interfaces.DOMXPathNSResolver.DOMXPathNSResolver' -}
    -> Word16
    {- ^ /@type@/: A @/gushort/@ -}
    -> Maybe (d)
    {- ^ /@inResult@/: A 'GI.WebKit2WebExtension.Objects.DOMXPathResult.DOMXPathResult' -}
    -> m WebKit2WebExtension.DOMXPathResult.DOMXPathResult
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMXPathResult.DOMXPathResult' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentEvaluate self expression contextNode resolver type_ inResult = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    expression' <- textToCString expression
    contextNode' <- unsafeManagedPtrCastPtr contextNode
    maybeResolver <- case resolver of
        Nothing -> return nullPtr
        Just jResolver -> do
            jResolver' <- unsafeManagedPtrCastPtr jResolver
            return jResolver'
    maybeInResult <- case inResult of
        Nothing -> return nullPtr
        Just jInResult -> do
            jInResult' <- unsafeManagedPtrCastPtr jInResult
            return jInResult'
    onException (do
        result <- propagateGError $ webkit_dom_document_evaluate self' expression' contextNode' maybeResolver type_ maybeInResult
        checkUnexpectedReturnNULL "dOMDocumentEvaluate" result
        result' <- (wrapObject WebKit2WebExtension.DOMXPathResult.DOMXPathResult) result
        touchManagedPtr self
        touchManagedPtr contextNode
        whenJust resolver touchManagedPtr
        whenJust inResult touchManagedPtr
        freeMem expression'
        return result'
     ) (do
        freeMem expression'
     )

#if ENABLE_OVERLOADING
data DOMDocumentEvaluateMethodInfo
instance (signature ~ (T.Text -> b -> Maybe (c) -> Word16 -> Maybe (d) -> m WebKit2WebExtension.DOMXPathResult.DOMXPathResult), MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b, WebKit2WebExtension.DOMXPathNSResolver.IsDOMXPathNSResolver c, WebKit2WebExtension.DOMXPathResult.IsDOMXPathResult d) => O.MethodInfo DOMDocumentEvaluateMethodInfo a signature where
    overloadedMethod _ = dOMDocumentEvaluate

#endif

-- method DOMDocument::exec_command
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "command", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "userInterface", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gboolean", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_exec_command" webkit_dom_document_exec_command :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- command : TBasicType TUTF8
    CInt ->                                 -- userInterface : TBasicType TBoolean
    CString ->                              -- value : TBasicType TUTF8
    IO CInt

{-# DEPRECATED dOMDocumentExecCommand ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentExecCommand ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@command@/: A @/gchar/@ -}
    -> Bool
    {- ^ /@userInterface@/: A 'Bool' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentExecCommand self command userInterface value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    command' <- textToCString command
    let userInterface' = (fromIntegral . fromEnum) userInterface
    value' <- textToCString value
    result <- webkit_dom_document_exec_command self' command' userInterface' value'
    let result' = (/= 0) result
    touchManagedPtr self
    freeMem command'
    freeMem value'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentExecCommandMethodInfo
instance (signature ~ (T.Text -> Bool -> T.Text -> m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentExecCommandMethodInfo a signature where
    overloadedMethod _ = dOMDocumentExecCommand

#endif

-- method DOMDocument::exit_pointer_lock
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_exit_pointer_lock" webkit_dom_document_exit_pointer_lock :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO ()

{-# DEPRECATED dOMDocumentExitPointerLock ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentExitPointerLock ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m ()
dOMDocumentExitPointerLock self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    webkit_dom_document_exit_pointer_lock self'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data DOMDocumentExitPointerLockMethodInfo
instance (signature ~ (m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentExitPointerLockMethodInfo a signature where
    overloadedMethod _ = dOMDocumentExitPointerLock

#endif

-- method DOMDocument::get_active_element
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_active_element" webkit_dom_document_get_active_element :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentGetActiveElement ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetActiveElement ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
dOMDocumentGetActiveElement self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_active_element self'
    checkUnexpectedReturnNULL "dOMDocumentGetActiveElement" result
    result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetActiveElementMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetActiveElementMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetActiveElement

#endif

-- method DOMDocument::get_anchors
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_anchors" webkit_dom_document_get_anchors :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetAnchors ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetAnchors ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetAnchors self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_anchors self'
    checkUnexpectedReturnNULL "dOMDocumentGetAnchors" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetAnchorsMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetAnchorsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetAnchors

#endif

-- method DOMDocument::get_applets
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_applets" webkit_dom_document_get_applets :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetApplets ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetApplets ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetApplets self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_applets self'
    checkUnexpectedReturnNULL "dOMDocumentGetApplets" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetAppletsMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetAppletsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetApplets

#endif

-- method DOMDocument::get_body
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_body" webkit_dom_document_get_body :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLElement.DOMHTMLElement)

{-# DEPRECATED dOMDocumentGetBody ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetBody ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLElement.DOMHTMLElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLElement.DOMHTMLElement' -}
dOMDocumentGetBody self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_body self'
    checkUnexpectedReturnNULL "dOMDocumentGetBody" result
    result' <- (newObject WebKit2WebExtension.DOMHTMLElement.DOMHTMLElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetBodyMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLElement.DOMHTMLElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetBodyMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetBody

#endif

-- method DOMDocument::get_character_set
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_character_set" webkit_dom_document_get_character_set :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetCharacterSet ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetCharacterSet ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetCharacterSet self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_character_set self'
    checkUnexpectedReturnNULL "dOMDocumentGetCharacterSet" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetCharacterSetMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetCharacterSetMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetCharacterSet

#endif

-- method DOMDocument::get_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_charset" webkit_dom_document_get_charset :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetCharset ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetCharset ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetCharset self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_charset self'
    checkUnexpectedReturnNULL "dOMDocumentGetCharset" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetCharsetMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetCharsetMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetCharset

#endif

-- method DOMDocument::get_child_element_count
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TULong)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_child_element_count" webkit_dom_document_get_child_element_count :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CULong

{-# DEPRECATED dOMDocumentGetChildElementCount ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetChildElementCount ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m CULong
    {- ^ __Returns:__ A @/gulong/@ -}
dOMDocumentGetChildElementCount self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_child_element_count self'
    touchManagedPtr self
    return result

#if ENABLE_OVERLOADING
data DOMDocumentGetChildElementCountMethodInfo
instance (signature ~ (m CULong), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetChildElementCountMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetChildElementCount

#endif

-- method DOMDocument::get_children
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_children" webkit_dom_document_get_children :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetChildren ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetChildren ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetChildren self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_children self'
    checkUnexpectedReturnNULL "dOMDocumentGetChildren" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetChildrenMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetChildrenMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetChildren

#endif

-- method DOMDocument::get_compat_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_compat_mode" webkit_dom_document_get_compat_mode :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetCompatMode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.14/
-}
dOMDocumentGetCompatMode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetCompatMode self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_compat_mode self'
    checkUnexpectedReturnNULL "dOMDocumentGetCompatMode" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetCompatModeMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetCompatModeMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetCompatMode

#endif

-- method DOMDocument::get_content_type
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_content_type" webkit_dom_document_get_content_type :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetContentType ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetContentType ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetContentType self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_content_type self'
    checkUnexpectedReturnNULL "dOMDocumentGetContentType" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetContentTypeMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetContentTypeMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetContentType

#endif

-- method DOMDocument::get_cookie
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_get_cookie" webkit_dom_document_get_cookie :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    Ptr (Ptr GError) ->                     -- error
    IO CString

{-# DEPRECATED dOMDocumentGetCookie ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetCookie ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentGetCookie self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    onException (do
        result <- propagateGError $ webkit_dom_document_get_cookie self'
        checkUnexpectedReturnNULL "dOMDocumentGetCookie" result
        result' <- cstringToText result
        freeMem result
        touchManagedPtr self
        return result'
     ) (do
        return ()
     )

#if ENABLE_OVERLOADING
data DOMDocumentGetCookieMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetCookieMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetCookie

#endif

-- method DOMDocument::get_current_script
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLScriptElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_current_script" webkit_dom_document_get_current_script :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLScriptElement.DOMHTMLScriptElement)

{-# DEPRECATED dOMDocumentGetCurrentScript ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetCurrentScript ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLScriptElement.DOMHTMLScriptElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLScriptElement.DOMHTMLScriptElement' -}
dOMDocumentGetCurrentScript self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_current_script self'
    checkUnexpectedReturnNULL "dOMDocumentGetCurrentScript" result
    result' <- (newObject WebKit2WebExtension.DOMHTMLScriptElement.DOMHTMLScriptElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetCurrentScriptMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLScriptElement.DOMHTMLScriptElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetCurrentScriptMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetCurrentScript

#endif

-- method DOMDocument::get_default_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_default_charset" webkit_dom_document_get_default_charset :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetDefaultCharset ["(Since version 2.14)"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetDefaultCharset ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetDefaultCharset self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_default_charset self'
    checkUnexpectedReturnNULL "dOMDocumentGetDefaultCharset" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetDefaultCharsetMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetDefaultCharsetMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetDefaultCharset

#endif

-- method DOMDocument::get_default_view
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDOMWindow"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_default_view" webkit_dom_document_get_default_view :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMDOMWindow.DOMDOMWindow)

{-# DEPRECATED dOMDocumentGetDefaultView ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetDefaultView ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMDOMWindow.DOMDOMWindow
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMDOMWindow.DOMDOMWindow' -}
dOMDocumentGetDefaultView self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_default_view self'
    checkUnexpectedReturnNULL "dOMDocumentGetDefaultView" result
    result' <- (wrapObject WebKit2WebExtension.DOMDOMWindow.DOMDOMWindow) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetDefaultViewMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMDOMWindow.DOMDOMWindow), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetDefaultViewMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetDefaultView

#endif

-- method DOMDocument::get_design_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_design_mode" webkit_dom_document_get_design_mode :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetDesignMode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.14/
-}
dOMDocumentGetDesignMode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetDesignMode self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_design_mode self'
    checkUnexpectedReturnNULL "dOMDocumentGetDesignMode" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetDesignModeMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetDesignModeMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetDesignMode

#endif

-- method DOMDocument::get_dir
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_dir" webkit_dom_document_get_dir :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetDir ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetDir ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetDir self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_dir self'
    checkUnexpectedReturnNULL "dOMDocumentGetDir" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetDirMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetDirMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetDir

#endif

-- method DOMDocument::get_doctype
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocumentType"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_doctype" webkit_dom_document_get_doctype :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMDocumentType.DOMDocumentType)

{-# DEPRECATED dOMDocumentGetDoctype ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetDoctype ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMDocumentType.DOMDocumentType
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMDocumentType.DOMDocumentType' -}
dOMDocumentGetDoctype self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_doctype self'
    checkUnexpectedReturnNULL "dOMDocumentGetDoctype" result
    result' <- (newObject WebKit2WebExtension.DOMDocumentType.DOMDocumentType) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetDoctypeMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMDocumentType.DOMDocumentType), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetDoctypeMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetDoctype

#endif

-- method DOMDocument::get_document_element
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_document_element" webkit_dom_document_get_document_element :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentGetDocumentElement ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetDocumentElement ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
dOMDocumentGetDocumentElement self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_document_element self'
    checkUnexpectedReturnNULL "dOMDocumentGetDocumentElement" result
    result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetDocumentElementMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetDocumentElementMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetDocumentElement

#endif

-- method DOMDocument::get_document_uri
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_document_uri" webkit_dom_document_get_document_uri :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetDocumentUri ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetDocumentUri ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetDocumentUri self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_document_uri self'
    checkUnexpectedReturnNULL "dOMDocumentGetDocumentUri" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetDocumentUriMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetDocumentUriMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetDocumentUri

#endif

-- method DOMDocument::get_domain
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_domain" webkit_dom_document_get_domain :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetDomain ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetDomain ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetDomain self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_domain self'
    checkUnexpectedReturnNULL "dOMDocumentGetDomain" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetDomainMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetDomainMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetDomain

#endif

-- method DOMDocument::get_element_by_id
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "elementId", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_element_by_id" webkit_dom_document_get_element_by_id :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- elementId : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentGetElementById ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetElementById ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@elementId@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
dOMDocumentGetElementById self elementId = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    elementId' <- textToCString elementId
    result <- webkit_dom_document_get_element_by_id self' elementId'
    checkUnexpectedReturnNULL "dOMDocumentGetElementById" result
    result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
    touchManagedPtr self
    freeMem elementId'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetElementByIdMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetElementByIdMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetElementById

#endif

-- method DOMDocument::get_elements_by_class_name
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "class_name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #gchar with the tag name", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeList"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_elements_by_class_name" webkit_dom_document_get_elements_by_class_name :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- class_name : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMNodeList.DOMNodeList)

{-# DEPRECATED dOMDocumentGetElementsByClassName ["(Since version 2.12)","Use 'GI.WebKit2WebExtension.Objects.DOMDocument.dOMDocumentGetElementsByClassNameAsHtmlCollection' instead."] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetElementsByClassName ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@className@/: a @/gchar/@ with the tag name -}
    -> m WebKit2WebExtension.DOMNodeList.DOMNodeList
    {- ^ __Returns:__ a 'GI.WebKit2WebExtension.Objects.DOMNodeList.DOMNodeList' -}
dOMDocumentGetElementsByClassName self className = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    className' <- textToCString className
    result <- webkit_dom_document_get_elements_by_class_name self' className'
    checkUnexpectedReturnNULL "dOMDocumentGetElementsByClassName" result
    result' <- (wrapObject WebKit2WebExtension.DOMNodeList.DOMNodeList) result
    touchManagedPtr self
    freeMem className'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetElementsByClassNameMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMNodeList.DOMNodeList), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetElementsByClassNameMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetElementsByClassName

#endif

-- method DOMDocument::get_elements_by_class_name_as_html_collection
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "classNames", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_elements_by_class_name_as_html_collection" webkit_dom_document_get_elements_by_class_name_as_html_collection :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- classNames : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetElementsByClassNameAsHtmlCollection ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.12/
-}
dOMDocumentGetElementsByClassNameAsHtmlCollection ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@classNames@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetElementsByClassNameAsHtmlCollection self classNames = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    classNames' <- textToCString classNames
    result <- webkit_dom_document_get_elements_by_class_name_as_html_collection self' classNames'
    checkUnexpectedReturnNULL "dOMDocumentGetElementsByClassNameAsHtmlCollection" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    freeMem classNames'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetElementsByClassNameAsHtmlCollectionMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetElementsByClassNameAsHtmlCollectionMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetElementsByClassNameAsHtmlCollection

#endif

-- method DOMDocument::get_elements_by_name
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "elementName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeList"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_elements_by_name" webkit_dom_document_get_elements_by_name :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- elementName : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMNodeList.DOMNodeList)

{-# DEPRECATED dOMDocumentGetElementsByName ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetElementsByName ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@elementName@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMNodeList.DOMNodeList
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNodeList.DOMNodeList' -}
dOMDocumentGetElementsByName self elementName = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    elementName' <- textToCString elementName
    result <- webkit_dom_document_get_elements_by_name self' elementName'
    checkUnexpectedReturnNULL "dOMDocumentGetElementsByName" result
    result' <- (wrapObject WebKit2WebExtension.DOMNodeList.DOMNodeList) result
    touchManagedPtr self
    freeMem elementName'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetElementsByNameMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMNodeList.DOMNodeList), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetElementsByNameMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetElementsByName

#endif

-- method DOMDocument::get_elements_by_tag_name
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "tag_name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #gchar with the tag name", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeList"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_elements_by_tag_name" webkit_dom_document_get_elements_by_tag_name :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- tag_name : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMNodeList.DOMNodeList)

{-# DEPRECATED dOMDocumentGetElementsByTagName ["(Since version 2.12)","Use 'GI.WebKit2WebExtension.Objects.DOMDocument.dOMDocumentGetElementsByTagNameAsHtmlCollection' instead."] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetElementsByTagName ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@tagName@/: a @/gchar/@ with the tag name -}
    -> m WebKit2WebExtension.DOMNodeList.DOMNodeList
    {- ^ __Returns:__ a 'GI.WebKit2WebExtension.Objects.DOMNodeList.DOMNodeList' -}
dOMDocumentGetElementsByTagName self tagName = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    tagName' <- textToCString tagName
    result <- webkit_dom_document_get_elements_by_tag_name self' tagName'
    checkUnexpectedReturnNULL "dOMDocumentGetElementsByTagName" result
    result' <- (wrapObject WebKit2WebExtension.DOMNodeList.DOMNodeList) result
    touchManagedPtr self
    freeMem tagName'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetElementsByTagNameMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMNodeList.DOMNodeList), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetElementsByTagNameMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetElementsByTagName

#endif

-- method DOMDocument::get_elements_by_tag_name_as_html_collection
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "tagname", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_elements_by_tag_name_as_html_collection" webkit_dom_document_get_elements_by_tag_name_as_html_collection :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- tagname : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetElementsByTagNameAsHtmlCollection ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.12/
-}
dOMDocumentGetElementsByTagNameAsHtmlCollection ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@tagname@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetElementsByTagNameAsHtmlCollection self tagname = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    tagname' <- textToCString tagname
    result <- webkit_dom_document_get_elements_by_tag_name_as_html_collection self' tagname'
    checkUnexpectedReturnNULL "dOMDocumentGetElementsByTagNameAsHtmlCollection" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    freeMem tagname'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetElementsByTagNameAsHtmlCollectionMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetElementsByTagNameAsHtmlCollectionMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetElementsByTagNameAsHtmlCollection

#endif

-- method DOMDocument::get_elements_by_tag_name_ns
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "namespace_uri", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #gchar with the namespace URI", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "tag_name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #gchar with the tag name", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeList"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_elements_by_tag_name_ns" webkit_dom_document_get_elements_by_tag_name_ns :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- namespace_uri : TBasicType TUTF8
    CString ->                              -- tag_name : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMNodeList.DOMNodeList)

{-# DEPRECATED dOMDocumentGetElementsByTagNameNs ["(Since version 2.12)","Use 'GI.WebKit2WebExtension.Objects.DOMDocument.dOMDocumentGetElementsByTagNameNsAsHtmlCollection' instead."] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetElementsByTagNameNs ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@namespaceUri@/: a @/gchar/@ with the namespace URI -}
    -> T.Text
    {- ^ /@tagName@/: a @/gchar/@ with the tag name -}
    -> m WebKit2WebExtension.DOMNodeList.DOMNodeList
    {- ^ __Returns:__ a 'GI.WebKit2WebExtension.Objects.DOMNodeList.DOMNodeList' -}
dOMDocumentGetElementsByTagNameNs self namespaceUri tagName = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    namespaceUri' <- textToCString namespaceUri
    tagName' <- textToCString tagName
    result <- webkit_dom_document_get_elements_by_tag_name_ns self' namespaceUri' tagName'
    checkUnexpectedReturnNULL "dOMDocumentGetElementsByTagNameNs" result
    result' <- (wrapObject WebKit2WebExtension.DOMNodeList.DOMNodeList) result
    touchManagedPtr self
    freeMem namespaceUri'
    freeMem tagName'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetElementsByTagNameNsMethodInfo
instance (signature ~ (T.Text -> T.Text -> m WebKit2WebExtension.DOMNodeList.DOMNodeList), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetElementsByTagNameNsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetElementsByTagNameNs

#endif

-- method DOMDocument::get_elements_by_tag_name_ns_as_html_collection
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "namespaceURI", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "localName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_elements_by_tag_name_ns_as_html_collection" webkit_dom_document_get_elements_by_tag_name_ns_as_html_collection :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- namespaceURI : TBasicType TUTF8
    CString ->                              -- localName : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetElementsByTagNameNsAsHtmlCollection ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.12/
-}
dOMDocumentGetElementsByTagNameNsAsHtmlCollection ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@namespaceURI@/: A @/gchar/@ -}
    -> T.Text
    {- ^ /@localName@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetElementsByTagNameNsAsHtmlCollection self namespaceURI localName = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    namespaceURI' <- textToCString namespaceURI
    localName' <- textToCString localName
    result <- webkit_dom_document_get_elements_by_tag_name_ns_as_html_collection self' namespaceURI' localName'
    checkUnexpectedReturnNULL "dOMDocumentGetElementsByTagNameNsAsHtmlCollection" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    freeMem namespaceURI'
    freeMem localName'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetElementsByTagNameNsAsHtmlCollectionMethodInfo
instance (signature ~ (T.Text -> T.Text -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetElementsByTagNameNsAsHtmlCollectionMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetElementsByTagNameNsAsHtmlCollection

#endif

-- method DOMDocument::get_embeds
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_embeds" webkit_dom_document_get_embeds :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetEmbeds ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.14/
-}
dOMDocumentGetEmbeds ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetEmbeds self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_embeds self'
    checkUnexpectedReturnNULL "dOMDocumentGetEmbeds" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetEmbedsMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetEmbedsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetEmbeds

#endif

-- method DOMDocument::get_first_element_child
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_first_element_child" webkit_dom_document_get_first_element_child :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentGetFirstElementChild ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetFirstElementChild ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
dOMDocumentGetFirstElementChild self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_first_element_child self'
    checkUnexpectedReturnNULL "dOMDocumentGetFirstElementChild" result
    result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetFirstElementChildMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetFirstElementChildMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetFirstElementChild

#endif

-- method DOMDocument::get_forms
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_forms" webkit_dom_document_get_forms :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetForms ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetForms ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetForms self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_forms self'
    checkUnexpectedReturnNULL "dOMDocumentGetForms" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetFormsMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetFormsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetForms

#endif

-- method DOMDocument::get_head
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLHeadElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_head" webkit_dom_document_get_head :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLHeadElement.DOMHTMLHeadElement)

{-# DEPRECATED dOMDocumentGetHead ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetHead ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLHeadElement.DOMHTMLHeadElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLHeadElement.DOMHTMLHeadElement' -}
dOMDocumentGetHead self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_head self'
    checkUnexpectedReturnNULL "dOMDocumentGetHead" result
    result' <- (newObject WebKit2WebExtension.DOMHTMLHeadElement.DOMHTMLHeadElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetHeadMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLHeadElement.DOMHTMLHeadElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetHeadMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetHead

#endif

-- method DOMDocument::get_hidden
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_hidden" webkit_dom_document_get_hidden :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CInt

{-# DEPRECATED dOMDocumentGetHidden ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetHidden ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentGetHidden self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_hidden self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetHiddenMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetHiddenMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetHidden

#endif

-- method DOMDocument::get_images
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_images" webkit_dom_document_get_images :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetImages ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetImages ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetImages self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_images self'
    checkUnexpectedReturnNULL "dOMDocumentGetImages" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetImagesMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetImagesMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetImages

#endif

-- method DOMDocument::get_implementation
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDOMImplementation"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_implementation" webkit_dom_document_get_implementation :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMDOMImplementation.DOMDOMImplementation)

{-# DEPRECATED dOMDocumentGetImplementation ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetImplementation ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMDOMImplementation.DOMDOMImplementation
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMDOMImplementation.DOMDOMImplementation' -}
dOMDocumentGetImplementation self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_implementation self'
    checkUnexpectedReturnNULL "dOMDocumentGetImplementation" result
    result' <- (wrapObject WebKit2WebExtension.DOMDOMImplementation.DOMDOMImplementation) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetImplementationMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMDOMImplementation.DOMDOMImplementation), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetImplementationMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetImplementation

#endif

-- method DOMDocument::get_input_encoding
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_input_encoding" webkit_dom_document_get_input_encoding :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetInputEncoding ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetInputEncoding ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetInputEncoding self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_input_encoding self'
    checkUnexpectedReturnNULL "dOMDocumentGetInputEncoding" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetInputEncodingMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetInputEncodingMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetInputEncoding

#endif

-- method DOMDocument::get_last_element_child
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_last_element_child" webkit_dom_document_get_last_element_child :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentGetLastElementChild ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetLastElementChild ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
dOMDocumentGetLastElementChild self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_last_element_child self'
    checkUnexpectedReturnNULL "dOMDocumentGetLastElementChild" result
    result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetLastElementChildMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetLastElementChildMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetLastElementChild

#endif

-- method DOMDocument::get_last_modified
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_last_modified" webkit_dom_document_get_last_modified :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetLastModified ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetLastModified ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetLastModified self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_last_modified self'
    checkUnexpectedReturnNULL "dOMDocumentGetLastModified" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetLastModifiedMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetLastModifiedMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetLastModified

#endif

-- method DOMDocument::get_links
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_links" webkit_dom_document_get_links :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetLinks ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetLinks ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetLinks self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_links self'
    checkUnexpectedReturnNULL "dOMDocumentGetLinks" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetLinksMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetLinksMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetLinks

#endif

-- method DOMDocument::get_origin
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_origin" webkit_dom_document_get_origin :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetOrigin ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetOrigin ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetOrigin self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_origin self'
    checkUnexpectedReturnNULL "dOMDocumentGetOrigin" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetOriginMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetOriginMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetOrigin

#endif

-- method DOMDocument::get_override_style
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "element", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMElement", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "pseudoElement", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMCSSStyleDeclaration"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_override_style" webkit_dom_document_get_override_style :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    Ptr WebKit2WebExtension.DOMElement.DOMElement -> -- element : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"})
    CString ->                              -- pseudoElement : TBasicType TUTF8
    IO (Ptr WebKit2WebExtension.DOMCSSStyleDeclaration.DOMCSSStyleDeclaration)

{-# DEPRECATED dOMDocumentGetOverrideStyle ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetOverrideStyle ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMElement.IsDOMElement b) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> b
    {- ^ /@element@/: A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
    -> Maybe (T.Text)
    {- ^ /@pseudoElement@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMCSSStyleDeclaration.DOMCSSStyleDeclaration
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMCSSStyleDeclaration.DOMCSSStyleDeclaration' -}
dOMDocumentGetOverrideStyle self element pseudoElement = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    element' <- unsafeManagedPtrCastPtr element
    maybePseudoElement <- case pseudoElement of
        Nothing -> return nullPtr
        Just jPseudoElement -> do
            jPseudoElement' <- textToCString jPseudoElement
            return jPseudoElement'
    result <- webkit_dom_document_get_override_style self' element' maybePseudoElement
    checkUnexpectedReturnNULL "dOMDocumentGetOverrideStyle" result
    result' <- (wrapObject WebKit2WebExtension.DOMCSSStyleDeclaration.DOMCSSStyleDeclaration) result
    touchManagedPtr self
    touchManagedPtr element
    freeMem maybePseudoElement
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetOverrideStyleMethodInfo
instance (signature ~ (b -> Maybe (T.Text) -> m WebKit2WebExtension.DOMCSSStyleDeclaration.DOMCSSStyleDeclaration), MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMElement.IsDOMElement b) => O.MethodInfo DOMDocumentGetOverrideStyleMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetOverrideStyle

#endif

-- method DOMDocument::get_plugins
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_plugins" webkit_dom_document_get_plugins :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetPlugins ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.14/
-}
dOMDocumentGetPlugins ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetPlugins self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_plugins self'
    checkUnexpectedReturnNULL "dOMDocumentGetPlugins" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetPluginsMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetPluginsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetPlugins

#endif

-- method DOMDocument::get_pointer_lock_element
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_pointer_lock_element" webkit_dom_document_get_pointer_lock_element :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentGetPointerLockElement ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetPointerLockElement ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
dOMDocumentGetPointerLockElement self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_pointer_lock_element self'
    checkUnexpectedReturnNULL "dOMDocumentGetPointerLockElement" result
    result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetPointerLockElementMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetPointerLockElementMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetPointerLockElement

#endif

-- method DOMDocument::get_preferred_stylesheet_set
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_preferred_stylesheet_set" webkit_dom_document_get_preferred_stylesheet_set :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetPreferredStylesheetSet ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
This function has been removed and does nothing.
-}
dOMDocumentGetPreferredStylesheetSet ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetPreferredStylesheetSet self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_preferred_stylesheet_set self'
    checkUnexpectedReturnNULL "dOMDocumentGetPreferredStylesheetSet" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetPreferredStylesheetSetMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetPreferredStylesheetSetMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetPreferredStylesheetSet

#endif

-- method DOMDocument::get_ready_state
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_ready_state" webkit_dom_document_get_ready_state :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetReadyState ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetReadyState ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetReadyState self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_ready_state self'
    checkUnexpectedReturnNULL "dOMDocumentGetReadyState" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetReadyStateMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetReadyStateMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetReadyState

#endif

-- method DOMDocument::get_referrer
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_referrer" webkit_dom_document_get_referrer :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetReferrer ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetReferrer ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetReferrer self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_referrer self'
    checkUnexpectedReturnNULL "dOMDocumentGetReferrer" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetReferrerMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetReferrerMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetReferrer

#endif

-- method DOMDocument::get_scripts
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLCollection"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_scripts" webkit_dom_document_get_scripts :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection)

{-# DEPRECATED dOMDocumentGetScripts ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.14/
-}
dOMDocumentGetScripts ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMHTMLCollection.DOMHTMLCollection' -}
dOMDocumentGetScripts self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_scripts self'
    checkUnexpectedReturnNULL "dOMDocumentGetScripts" result
    result' <- (wrapObject WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetScriptsMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMHTMLCollection.DOMHTMLCollection), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetScriptsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetScripts

#endif

-- method DOMDocument::get_scrolling_element
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_scrolling_element" webkit_dom_document_get_scrolling_element :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentGetScrollingElement ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetScrollingElement ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
dOMDocumentGetScrollingElement self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_scrolling_element self'
    checkUnexpectedReturnNULL "dOMDocumentGetScrollingElement" result
    result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetScrollingElementMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetScrollingElementMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetScrollingElement

#endif

-- method DOMDocument::get_selected_stylesheet_set
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_selected_stylesheet_set" webkit_dom_document_get_selected_stylesheet_set :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetSelectedStylesheetSet ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
This function has been removed and does nothing.
-}
dOMDocumentGetSelectedStylesheetSet ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetSelectedStylesheetSet self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_selected_stylesheet_set self'
    checkUnexpectedReturnNULL "dOMDocumentGetSelectedStylesheetSet" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetSelectedStylesheetSetMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetSelectedStylesheetSetMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetSelectedStylesheetSet

#endif

-- method DOMDocument::get_style_sheets
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMStyleSheetList"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_style_sheets" webkit_dom_document_get_style_sheets :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMStyleSheetList.DOMStyleSheetList)

{-# DEPRECATED dOMDocumentGetStyleSheets ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetStyleSheets ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMStyleSheetList.DOMStyleSheetList
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMStyleSheetList.DOMStyleSheetList' -}
dOMDocumentGetStyleSheets self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_style_sheets self'
    checkUnexpectedReturnNULL "dOMDocumentGetStyleSheets" result
    result' <- (newObject WebKit2WebExtension.DOMStyleSheetList.DOMStyleSheetList) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetStyleSheetsMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMStyleSheetList.DOMStyleSheetList), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetStyleSheetsMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetStyleSheets

#endif

-- method DOMDocument::get_title
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_title" webkit_dom_document_get_title :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetTitle ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetTitle ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetTitle self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_title self'
    checkUnexpectedReturnNULL "dOMDocumentGetTitle" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetTitleMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetTitleMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetTitle

#endif

-- method DOMDocument::get_url
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_url" webkit_dom_document_get_url :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetUrl ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetUrl ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetUrl self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_url self'
    checkUnexpectedReturnNULL "dOMDocumentGetUrl" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetUrlMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetUrlMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetUrl

#endif

-- method DOMDocument::get_visibility_state
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_visibility_state" webkit_dom_document_get_visibility_state :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetVisibilityState ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetVisibilityState ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetVisibilityState self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_visibility_state self'
    checkUnexpectedReturnNULL "dOMDocumentGetVisibilityState" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetVisibilityStateMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetVisibilityStateMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetVisibilityState

#endif

-- method DOMDocument::get_webkit_current_fullscreen_element
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_webkit_current_fullscreen_element" webkit_dom_document_get_webkit_current_fullscreen_element :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentGetWebkitCurrentFullscreenElement ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetWebkitCurrentFullscreenElement ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
dOMDocumentGetWebkitCurrentFullscreenElement self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_webkit_current_fullscreen_element self'
    checkUnexpectedReturnNULL "dOMDocumentGetWebkitCurrentFullscreenElement" result
    result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetWebkitCurrentFullscreenElementMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetWebkitCurrentFullscreenElementMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetWebkitCurrentFullscreenElement

#endif

-- method DOMDocument::get_webkit_fullscreen_element
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_webkit_fullscreen_element" webkit_dom_document_get_webkit_fullscreen_element :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentGetWebkitFullscreenElement ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetWebkitFullscreenElement ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' -}
dOMDocumentGetWebkitFullscreenElement self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_webkit_fullscreen_element self'
    checkUnexpectedReturnNULL "dOMDocumentGetWebkitFullscreenElement" result
    result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetWebkitFullscreenElementMethodInfo
instance (signature ~ (m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetWebkitFullscreenElementMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetWebkitFullscreenElement

#endif

-- method DOMDocument::get_webkit_fullscreen_enabled
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_webkit_fullscreen_enabled" webkit_dom_document_get_webkit_fullscreen_enabled :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CInt

{-# DEPRECATED dOMDocumentGetWebkitFullscreenEnabled ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetWebkitFullscreenEnabled ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentGetWebkitFullscreenEnabled self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_webkit_fullscreen_enabled self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetWebkitFullscreenEnabledMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetWebkitFullscreenEnabledMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetWebkitFullscreenEnabled

#endif

-- method DOMDocument::get_webkit_fullscreen_keyboard_input_allowed
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_webkit_fullscreen_keyboard_input_allowed" webkit_dom_document_get_webkit_fullscreen_keyboard_input_allowed :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CInt

{-# DEPRECATED dOMDocumentGetWebkitFullscreenKeyboardInputAllowed ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetWebkitFullscreenKeyboardInputAllowed ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentGetWebkitFullscreenKeyboardInputAllowed self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_webkit_fullscreen_keyboard_input_allowed self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetWebkitFullscreenKeyboardInputAllowedMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetWebkitFullscreenKeyboardInputAllowedMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetWebkitFullscreenKeyboardInputAllowed

#endif

-- method DOMDocument::get_webkit_is_fullscreen
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_webkit_is_fullscreen" webkit_dom_document_get_webkit_is_fullscreen :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CInt

{-# DEPRECATED dOMDocumentGetWebkitIsFullscreen ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentGetWebkitIsFullscreen ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentGetWebkitIsFullscreen self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_webkit_is_fullscreen self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetWebkitIsFullscreenMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetWebkitIsFullscreenMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetWebkitIsFullscreen

#endif

-- method DOMDocument::get_xml_encoding
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_xml_encoding" webkit_dom_document_get_xml_encoding :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetXmlEncoding ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetXmlEncoding ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetXmlEncoding self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_xml_encoding self'
    checkUnexpectedReturnNULL "dOMDocumentGetXmlEncoding" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetXmlEncodingMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetXmlEncodingMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetXmlEncoding

#endif

-- method DOMDocument::get_xml_standalone
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_xml_standalone" webkit_dom_document_get_xml_standalone :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CInt

{-# DEPRECATED dOMDocumentGetXmlStandalone ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetXmlStandalone ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentGetXmlStandalone self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_xml_standalone self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetXmlStandaloneMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetXmlStandaloneMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetXmlStandalone

#endif

-- method DOMDocument::get_xml_version
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_get_xml_version" webkit_dom_document_get_xml_version :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CString

{-# DEPRECATED dOMDocumentGetXmlVersion ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentGetXmlVersion ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentGetXmlVersion self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_get_xml_version self'
    checkUnexpectedReturnNULL "dOMDocumentGetXmlVersion" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentGetXmlVersionMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentGetXmlVersionMethodInfo a signature where
    overloadedMethod _ = dOMDocumentGetXmlVersion

#endif

-- method DOMDocument::has_focus
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_has_focus" webkit_dom_document_has_focus :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO CInt

{-# DEPRECATED dOMDocumentHasFocus ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentHasFocus ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentHasFocus self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- webkit_dom_document_has_focus self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentHasFocusMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentHasFocusMethodInfo a signature where
    overloadedMethod _ = dOMDocumentHasFocus

#endif

-- method DOMDocument::import_node
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "importedNode", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMNode", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "deep", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gboolean", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_import_node" webkit_dom_document_import_node :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    Ptr WebKit2WebExtension.DOMNode.DOMNode -> -- importedNode : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNode"})
    CInt ->                                 -- deep : TBasicType TBoolean
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMNode.DOMNode)

{-# DEPRECATED dOMDocumentImportNode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentImportNode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> b
    {- ^ /@importedNode@/: A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' -}
    -> Bool
    {- ^ /@deep@/: A 'Bool' -}
    -> m WebKit2WebExtension.DOMNode.DOMNode
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNode.DOMNode' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentImportNode self importedNode deep = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    importedNode' <- unsafeManagedPtrCastPtr importedNode
    let deep' = (fromIntegral . fromEnum) deep
    onException (do
        result <- propagateGError $ webkit_dom_document_import_node self' importedNode' deep'
        checkUnexpectedReturnNULL "dOMDocumentImportNode" result
        result' <- (newObject WebKit2WebExtension.DOMNode.DOMNode) result
        touchManagedPtr self
        touchManagedPtr importedNode
        return result'
     ) (do
        return ()
     )

#if ENABLE_OVERLOADING
data DOMDocumentImportNodeMethodInfo
instance (signature ~ (b -> Bool -> m WebKit2WebExtension.DOMNode.DOMNode), MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMNode.IsDOMNode b) => O.MethodInfo DOMDocumentImportNodeMethodInfo a signature where
    overloadedMethod _ = dOMDocumentImportNode

#endif

-- method DOMDocument::query_command_enabled
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "command", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_query_command_enabled" webkit_dom_document_query_command_enabled :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- command : TBasicType TUTF8
    IO CInt

{-# DEPRECATED dOMDocumentQueryCommandEnabled ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentQueryCommandEnabled ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@command@/: A @/gchar/@ -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentQueryCommandEnabled self command = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    command' <- textToCString command
    result <- webkit_dom_document_query_command_enabled self' command'
    let result' = (/= 0) result
    touchManagedPtr self
    freeMem command'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentQueryCommandEnabledMethodInfo
instance (signature ~ (T.Text -> m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentQueryCommandEnabledMethodInfo a signature where
    overloadedMethod _ = dOMDocumentQueryCommandEnabled

#endif

-- method DOMDocument::query_command_indeterm
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "command", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_query_command_indeterm" webkit_dom_document_query_command_indeterm :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- command : TBasicType TUTF8
    IO CInt

{-# DEPRECATED dOMDocumentQueryCommandIndeterm ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentQueryCommandIndeterm ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@command@/: A @/gchar/@ -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentQueryCommandIndeterm self command = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    command' <- textToCString command
    result <- webkit_dom_document_query_command_indeterm self' command'
    let result' = (/= 0) result
    touchManagedPtr self
    freeMem command'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentQueryCommandIndetermMethodInfo
instance (signature ~ (T.Text -> m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentQueryCommandIndetermMethodInfo a signature where
    overloadedMethod _ = dOMDocumentQueryCommandIndeterm

#endif

-- method DOMDocument::query_command_state
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "command", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_query_command_state" webkit_dom_document_query_command_state :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- command : TBasicType TUTF8
    IO CInt

{-# DEPRECATED dOMDocumentQueryCommandState ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentQueryCommandState ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@command@/: A @/gchar/@ -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentQueryCommandState self command = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    command' <- textToCString command
    result <- webkit_dom_document_query_command_state self' command'
    let result' = (/= 0) result
    touchManagedPtr self
    freeMem command'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentQueryCommandStateMethodInfo
instance (signature ~ (T.Text -> m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentQueryCommandStateMethodInfo a signature where
    overloadedMethod _ = dOMDocumentQueryCommandState

#endif

-- method DOMDocument::query_command_supported
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "command", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_query_command_supported" webkit_dom_document_query_command_supported :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- command : TBasicType TUTF8
    IO CInt

{-# DEPRECATED dOMDocumentQueryCommandSupported ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentQueryCommandSupported ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@command@/: A @/gchar/@ -}
    -> m Bool
    {- ^ __Returns:__ A 'Bool' -}
dOMDocumentQueryCommandSupported self command = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    command' <- textToCString command
    result <- webkit_dom_document_query_command_supported self' command'
    let result' = (/= 0) result
    touchManagedPtr self
    freeMem command'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentQueryCommandSupportedMethodInfo
instance (signature ~ (T.Text -> m Bool), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentQueryCommandSupportedMethodInfo a signature where
    overloadedMethod _ = dOMDocumentQueryCommandSupported

#endif

-- method DOMDocument::query_command_value
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "command", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_query_command_value" webkit_dom_document_query_command_value :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- command : TBasicType TUTF8
    IO CString

{-# DEPRECATED dOMDocumentQueryCommandValue ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentQueryCommandValue ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@command@/: A @/gchar/@ -}
    -> m T.Text
    {- ^ __Returns:__ A @/gchar/@ -}
dOMDocumentQueryCommandValue self command = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    command' <- textToCString command
    result <- webkit_dom_document_query_command_value self' command'
    checkUnexpectedReturnNULL "dOMDocumentQueryCommandValue" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr self
    freeMem command'
    return result'

#if ENABLE_OVERLOADING
data DOMDocumentQueryCommandValueMethodInfo
instance (signature ~ (T.Text -> m T.Text), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentQueryCommandValueMethodInfo a signature where
    overloadedMethod _ = dOMDocumentQueryCommandValue

#endif

-- method DOMDocument::query_selector
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "selectors", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMElement"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_query_selector" webkit_dom_document_query_selector :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- selectors : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMElement.DOMElement)

{-# DEPRECATED dOMDocumentQuerySelector ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentQuerySelector ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@selectors@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMElement.DOMElement
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMElement.DOMElement' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentQuerySelector self selectors = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    selectors' <- textToCString selectors
    onException (do
        result <- propagateGError $ webkit_dom_document_query_selector self' selectors'
        checkUnexpectedReturnNULL "dOMDocumentQuerySelector" result
        result' <- (newObject WebKit2WebExtension.DOMElement.DOMElement) result
        touchManagedPtr self
        freeMem selectors'
        return result'
     ) (do
        freeMem selectors'
     )

#if ENABLE_OVERLOADING
data DOMDocumentQuerySelectorMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMElement.DOMElement), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentQuerySelectorMethodInfo a signature where
    overloadedMethod _ = dOMDocumentQuerySelector

#endif

-- method DOMDocument::query_selector_all
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "selectors", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMNodeList"}))
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_query_selector_all" webkit_dom_document_query_selector_all :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- selectors : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr WebKit2WebExtension.DOMNodeList.DOMNodeList)

{-# DEPRECATED dOMDocumentQuerySelectorAll ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentQuerySelectorAll ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@selectors@/: A @/gchar/@ -}
    -> m WebKit2WebExtension.DOMNodeList.DOMNodeList
    {- ^ __Returns:__ A 'GI.WebKit2WebExtension.Objects.DOMNodeList.DOMNodeList' /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentQuerySelectorAll self selectors = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    selectors' <- textToCString selectors
    onException (do
        result <- propagateGError $ webkit_dom_document_query_selector_all self' selectors'
        checkUnexpectedReturnNULL "dOMDocumentQuerySelectorAll" result
        result' <- (wrapObject WebKit2WebExtension.DOMNodeList.DOMNodeList) result
        touchManagedPtr self
        freeMem selectors'
        return result'
     ) (do
        freeMem selectors'
     )

#if ENABLE_OVERLOADING
data DOMDocumentQuerySelectorAllMethodInfo
instance (signature ~ (T.Text -> m WebKit2WebExtension.DOMNodeList.DOMNodeList), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentQuerySelectorAllMethodInfo a signature where
    overloadedMethod _ = dOMDocumentQuerySelectorAll

#endif

-- method DOMDocument::set_body
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLElement"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMHTMLElement", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_set_body" webkit_dom_document_set_body :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    Ptr WebKit2WebExtension.DOMHTMLElement.DOMHTMLElement -> -- value : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMHTMLElement"})
    Ptr (Ptr GError) ->                     -- error
    IO ()

{-# DEPRECATED dOMDocumentSetBody ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentSetBody ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMHTMLElement.IsDOMHTMLElement b) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> b
    {- ^ /@value@/: A 'GI.WebKit2WebExtension.Objects.DOMHTMLElement.DOMHTMLElement' -}
    -> m ()
    {- ^ /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentSetBody self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- unsafeManagedPtrCastPtr value
    onException (do
        propagateGError $ webkit_dom_document_set_body self' value'
        touchManagedPtr self
        touchManagedPtr value
        return ()
     ) (do
        return ()
     )

#if ENABLE_OVERLOADING
data DOMDocumentSetBodyMethodInfo
instance (signature ~ (b -> m ()), MonadIO m, IsDOMDocument a, WebKit2WebExtension.DOMHTMLElement.IsDOMHTMLElement b) => O.MethodInfo DOMDocumentSetBodyMethodInfo a signature where
    overloadedMethod _ = dOMDocumentSetBody

#endif

-- method DOMDocument::set_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_set_charset" webkit_dom_document_set_charset :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMDocumentSetCharset ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentSetCharset ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m ()
dOMDocumentSetCharset self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- textToCString value
    webkit_dom_document_set_charset self' value'
    touchManagedPtr self
    freeMem value'
    return ()

#if ENABLE_OVERLOADING
data DOMDocumentSetCharsetMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentSetCharsetMethodInfo a signature where
    overloadedMethod _ = dOMDocumentSetCharset

#endif

-- method DOMDocument::set_cookie
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_set_cookie" webkit_dom_document_set_cookie :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- value : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()

{-# DEPRECATED dOMDocumentSetCookie ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentSetCookie ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m ()
    {- ^ /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentSetCookie self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- textToCString value
    onException (do
        propagateGError $ webkit_dom_document_set_cookie self' value'
        touchManagedPtr self
        freeMem value'
        return ()
     ) (do
        freeMem value'
     )

#if ENABLE_OVERLOADING
data DOMDocumentSetCookieMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentSetCookieMethodInfo a signature where
    overloadedMethod _ = dOMDocumentSetCookie

#endif

-- method DOMDocument::set_design_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_set_design_mode" webkit_dom_document_set_design_mode :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMDocumentSetDesignMode ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.14/
-}
dOMDocumentSetDesignMode ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m ()
dOMDocumentSetDesignMode self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- textToCString value
    webkit_dom_document_set_design_mode self' value'
    touchManagedPtr self
    freeMem value'
    return ()

#if ENABLE_OVERLOADING
data DOMDocumentSetDesignModeMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentSetDesignModeMethodInfo a signature where
    overloadedMethod _ = dOMDocumentSetDesignMode

#endif

-- method DOMDocument::set_dir
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_set_dir" webkit_dom_document_set_dir :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMDocumentSetDir ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentSetDir ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m ()
dOMDocumentSetDir self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- textToCString value
    webkit_dom_document_set_dir self' value'
    touchManagedPtr self
    freeMem value'
    return ()

#if ENABLE_OVERLOADING
data DOMDocumentSetDirMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentSetDirMethodInfo a signature where
    overloadedMethod _ = dOMDocumentSetDir

#endif

-- method DOMDocument::set_document_uri
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_set_document_uri" webkit_dom_document_set_document_uri :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMDocumentSetDocumentUri ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentSetDocumentUri ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m ()
dOMDocumentSetDocumentUri self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- textToCString value
    webkit_dom_document_set_document_uri self' value'
    touchManagedPtr self
    freeMem value'
    return ()

#if ENABLE_OVERLOADING
data DOMDocumentSetDocumentUriMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentSetDocumentUriMethodInfo a signature where
    overloadedMethod _ = dOMDocumentSetDocumentUri

#endif

-- method DOMDocument::set_selected_stylesheet_set
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_set_selected_stylesheet_set" webkit_dom_document_set_selected_stylesheet_set :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMDocumentSetSelectedStylesheetSet ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
This function has been removed and does nothing.
-}
dOMDocumentSetSelectedStylesheetSet ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m ()
dOMDocumentSetSelectedStylesheetSet self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- textToCString value
    webkit_dom_document_set_selected_stylesheet_set self' value'
    touchManagedPtr self
    freeMem value'
    return ()

#if ENABLE_OVERLOADING
data DOMDocumentSetSelectedStylesheetSetMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentSetSelectedStylesheetSetMethodInfo a signature where
    overloadedMethod _ = dOMDocumentSetSelectedStylesheetSet

#endif

-- method DOMDocument::set_title
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_set_title" webkit_dom_document_set_title :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMDocumentSetTitle ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentSetTitle ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m ()
dOMDocumentSetTitle self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- textToCString value
    webkit_dom_document_set_title self' value'
    touchManagedPtr self
    freeMem value'
    return ()

#if ENABLE_OVERLOADING
data DOMDocumentSetTitleMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentSetTitleMethodInfo a signature where
    overloadedMethod _ = dOMDocumentSetTitle

#endif

-- method DOMDocument::set_xml_standalone
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gboolean", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_set_xml_standalone" webkit_dom_document_set_xml_standalone :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CInt ->                                 -- value : TBasicType TBoolean
    Ptr (Ptr GError) ->                     -- error
    IO ()

{-# DEPRECATED dOMDocumentSetXmlStandalone ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentSetXmlStandalone ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> Bool
    {- ^ /@value@/: A 'Bool' -}
    -> m ()
    {- ^ /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentSetXmlStandalone self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    let value' = (fromIntegral . fromEnum) value
    onException (do
        propagateGError $ webkit_dom_document_set_xml_standalone self' value'
        touchManagedPtr self
        return ()
     ) (do
        return ()
     )

#if ENABLE_OVERLOADING
data DOMDocumentSetXmlStandaloneMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentSetXmlStandaloneMethodInfo a signature where
    overloadedMethod _ = dOMDocumentSetXmlStandalone

#endif

-- method DOMDocument::set_xml_version
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #gchar", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_document_set_xml_version" webkit_dom_document_set_xml_version :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    CString ->                              -- value : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()

{-# DEPRECATED dOMDocumentSetXmlVersion ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./
-}
dOMDocumentSetXmlVersion ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> T.Text
    {- ^ /@value@/: A @/gchar/@ -}
    -> m ()
    {- ^ /(Can throw 'Data.GI.Base.GError.GError')/ -}
dOMDocumentSetXmlVersion self value = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    value' <- textToCString value
    onException (do
        propagateGError $ webkit_dom_document_set_xml_version self' value'
        touchManagedPtr self
        freeMem value'
        return ()
     ) (do
        freeMem value'
     )

#if ENABLE_OVERLOADING
data DOMDocumentSetXmlVersionMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentSetXmlVersionMethodInfo a signature where
    overloadedMethod _ = dOMDocumentSetXmlVersion

#endif

-- method DOMDocument::webkit_cancel_fullscreen
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_webkit_cancel_fullscreen" webkit_dom_document_webkit_cancel_fullscreen :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO ()

{-# DEPRECATED dOMDocumentWebkitCancelFullscreen ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentWebkitCancelFullscreen ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m ()
dOMDocumentWebkitCancelFullscreen self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    webkit_dom_document_webkit_cancel_fullscreen self'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data DOMDocumentWebkitCancelFullscreenMethodInfo
instance (signature ~ (m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentWebkitCancelFullscreenMethodInfo a signature where
    overloadedMethod _ = dOMDocumentWebkitCancelFullscreen

#endif

-- method DOMDocument::webkit_exit_fullscreen
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "A #WebKitDOMDocument", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_document_webkit_exit_fullscreen" webkit_dom_document_webkit_exit_fullscreen :: 
    Ptr DOMDocument ->                      -- self : TInterface (Name {namespace = "WebKit2WebExtension", name = "DOMDocument"})
    IO ()

{-# DEPRECATED dOMDocumentWebkitExitFullscreen ["(Since version 2.22)","Use JavaScriptCore API instead"] #-}
{- |
/No description available in the introspection data./

/Since: 2.16/
-}
dOMDocumentWebkitExitFullscreen ::
    (B.CallStack.HasCallStack, MonadIO m, IsDOMDocument a) =>
    a
    {- ^ /@self@/: A 'GI.WebKit2WebExtension.Objects.DOMDocument.DOMDocument' -}
    -> m ()
dOMDocumentWebkitExitFullscreen self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    webkit_dom_document_webkit_exit_fullscreen self'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data DOMDocumentWebkitExitFullscreenMethodInfo
instance (signature ~ (m ()), MonadIO m, IsDOMDocument a) => O.MethodInfo DOMDocumentWebkitExitFullscreenMethodInfo a signature where
    overloadedMethod _ = dOMDocumentWebkitExitFullscreen

#endif


